# $Id$
#
# COPYRIGHT ANSYS. ALL RIGHTS RESERVED
#
# These are the rules to define various objects

RULES:

  Categories = deletable, \
        internal,  \
        point, point-only, line, line-only, surface, plane, volume,  \
        constant-colour, annotation, suspendable,   \
        vector-variable, scalar-variable, mesh-variable,  variable, \
        fundamental-variable, user-variable, geometry, viewer-viewable, \
        selectable, edge-based, has-variable, has-variable-colour, \
        has-local-variable, instance-transformation, turbo-object, \
        region, region2d, res-dependent, domain-geometry-dependent, \
        domain-dependent, mesh-density, \
        has-instance-transform, quick-editable, quick-animatable, \
        has-local-legend, reportable, autogenerated, domain, res-surface, \
        preview, colourmap, tbr-plot, time-dependent, pir, res-user-surface

  ParamCategories = Direction, Position, Quaternion, RGBColour, Timestep, String, Other

# Categories
# Categories allow the selection of object types by their potential properties.
# Tools are provided for selecting all objects of types that fall into given categories.
#
# Note that all categories define only the potential contents. An Isosurface
# defined to be outside the range of its variable will have no points or surfaces,
# but is still in category 'surface'.
#
# Explanation of categories:
# deletable - can be created and deleted by the user through CCL
# internal - can be created and deleted only by the system
# point - is a geometry that may contain at least one point
# line  - is a geometry that may contain lines
# surface  - is a geometry that may contain surfaces
# volume - is a geometry that may contain volumes
# constant-colour - can be given a constant colour
# annotation - currently unused
# vector-variable - is a variable with more than one component (e.g. Velocity)
# scalar-variable  - is a variable with one component (e.g. Pressure)
# mesh-variable - currently unused
# variable - is a variable 
# fundamental-variable - is a variable read from the results file or defined by the system
# user-variable - is a variable defined by the user
# geometry - has geometry
# viewer-viewable - is drawn in the viewer
# selectable - should appear in the ObjectSelector in the GUI
# edge-based - may be defined by an edge-based interpolator, like isosurface
# has-variable - can have variables defined on it
# has-variable-colour - can be coloured by a variable
# mesh-density - has interpolants of type Edge or Vertex
# has-instance-transform - contains parameters that define an instance transform
# quick-editable - is allowed to be modified by the Quick Editor
# quick-animatable - is allowed to be animated with the quick animator
# domain-geometry-dependent - object whose geometry is derived from a domain geometry
# res-surface - is a RES-Dependent object with a surface
# res-user-surface - is a RES-Dependent object with a user defined surface

  SchedulerTypes = top, colour, glyph, symbol, variable, expression, \
                   camera, render, delete, instance, edge colour, \
                   text colour, cylindrical, turbo, blade, circ average, \
                   bndValues, ruler, tbrtransform, geometry, fft

  CCLObjectClasses = GenericCCLObject, GeometricCCLObject, \
    SymbolGeometricCCLObject, TurboGeometricCCLObject, \
    TurboLineCCLObject, DomainGeometricCCLObject, \
    BoundaryGeometricCCLObject, RegionGeometricCCLObject, \
    CoordinateFrameCCLObject, OverlayCCLObject, DataCCLObject,\
    UnrestrictedCCLObject, ExpressionsCCLObject, CubeCCLObject,\
    VariableCCLObject, SymbolCCLObject, ExpressionEvaluatorCCLObject, \
    ContourCCLObject, PlaneCCLObject, UnitsCCLObject, \
    PostViewCCLObject, ViewportManagerCCLObject, CameraCCLObject, \
    ExpressionPreviewCCLObject, ChartCCLObject, ChartSeriesCCLObject, \
    ChartLineCCLObject, PostTextCCLObject, \
    PointCloudGeometricCCLObject, TableCCLObject, ObjectTransformCCLObject, \
    ParticleTrackGeometricCCLObject, CommentCCLObject, TitlePageCCLObject, \
    ReportCCLObject, DeformationCCLObject, ColourMapCCLObject, \
    ParameterizationCCLObject, ComparisonCCLObject, IsoClipCCLObject, \
    ExternalFileUserCCLObject, ParticleCloudGeometricCCLObject, \
    ResultsSurfaceGeometricCCLObject, MassFlowCalcOptionCCLObject

# Allowed Actions:
#
# quit
# print [<Print File>]
# export [<Export File>]
# load [<Current Results File>]
# delete <objectName>
# rename <objectName>, <newObjectName>
# copy <objectName>, <newObjectName>
# transform <objectName>, <transformObject1>, [transformObject2], ...
# listobjects [name = (,,)], [type = (,,)], [category = (,,)]
# listtimesteps
# readsession <file>, [update=on|off], [promptmode = prompt | continue | stop]
# readstate <file>
# sessionrecorder (start, <file> | stop)
# undo
# redo
# evaluate <expression name>
# animation (clear | store | play | delete), [animationObject]
# array (delete | create | setentry | getentry | getdim) ....
#   array delete, <arrayname>
#   array create, <arrayname>, (1D | 2D | 3D)
#   array set, <arrayname>, <value>, (by value | by reference), <index1>, [index2], [index3]
#   array get, <arrayname>, <index1>, [index2], [index3]
#   array getdim, <arrayname>
# camera view <cameraObject> - sets the viewer eye position to the location specified
#                              by the named cameraObject
# camera save <cameraObject> - Stores the current viewer camera to the named object

 # -------------- PARAMETERS --------------------

# General geometry Parameters
# PARAMETER: Location
#   Parameter Type = String List
#   Local Type = top
#   Remote Type = top
# END
  PARAMETER: Point
    Parameter Type = Real List
    Local Type = top
    Remote Type = expression
    Default = 0.0, 0.0, 0.0
    Parameter Category = Position
    Description = An XYZ triple which defines a point in space.
  END
  PARAMETER: Nearest Node Number
    Parameter Type = Integer
    Description = Stores index of the mesh node nearest to this point.
  END
  PARAMETER: X
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0
    Description = The X coordinate value for the location of this object.
  END
  PARAMETER: Y
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0
    Description = The Y coordinate value for the location of this object.
  END
  PARAMETER: Z
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0
    Description = The Z coordinate value for the location of this object.
  END

  PARAMETER: Position 1
    Parameter Type = Real
    Default = 0.5
    Local Type = top
    Remote Type = expression
    Description = A real number that represents the first position of the object.
  END

  PARAMETER: Position 2
    Parameter Type = Real
    Default = 0.5
    Local Type = top
    Remote Type = expression
    Description = A real number that represents the second position of the object.
  END

  PARAMETER: Normal
    Parameter Type = Real List
    Local Type = top
    Default = 1.0,0.0,0.0
    Parameter Category = Direction
    Description = An XYZ triple describing the normal vector.
  END
  PARAMETER: Point 1
    Parameter Type = Real List
    Local Type = top
    Remote Type = expression
    Default = 0.0, 0.0, 0.0
    Parameter Category = Position
    Description = An XYZ triple defining the first point for this object.
  END
  PARAMETER: Point 2
    Parameter Type = Real List
    Local Type = top
    Remote Type = expression
    Default = 1.0, 0.0, 0.0
    Parameter Category = Position
    Description = An XYZ triple defining the second point for this object.
  END
  PARAMETER: Point 3
    Parameter Type = Real List
    Local Type = top
    Remote Type = expression
    Default = 0.0, 1.0, 0.0
    Parameter Category = Position
    Description = An XYZ triple defining the third point for this object.
  END
  PARAMETER: Plane Bound
    Allowed String List = None, Circular, Rectangular
    Parameter Type = String
    Local Type = top
    Default = None
    Description = Defines plane bounding (Circular, Rectangular, None).
  END
  PARAMETER: Invert Plane Bound
    Parameter Type = Logical
    Local Type = top
    Default = Off
    Description = Reverses the plane bounds by selecting region outside plane bound.
  END
  PARAMETER: Surface Bound
    Allowed String List = None, Rectangular
    Parameter Type = String
    Local Type = top
    Default = None
    Description = Defines surface bounding (Rectangular, None).
  END
  PARAMETER: Invert Surface Bound
    Parameter Type = Logical
    Local Type = top
    Default = Off
    Description = Reverses the surface bounds by selecting region outside surface bound.
  END

  PARAMETER: Line Bound
    Allowed String List = None, End Points
    Parameter Type = String
    Local Type = top
    Default = None
    Description = Defines line bounding (End Points, None).
  END
  PARAMETER: Invert Line Bound
    Parameter Type = Logical
    Local Type = top
    Default = Off
    Description = Reverses the line bounds by selecting line outside line bound.
  END

  PARAMETER: Bound Radius
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.5 [m]
    Description = Radius of Circular Plane Bound.
  END
  PARAMETER: Direction 1 Bound
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 1.0 [m]
    Description = Length of Rectangular Plane Bound.
  END
  PARAMETER: Direction 2 Bound
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 1.0 [m]
    Description = Width of Rectangular Plane Bound.
  END
  PARAMETER: Direction 1 Orientation
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0 [degree]
    Description = Orientation of Rectangular Plane Bound length.
  END
    PARAMETER: Direction 1 Points
    Parameter Type = Integer
    Local Type = top
    Remote Type = expression
    Default = 10
    Description = Number of Sample points in direction 1.
  END
  PARAMETER: Direction 2 Points
    Parameter Type = Integer
    Local Type = top
    Remote Type = expression
    Default = 10
    Description = Number of Sample points in direction 2.
  END
  PARAMETER: Plane Type
    Parameter Type = String
    Local Type = top
    Allowed String List = Slice, Sample
    Default = Slice
    Description = Indicates if the plane is a slice or sample plane.
  END

  PARAMETER: Line Type
    Parameter Type = String
    Local Type = top
    Allowed String List = Cut, Sample
    Default = Sample
    Description = Indicates if the line is a cut or sample line.
  END
  PARAMETER: Line Samples
    Parameter Type = Integer
    Local Type = top
    Remote Type = expression
    Default = 10
    Description = Number of points in the sample line.
  END
  PARAMETER: Radius
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 1.0 [m]
    Description = Radius distance of a sphere.
  END
  PARAMETER: Local Variable Ranges
    Parameter Type = String List
    Description = A list of Variable Local Range data in base units.  Each element in the \
                list contains: "<Variable Name> : <Hybrid/Conservative> : \
                <Min Value> : <Max Value>"
  END

PARAMETER: Add Local Variable
  Parameter Type = Logical
  Default = On
  Description = Boolean indicating whether to add local variable for a \
                geometry.
END

PARAMETER: Is Local Variable
  Parameter Type = Logical
  Default = Off
  Description = Boolean indicating whether a variable is local to a geometry.
END

PARAMETER: Is Cross Domain Surface
  Parameter Type = Logical
  Default = False
  Description = Internal parameter indicating a cross domain res surface.
END

PARAMETER: Update Variable Global Range
  Parameter Type = Logical
  Default = False
  Description = Internal parameter indicating if we need to update \ 
                global range for local variables on a res surface.
END

PARAMETER: Fourier Coefficient List
  Parameter Type = String List
  Description = Specifies all coefficients for creation of this \
                variable
END

PARAMETER: Instancing Recipe
  Parameter Type = String
  Default = Independent
  Allowed String List = Independent, Shared, Transformed
  Description = Specifies Variable recipe for instanced geometry. \
                Independent - data has to be computed independently \
                using FCs.\
                Shared - data has to be shared with the master\
                geometry. No need for any computaion.\
                Transformed - data can be computed using master geometry \
                data and transformed appropriately.
END

#
# PARAMETER: Parametric Distance
#   Parameter Type = Real
#   Local Type = top
#   Remote Type = expression
#   Default = 0.0
# END
PARAMETER: Coord Frame
  Parameter Type = String
  Local Type = top
  Remote Type = top
  Default = Global
END

  # General Variable parameters
  PARAMETER: Colour Variable
    Parameter Type = String
    Local Type = colour
    Remote Type = top
    Description = The name of the variable to be used in colouring the object.  \
                Should be set equal to the name of a currently defined VARIABLE \
                object.
  END
  PARAMETER: Variable
    Parameter Type = String
    Local Type = top
    Remote Type = top
    Description = The name of the variable used to create the object. \
                Should be set equal to the name of a currently defined VARIABLE \
                object.
  END
  PARAMETER: Variable to Copy
    Parameter Type = String
    Local Type = top
    Description = The name of the variable used to create the object. \
                Should be set equal to the name of a currently defined VARIABLE \
                object.
  END
  PARAMETER: Variable to Gradient
    Parameter Type = String
    Local Type = top
    Remote Type = top
    Description = The name of the scalar variable used to calculate gradient upon.
  END
  PARAMETER: Vector Variable
    Parameter Type = String
    Local Type = top
    Remote Type = top
    Default = Velocity
    Description = The vector variable to be used in creating this plot.
  END
  PARAMETER: User Units
    Parameter Type = String
    Description = Specifies the preferred units to display this variable in \
                if different from the default units setting.  To use the default \
                units, this parameter must be empty (blank).
  END
  PARAMETER: Base Units
    Parameter Type = String
    Description = The base units of a variable.
  END
  PARAMETER: Has Hybrid Values
    Parameter Type = Logical
    Default = Yes
    Description = Internal parameter specifying whether a variable can load \
      Hybrid Values on boundary nodes.
  END
  PARAMETER: Has Face Values
    Parameter Type = Logical
    Default = False
    Description = Internal parameter specifying whether a variable has Face Values
  END
  PARAMETER: Boundary Values
    Parameter Type = String
    Allowed String List = Conservative, Hybrid
    Default = Conservative
    Local Type = bndValues
    Description = Sets the type of boundary values to be presented for this \
                  variable (Conservative or Hybrid).
  END
  PARAMETER: Replaced with Expression
    Parameter Type = Logical
    Default = No
    Description = Indicates whether the variable has been replaced with an \
        expression in the results file.
  END
  PARAMETER: Calculate Global Range
    Parameter Type = Logical
    Default = No
    Local Type = top
    Description = If toggled on, the global range of the user variable will be calculated.
  END
  PARAMETER: Colour Variable Boundary Values
    Parameter Type = String
    Allowed String List = Conservative, Hybrid
    Default = Hybrid
    Local Type = colour
    Description = Sets the type of boundary values to be presented for \
                  colour variables in this object (Conservative or Hybrid).
  END
  PARAMETER: Variable Boundary Values
    Parameter Type = String
    Allowed String List = Conservative, Hybrid
    Default = Hybrid
    Local Type = top
    Description = Sets the type of boundary values to be presented for \
                  variables in this object (Conservative or Hybrid).
  END
  PARAMETER: Colour Scale
    Parameter Type = String
    Allowed String List = Linear, Logarithmic
    Default = Linear
    Local Type = colour
    Description = Sets whether to colour the object with a Linear or Logarithmic \
                scale.  By default, the colour scale is Linear.
  END
  PARAMETER: Boundary Type
    Parameter Type = String
    Description = Internal parameter tells the type of the boundary.
  END
  PARAMETER: Recipe
    Parameter Type = String
    Default = Standard
    Allowed String List = Standard, Vector Component, Expression, Frozen Copy, Difference, \
                          Gradient, Fourier Coefficients
    Description = Contains instructions on how to build a value list for \
                  the variable.
    Local Type = top
  END
  PARAMETER: Component Index
    Parameter Type = String
    Default = 1
    Allowed String List = 1, 2, 3
    Description = Specifies vector component to be used for the variable.
  END
  PARAMETER: User Level
    Parameter Type = String
    Default = 1
    Allowed String List = 1, 2, 3
    Description = Specifies the user level of the variable.
  END
  PARAMETER: Quantity Type
    Parameter Type = String
    Description = Specifies the Quantity Type of the variable.
  END
  PARAMETER: Is Temperature Difference
    Parameter Type = Logical
    Default = false
    Description = Indicates whether the variable is a 'temperature \
                  difference' variable, i.e. the value should not be \
                  converted to absolute units.
  END  
  PARAMETER: Related Object
    Parameter Type = String
    Description = Specifies the Object that this object is related to.
  END
  PARAMETER: Related Variable List
    Parameter Type = String List
    Description = The list of variables that are related to an object.
  END
                             
#Current variable group list - Solution, Solution/Stress, Solution/Strain, ...,
#     User Defined, Turbo, Geometric     
# Null default, value will have to be set properly in the engine
  PARAMETER: Variable Group
    Parameter Type = String
    Description = Specifies the group that this object is belong to for GUI grouping.
  END
  PARAMETER: Can Be Overwritten
    Parameter Type = Logical
    Default = No
    Description = Set to Yes if the solution variable can be overwritten \
        with an expression.
  END
  PARAMETER: Variable Location
    Parameter Type = String List
    Default = Vertex
    Allowed String List = Element, Face, Vertex
    Description = Indicates the location where the variable is written
  END

  # General Glyph parameters

  PARAMETER: Symbol Type
    Parameter Type = String
    Local Type = top
    Default = Line Arrow
    Allowed String List = Arrow2D, Arrow3D, Crosshair, Octahedron, Line Arrow, \
        Arrowhead, Arrowhead3D
    Description = The category a symbol falls under.
  END

  PARAMETER: Direction
  Parameter Type = String
  Local Type = top
#  Allowed String List = X, Y, Z
  Default = X
  Description = The direction specification for vector coord frame projection.
  END

  PARAMETER: Symbol
    Parameter Type = String
    Local Type = symbol
    Default = Line Arrow 
    Allowed String List = Arrow2D, Arrow3D, Ball, Crosshair, Line Arrow, \
        Arrowhead, Arrowhead3D, Fish3D, Octahedron, Cube
    Description = Name of symbol to be used for the vector plot.
  END
  PARAMETER: Point Symbol
    Parameter Type = String
    Local Type = symbol
    Description = Name of point symbol (non-directional) to be used for plot.
  END
  PARAMETER: Stream Symbol
    Parameter Type = String
    Local Type = symbol
    Default = Ball
    Allowed String List = Crosshair, Octahedron, Cube, Ball, Arrow2D, \
                          Arrow3D, Line Arrow, Arrowhead, Arrowhead3D, Fish3D
    Description = Name of streamline symbol to be used for plot.
  END
  PARAMETER: Symbol Size
    Parameter Type = Real
    Local Type = symbol
    Remote Type = expression
    Default = 1.0
    Description = A scaling factor for all symbols in the plot.
  END
  PARAMETER: Symbol Size Mode
    Parameter Type = String
    Local Type = symbol
    Default = Relative
    Allowed String List = Absolute, Relative
    Description = Determines whether the symbol size is defined relative to the \
         problem size or it is an absolute size. 
  END
  PARAMETER: Symbol Size Conversion Factor
    Parameter Type = Real
    Default = 1.0
    Description = A scaling factor for symbol size in Cartesian space.
  END
  PARAMETER: MTS Symbol Size Conversion Factor
    Parameter Type = Real
    Default = 1.0
    Description = A scaling factor for symbol size in MTS transform space.
  END

  #General Colouring and Range Variables
  PARAMETER: Colour Mode
    Parameter Type = String
    Allowed String List = Use Plot Variable, Constant, \
                          Variable, Time, Unique
    Local Type = colour
    Default = Constant
    Description = Sets the mode used to colour the object.  If set equal to \
                "Constant" then the "Colour" parameter is used to determine the \
                plot colour. If set equal to "Variable", then the "Colour Variable" \
                parameter is used.
  END
  PARAMETER: Colour
    Parameter Type = Real List
    Local Type = colour
    Default = 0.75, 0.75, 0.75
    Parameter Category = RGBColour
    Description = A list of three numbers between 0 and 1, which represent the \
                RGB (Red/Green/Blue) values to be used when colouring the faces \
                of an object by constant colour.
  END
  PARAMETER: Line Colour Mode
   Local Type = colour
   Allowed String List = Default, User Specified
   Default = Default
   Description = Determines where to get the line colour from.
  END

  PARAMETER: Range
    Parameter Type = String
    Allowed String List = Global, Local, User Specified
    Local Type = colour
    Default = Global
    Description = Sets the method used to calculate the extents of the colour \
                map on an object.  "Global" uses the range of values in the \
                problem domain. "Local" uses the range of values on the current \
                object.
  END
  PARAMETER: Min
    Parameter Type = Real
    Local Type = colour
    Remote Type = expression
    Description = The minimum value of a variable in the colour map when using a \
                "User Specified" range.

  END
  PARAMETER: Max
    Parameter Type = Real
    Local Type = colour
    Remote Type = expression
    Description = The maximum value of a variable in the colour map when using a \
                "User Specified" range.
  END
  PARAMETER: Colour Map
    Parameter Type = String
    Default = Default Colour Map
    Local Type = colour
    Remote Type = top
    Description = The name of the colour map to use when colouring the object.
  END

  # Rendering Parameters
  PARAMETER: Visibility
    Parameter Type = Logical
    Default = true
    Description = Toggles the visibility of this graphics object in the viewer. \
        THIS PARAMETER IS DEPRECATED!
  END
  PARAMETER: Transparency
    Parameter Type = Real
    Default = 0.0
    Local Type = render
    Remote Type = expression
    Description = Set between 0.0 (fully opaque) and 1.0 (fully transparent) \
                to control the transparency of this graphics object in the viewer.
  END
  PARAMETER: Draw Faces
    Parameter Type = Logical
    Default = On
    Local Type = render
    Description = Toggles the visibility filled faces for this graphics object\
                in the viewer.
  END
  PARAMETER: Surface Drawing
    Parameter Type = String
    Allowed String List = Flat Shading, Smooth Shading, Draw As Lines, \
        Draw As Points
    Default = Smooth Shading
    Local Type = render
    Description = Sets the algorithm used to shade the faces for this graphics object.
  END
  PARAMETER: Lighting
    Parameter Type = Logical
    Default = true
    Local Type = render
    Description = Toggles the lighting of this graphics object in the viewer.
  END
  PARAMETER: Specular Lighting
    Parameter Type = Logical
    Default = On
    Local Type = render
    Description = Toggles the specular lighting of this object in the viewer.
  END
  PARAMETER: Culling Mode
    Parameter Type = String
    Allowed String List = No Culling, Back Faces, Front Faces
    Default = No Culling
    Local Type = render
    Description = Controls the face culling of this object in the viewer.
  END
  PARAMETER: Draw Lines
    Parameter Type = Logical
    Default = Off
    Local Type = render
    Description = Toggles the visibility of lines around each face of this \
                graphics object.
  END
  PARAMETER: Line Width
    Parameter Type = Integer
    Default = 1
    Local Type = render
    Description = Controls the width (in pixels) of lines drawn for this \
                graphics object.
  END
  PARAMETER: Iso Line Width
    Parameter Type = Integer
    Default = 2
    Local Type = render
    Description = Controls the width (in pixels) of the curves drawn for this \
                graphics object.
  END
  PARAMETER: Line Colour
    Parameter Type = Real List
    Default = 0, 0, 0
    Local Type = colour
    Parameter Category = RGBColour
    Description = A list of three numbers between 0 and 1, which represent the \
                RGB (Red/Green/Blue) values to be used for colouring the lines \
                on a graphics object.
  END
  PARAMETER: Instancing Transform
    Parameter Type = String
    Local Type = colour
    Remote Type = instance
    Default = Default Transform
    Description = Defines the TRANSFORM object that is used for the object \
         instancing.
  END
  PARAMETER: Apply Instancing Transform
    Parameter Type = Logical
    Local Type = colour
    Default = On
    Description = Toggles the instancing transformation for this graphics \
        object in the viewer.
  END

  # Texture parameters

  PARAMETER: Apply Texture
    Parameter Type = Logical
    Local Type = colour
    Default = Off
    Description = Toggles display of the texture.
  END
  PARAMETER: Texture Type
    Parameter Type = String
    Allowed String List = Predefined, Custom
    Default = Predefined
    Local Type = colour
    Description = The type of texture to use.
  END
  PARAMETER: Texture File
    Parameter Type = String
    Local Type = colour
    Description = The texture file to display on the object.
  END
  PARAMETER: Texture Material
    Parameter Type = String
    Allowed String List = Metal, White Metal, Brushed Metal, Blue Metal, Red Metal, Chrome, Gold, Rough Wall, Brick
    Default = Metal
    Local Type = colour
    Description = The material to use for texture.
  END
  PARAMETER: Texture Direction
    Parameter Type = Real List
    Local Type = colour
    Default = 0.0, 1.0, 0.0
    Parameter Category = Direction
    Description = The direction of texture projection to the object.
  END
  PARAMETER: Texture Scale
    Parameter Type = Real
    Default = 1.0
    Local Type = colour
    Description = The texture scale.
  END
  PARAMETER: Texture Position
    Parameter Type = Real List
    Default = 0.0, 0.0
    Local Type = colour
    Description = X-Y position of the texture.
  END
  PARAMETER: Texture Angle
    Parameter Type = Real
    Default = 0
    Local Type = colour
    Description = The texture angle in degrees.
  END
  PARAMETER: Tile Texture
    Parameter Type = Logical
    Local Type = colour
    Default = Off
    Description = Toggles tiling of the texture.
  END
  PARAMETER: Blend Texture
    Parameter Type = Logical
    Local Type = colour
    Default = On
    Description = Toggles blending of the texture.
  END
  PARAMETER: Transform Texture
    Parameter Type = Logical
    Local Type = colour
    Default = Off
    Description = Toggles transforming (spherical) of the texture.
  END

  #General Object Parameters

  #HARDCOPY
  PARAMETER: Hardcopy Format
    Parameter Type = String
    Default = png
    Allowed String List = ps, eps, jpg, ppm, bmp, png, vrml, cvf, avz, gltf
    Description = Sets the format of hardcopy output from "print".
  END
  PARAMETER: Hardcopy Filename
    Parameter Type = String
    Description = Sets the file name for the output from "print".
  END
  PARAMETER: Paper Size
   Parameter Type = String
   Allowed String List = Letter, A4
   Default = Letter
   Description = Scales hardcopy output to the specified paper size.
  END
 PARAMETER: Print Quality
   Parameter Type = String
   Allowed String List = Draft, Medium, High
   Default = High
   Description = Controls quality vs. speed of hardcopy output.
 END
 PARAMETER: JPEG Image Quality
   Parameter Type = Integer
   Default = 80
   Description = The quality factor for jpeg image output.  Higher values results \
               in clearer, but larger, files.
 END
 PARAMETER: Paper Orientation
   Parameter Type = String
   Allowed String List = Landscape, Portrait
   Default = Landscape
   Description = Sets the rotation of the image on the printed page.
 END
 PARAMETER: Hardcopy Tolerance
   Parameter Type = String
   Default = 0.0001
   Description = A non-dimensional tolerance used in face-sorting when generating \
               hardcopy output.  Higher values will result in faster printing times, \
               but may cause defects in the resulting output.
 END
 PARAMETER: Print Line Width
   Parameter Type = Integer
   Default = 1
   Description = The width of lines in hardcopy output.  Increasing this value \
                 may give better results on high-resolution printers.
 END
 PARAMETER: White Background
   Parameter Type = Logical
   Default = Off
   Description = Toggles if hardcopy output is produced on a white or black background.
 END
 PARAMETER: Image Scale
   Parameter Type = Integer
   Default = 100
   Description = Scales the size of bitmap images to a fraction (in percent) of \
               the current viewer window size.
 END
 PARAMETER: Use Screen Size
   Parameter Type = Logical
   Default = On
   Description = When set to On, the current screen size is used as the image size
 END 
 PARAMETER: Image Width
   Parameter Type = Integer
   Default = 600
   Description = The image width (used when Use Screen Size is set to Off)
 END
 PARAMETER: Image Height
   Parameter Type = Integer
   Default = 600
   Description = The image height (used when Use Screen Size is set to Off)
 END

 PARAMETER: Screen Capture
   Parameter Type = Logical
   Default = Off
   Description = Enables the screen capture mode for producing image output.
 END

 PARAMETER: Antialiasing
   Parameter Type = Logical
   Default = On
   Description = Enables the antialiasing of the graphics (smooth edges).
 END

 # EXPORT
 
PARAMETER: External Export Data
  Parameter Type = String List
  Default = None
  Allowed String List = None, Temperature, Heat Flow, HTC and Wall Adjacent Temperature
  Description = The list of data items to export to External Data format
END

PARAMETER: Heat Flow Sign Flipping
  Parameter Type = String
  Default = Automatic
  Allowed String List = Automatic, On, Off
  Description = ...
END

 PARAMETER: Additional Variable List
   Parameter Type = String List
   Description = List of variables to be exported to External Data.
 END
 
PARAMETER: Export File
   Parameter Type = String
   Default = export
   Description = The filename to which the exported data will be written.
END
PARAMETER: Export Type
  Parameter Type = String
  Allowed String List = Generic, ANSYS, BC Profile, Case Summary, \
    External Data, Geometry Only, STL
                        
  Default = Generic
  Description = Sets the rotation of the image on the printed page.
END

PARAMETER: Export Units System
  Parameter Type = String
  Default = Current
  Description = Sets the Units System to convert all exported data to. \
                By default the value is 'Preferred' which will use the users \
                currently selected Preferred Units setting.
END

PARAMETER: Export Variable Type
  Parameter Type = String
  Default = Current
  Allowed String List = Current, Conservative, Hybrid
  Description = Specifies what variable data to export.  If 'Current' is selected, \
                the varType for each variable is used.  If Hybrid or Conservative \
                is selected, then all variable have their Hybrid or Conservative \
                values exported.
END

PARAMETER: Case Summary Format
  Parameter Type = String
  Allowed String List = XML
  Default = XML
  Description = Sets the Export format for the Case Summary export.
END

PARAMETER: Case Summary Type
  Parameter Type = String
  Allowed String List = ANSYS FSI
  Default = ANSYS FSI
  Description = Sets the export type for the Case Summary export.
END

PARAMETER: Export Location Aliases
  Parameter Type = String
  Description = Allows the user to specify a list of names which will \
                be assigned to each respective locator as the data is \
                exported.  If insufficient names are given, or if this \
                parameter is blank, the locator name will be used for \
                each locator that has no alias.
END

PARAMETER: Export Chart Name
  Parameter Type = String
  Description = Sets the name of the chart to export the data for.  This parameter\
                will be used if the >export command is sent with 'chart' as a parameter.
END

PARAMETER: ANSYS Export Data
  Parameter Type = String
  Default = Element Heat Flux
  Allowed String List = Element Pressure, Element Shear, Element Stress, \
                        Element Convection, Element Heat Flux, Node Temperature
  Description = The list of data items to export.
END

PARAMETER: ANSYS Specify Reference Temperature
  Parameter Type = Logical
  Default = false
  Description = Indicates whether the user wishes to specify the Reference \
                Temperature (Tref) when exporting Element Convection.
END

PARAMETER: ANSYS Reference Temperature
  Parameter Type = Real
  Description = Specifies the Reference Temperature to use when the \
                ANSYS Specify Reference Temperature parameter is set to true \
                when exporting Element Convection.
END
PARAMETER: ANSYS Supplemental HTC
  Parameter Type = Real
  Description = Supplemental HTC will replace any negative convection \
                coefficient at the nodes where the choice of bulk \
                temperature is not physical.
END

PARAMETER: ANSYS Export Locator
  Parameter Type = String
  Description = The locator to export the data on.
END

PARAMETER: ANSYS Fluid Selection
  Parameter Type = String
  Default = All Fluids
  Description = Specifies the fluid from which to obtain Wall Shear data \
                if applicable.  If "All Fluids" is selected, then the Wall \
                Shear for all the fluids are summed.
END

PARAMETER: CFX Timestep List
  Parameter Type = String List
  Description = Specifies the list of timesteps to export the specified CFX \
                export data for.
END

PARAMETER: ANSYS Timestep List
  Parameter Type = String List
  Description = Specifies the list of timesteps to export the specified ANSYS \
                export data for.
END

PARAMETER: ANSYS Export Units
  Parameter Type = String
  Description = Specifies the units to which the exported data should be converted to.
END

PARAMETER: ANSYS File Format
  Parameter Type = String
  Allowed String List = Simulation, ANSYS
  Default = ANSYS
  Description = Specifies the file format to write the FSI data in.  The options are \
                'Simulation', which is used by Simulation, often when running under WB; \
                and 'ANSYS' which is used when writing files used by ANSYS Classic.
END

PARAMETER: BC Profile Type
  Parameter Type = String
  Allowed String List = Inlet Velocity, Inlet Total Pressure, Inlet Direction, \
                        Inlet Supersonic, Outlet Pressure, Wall, Custom
  Default = Inlet Velocity
  Description = The type of BC Profile to export.
END

PARAMETER: Spatial Variables
  Parameter Type = String List
  Default = X,Y,Z
  Description = The list of Spatial variables to export.
END

PARAMETER: Export Coord Frame
  Parameter Type = String
  Default = Global
  Description = The Coordinate Frame relative to which all data will be exported.
END

PARAMETER: Export Geometry
  Parameter Type = Logical
  Default = true
  Description = Boolean indicating whether or not the locator geometry (i.e. X, Y & Z)\
                should be exported.
END

PARAMETER: Export Geometry Location
   Parameter Type = String List
   Local Type = top
   Remote Type = geometry
   Description = A comma delimited list of locator names.
END

PARAMETER: Export Connectivity
  Parameter Type = Logical
  Default = false
  Description = Boolean indicating whether or not to export the locator connectivity \
                along with the geometry.  This will only be allowed if the geometry\
                is also exported.
END

PARAMETER: Export Node Numbers
  Parameter Type = Logical
  Default = false
  Description = Boolean indicating whether to export the node number along with the\
                geometry.
END

PARAMETER: Variable List
   Parameter Type = String List
   Description = A comma delimited list of variables whose data is to be exported.
END

# PARAMETER: Export Format
#    Parameter Type = String
#    Default = f8.3
#    Description = The format that the output data is to be in.
# END

PARAMETER: Export Null Data
   Parameter Type = Logical
   Default = True
   Description = Indicates whether to export points at which a variable is \
                not defined.
END

PARAMETER: Null Token
   Parameter Type = String
   Default = null
   Description = The string that should be used in the export file if no data \
                  exists for a variable at a node.
END

PARAMETER: Location List
   Parameter Type = String List
   Local Type = top
   Remote Type = geometry
   Description = A comma delimited list of locator names.
END

PARAMETER: Location
   Parameter Type = String
   Local Type = top
   Remote Type = geometry
   Description = A locator name.
END

PARAMETER: Overwrite
   Parameter Type = Logical
   Default = True
   Description = Indicates whether, if the specified filename exists, the file should \
                  be overwritten with the new data.
END

PARAMETER: Precision
    Parameter Type = Integer
    Default = 8
    Description = Indicates the number of decimal points of precision to display the \
                   exported data to.
END

PARAMETER: Vector Display
   Parameter Type = String
   Default = Scalar
   Allowed String List = Components, Scalar
   Description = Indicates the way that vector variables are to be displayed. \
                  Choices are: Components | Scalar.
END

PARAMETER: Vector Brackets
   Parameter Type = String
   Default = ()
   Description = Indicates the kind of brackets to use around vector data when displayed \
                 as components. Any two character combination is valid, where the first \
                 character will be used as the open-bracket, and the second as the \
                 close-bracket. If "-" is specified (no quotes), no brackets will be \
                 displayed.
END

PARAMETER: Separator
  Parameter Type = String
  Default = ", "
  Description = Indicates the string to use between each variable.  The string must \
                be delimited by quotation marks.
END

PARAMETER: Include Header
  Parameter Type = Logical
  Default = true
  Description = Indicates whether to include header information in the exported \
        file, or just output the data.
END

PARAMETER: Split Cut Lines
  Parameter Type = Logical
  Default = true
  Description = Indicates whether to split cut lines along connectivity boundaries, \
  or just leave all points connected.
END

PARAMETER: Include File Information
  Parameter Type = Logical
  Default = false
  Description = Indicates whether to include file information including file name \
                version of Post, and date of export.
END

  # Variables
  PARAMETER: VarMin
    Parameter Type = Real
    Description = The global minimum value from this variable as read from the result file.
  END
  PARAMETER: VarMax
    Parameter Type = Real
    Description = The global maximum value from this variable as read from the result file.
  END
  PARAMETER: HybridMin
    Parameter Type = Real
    Description = The global hybrid minimum value from this variable as read from the result file.
  END
  PARAMETER: HybridMax
    Parameter Type = Real
    Description = The global hybrid maximum value from this variable as read from the result file.
  END
  PARAMETER: FaceVarMin
    Parameter Type = Real
    Description = The global minimum value at Face-centers from this variable as read from the result file.
  END
  PARAMETER: FaceVarMax
    Parameter Type = Real
    Description = The global maximum value at Face-centers from this variable as read from the result file.
  END
  PARAMETER: Boundary Only
    Parameter Type = Logical
    Default = false
    Description = Parameter indicating whether or not the particular variable has only \
                values on the boundary.
  END
  PARAMETER: Expression
    Parameter Type = String
    Local Type = top
    Remote Type = expression
    Description =  A CFX Expression Language expression.
  END
  PARAMETER: Variable Dimensions
    Parameter Type = Real List
    Default = 0,0,0,0,0,0,0,0,0,0
    Description = The dimensions of the variable as read from the results file.
  END
  PARAMETER: Iso Level Index
    Parameter Type = Real
    Description = Parameter indicating the relative level index between variables' units \
                  within certain variable group.
  END
  PARAMETER: Velocity Names
    Parameter Type = String List
    Local Type = top
    Remote Type = top
    Description = Parameter indicating the corresponding velocity names that a derived \
                  variable will be depended upon.
  END

  PARAMETER: Velocity Names Case Map
    Parameter Type = String
    Description = Parameter indicating the corresponding velocity names vs case names. \
                  These are used when the same variable can map to \
                  different velocity names for different cases. 

  END

  PARAMETER: Method Name
    Parameter Type = String
    Local Type = top
    Description = Parameter indicating the name of the method associated with the variable.
  END

 PARAMETER: X Expression
   Parameter Type = String
   Local Type = top
   Remote Type = expression
   Description =  A CFX Expression Language expression defining X component of a vector variable
 END
 PARAMETER: Y Expression
   Parameter Type = String
   Local Type = top
   Remote Type = expression
   Description =  A CFX Expression Language expression defining Y component of a vector variable
 END
 PARAMETER: Z Expression
   Parameter Type = String
   Local Type = top
   Remote Type = expression
   Description =  A CFX Expression Language expression defining Z component of a vector variable
 END
 PARAMETER: Solver Name
    Parameter Type = String
    Local Type = top
    Description = The name of this object inside the result file.
 END
 PARAMETER: Internal Name
    Parameter Type = String
    Local Type = top
    Description = The internal name of this object, such as its name in the GTM database 
 END
 PARAMETER: Results File
   Parameter Type = String
   Description = The parent results file for a domain object. 
 END

  # DATA READER
  PARAMETER: Current Case List
    Parameter Type = String List
    Description = The list of cases that are currently loaded in the \
                post-processor. The list order reflects the load order.
  END
  PARAMETER: Current Results File
    Parameter Type = String
    Description = The name of the results file to be read into the post-processor.
  END

  PARAMETER: Current Mesh File
    Parameter Type = String
    Description = The name of the mesh file associated with the current timestep.
  END

  PARAMETER: Current Configuration Name
    Parameter Type = String
    Description = The name of the configuration for the current timestep.
  END

  PARAMETER: Multi Configuration File Load Option
    Allowed String List = Single Case, Separate Cases, Last Case
    Default = Single Case
    Parameter Type = String
    Description = Load option for files that contains multiple configurations.
  END
  
  PARAMETER: Master Results File
    Parameter Type = String
    Description = The name of the results file that is used as the base for \
                synchronization in multiple transient file load.
  END
  PARAMETER: Current Case Name
    Parameter Type = String
    Description = Internal CFD-Post name for the currently analysed problem.
  END
  PARAMETER: Active Case Name
    Parameter Type = String
    Description = Internal CFD-Post name for the currently analysed problem.
  END
  PARAMETER: Deformation Variable
    Parameter Type = String
    Description = The deformation variable currently used in the system.
  END
  PARAMETER: Deformation Scale
    Parameter Type = Real
    Default = 1
    Local Type = render
    Description = The deformation scale currently used in the system.
  END
  PARAMETER: Deformation Auto Scale
    Parameter Type = Real
    Default = 1
    Description = Internal parameter used for GUI deformation scale \
                selections. It is calulated based on problem extends \ 
                (Auto Scale * max true deformation = 6% * problem extends) 
  END

  # the default has to be OFF for backword compatibility
  PARAMETER: Timestep Sync Mode
    Allowed String List = Off, By Time Step, By Time Value, By Index, By Crank Angle
    Parameter Type = String
    Default = By Time Value
    Description = Defines timestep synchronization method for multiple \
                transient files.
  END
  PARAMETER: Timevalue Match Criterion
    Allowed String List = Same Value, Nearest Available, Within 1 %, Within 5 %, Within 10 %
    Parameter Type = String
    Default = Same Value
    Description = Defines real value matching mode for timestep or crank angle \
                  synchronization for multiple transient files.
  END
  PARAMETER: Timestep Match Criterion
    Allowed String List = Same Step, Nearest Available
    Parameter Type = String
    Default = Same Step
    Description = Defines timestep matching mode for timestep \
                  synchronization for multiple transient files.
  END
  PARAMETER: Domains to Load
    Parameter Type = String List
    Description = A list of domains for processing.
  END
  PARAMETER: Available Domains
    Parameter Type = String List
    Description = All available domains contained in this case..
  END
  PARAMETER: Machine Type
    Parameter Type = String
    Description = Turbo machine type, i.e., pump, compressor etc.
  END
  PARAMETER: Flow Type
    Parameter Type = String
    Description = Case flow type, i.e., compressive, incompressive 
  END
  PARAMETER: Previous Timestep
    Parameter Type = Integer
    Default = -1
    Parameter Category = Timestep
    Description = The timestep used for previous transient file load.
  END
  PARAMETER: Current Timestep
    Parameter Type = Integer
    Default = -1
    Parameter Category = Timestep
    Description = The timestep to be used when reading a transient results file.
  END
  PARAMETER: Current Timevalue
    Parameter Type = Real
    Default = 1
    Description = The time value of the currently loaded results file. \
        To change current timestep, use Current Timestep parameter.
  END
  PARAMETER: Additional Timestep Files
    Parameter Type = String List
    Description = A list of files representing additional timesteps.
  END
  PARAMETER: Workbench ID
    Parameter Type = String
    Description = A numerical ID used to uniquely identify cases loaded via \
                  Workbench.
  END
  PARAMETER: Force File Reload
    Parameter Type = Logical
    Default = false
    Description = Parameter indicating whether or not to force a reload of the file \
                even if the filename is the same as that currently loaded.
  END
  PARAMETER: Create Additional Turbo Variables
    Parameter Type = Logical
    Default = false
    Description = A domain parameter indicating if additional turbo variables \
                  have been requested by the user.
  END

  PARAMETER: Create Blade Aligned Variable
    Parameter Type = Logical
    Default = false
    Description = A domain parameter indicating if Nonlinear version of \
                Blade Aligned Streamwise Location variable is requested.
  END
                             
  PARAMETER: Blade Aligned Variable Available
    Parameter Type = Logical
    Default = false
    Description = A domain parameter indicating if Nonlinear version of \
                Blade Aligned Streamwise Location variable is created properly.
  END

  PARAMETER: Linear Blade Aligned Variable Available
    Parameter Type = Logical
    Default = false
    Description = A domain parameter indicating if linear version of \
                Blade Aligned Streamwise Location variable is created properly.
  END
                             
                             
  PARAMETER: Clear All Objects
    Parameter Type = Logical
    Default = false
    Description = Parameter indicating whether or not to remove all objects in the \
                system before loading the new res file.
  END
  PARAMETER: Append Results
    Parameter Type = Logical
    Default = false
    Description = Parameter indicating whether or not to append the results \
                when loading a file.
  END
  PARAMETER: Apply X Offset
    Parameter Type = Logical
    Default = false
    Description = If set to true, appended file is offset in X direction \
        so that it is outside domain extents.
  END
  PARAMETER: Apply Y Offset
    Parameter Type = Logical
    Default = false
    Description = If set to true, appended file is offset in Y direction \
        so that it is outside domain extents.
  END
  PARAMETER: Apply Z Offset
    Parameter Type = Logical
    Default = false
    Description = If set to true, appended file is offset in Z direction \
        so that it is outside domain extents.
  END
  PARAMETER: Open in New View
    Parameter Type = Logical
    Default = true
    Description = If set to true, view based filtering is used to open each \
       results file in a separate view
  END
  PARAMETER: Edit Case Names
    Parameter Type = Logical
    Default = false
    Description = Parameter to save the users choice for the load dialog option on \
                  whether the user wants to specify and edit the case name instead of \
                  using the default case name generated by post.
  END
  PARAMETER: Open to Compare
    Parameter Type = Logical
    Default = false
    Description = If set to true, comparison mode will be entered after opening file
  END

  PARAMETER: Files to Compare
    Parameter Type = String List
    Description = List of files (no more than 2) to use in comparison mode.
  END

  PARAMETER: Keep Camera Position
    Parameter Type = Logical
    Default = true
    Description = Parameter indicating whether or not to reset the camera position after \
                loading the new res file.
  END
  PARAMETER: Load Particle Tracks
    Parameter Type = Logical
    Default = true
    Description = Parameter indicating whether to load the Particle tracks from a result file or not.
  END
  PARAMETER: Construct Variables From Fourier Coefficients
    Parameter Type = Logical
    Default = True
    Description = Parameter to indicate if variables should be \
                  constructed using Fourier Coefficients.
  END
  PARAMETER: File Length Units
    Parameter Type = String
    Default = m
    Description = Length units read from the file. 
  END
  PARAMETER: File Mass Units
    Parameter Type = String
    Default = kg
    Description = Mass units read from the file. 
  END
  PARAMETER: File Time Units
    Parameter Type = String
    Default = s
    Description = Time units read from the file. 
  END
  PARAMETER: File Temperature Units
    Parameter Type = String
    Default = K
    Description = Temperature units read from the file. 
  END
  PARAMETER: File Angle Units
    Parameter Type = String
    Default = rad
    Description = Angle units read from the file. 
  END
  PARAMETER: File Solid Angle Units
    Parameter Type = String
    Default = sr
    Description = Solid Angle units read from the file. 
  END
  PARAMETER: File Chemical Amount Units
    Parameter Type = String
    Default = mol
    Description = Chemical Amount units read from the file. 
  END
  PARAMETER: File Current Units
    Parameter Type = String
    Default = A
    Description = Current units read from the file. 
  END
  PARAMETER: File Light Units
    Parameter Type = String
    Default = cd
    Description = Light units read from the file. 
  END
  PARAMETER: File Money Units
    Parameter Type = String
    Default = GBP
    Description = Money units read from the file. 
  END
  PARAMETER: Current File Type
    Allowed String List = CFX5, CFX4, TASCflow, CGNS, ANSYS, FLUENT, FieldView, FidapNeut, Forte, FENSAP
    Parameter Type = String
    Description = The type of the results file to be read into the post-processor. \
                  This is an internal parameter.
  END
  PARAMETER: Current Results File Version
    Parameter Type = Integer
    Description = The version of the current results file.
  END
  PARAMETER: Particle Track Material List
    Parameter Type = String List
    Description = A list of Particle Track Materials that exist in the result file. \
                This parameter is empty if no Particle Tracks exist.
  END
  PARAMETER: Expression List
    Parameter Type = String List
    Description = A list of Expressions that were loaded with the res file. \
                These expressions must be deleted when a new result file is loaded.
  END
  PARAMETER: Timestep List
    Parameter Type = String List
    Description = A list of all the timesteps that exist for the loaded file.
  END

#  PARAMETER: Load Domains
#    Parameter Type = String List
#    Description = A list of domains to be read from the current results file. Not yet implemented.
#  END
#  PARAMETER: Variable List
#    Parameter Type = String List
#    Description = A list of variable names to be immediately loaded from the results file.\
#                All other variables are automatically loaded when they are needed. Not yet implemented.
#  END

#ANIMATION
PARAMETER: Animation Name
  Parameter Type = String
  Description = The name of this animation.
END
PARAMETER: Animation Filename
  Parameter Type = String
  Description = The name of the file to save this animation to.
END
PARAMETER: Keyframe List
  Parameter Type = String List
  Description = An ordered list of keyframe names to be used for this \
                animation.
END
PARAMETER: Looping
  Parameter Type = String
  Default = Loop
  Allowed String List = Bounce, Loop
  Description = Indicates the type of looping to perform for the animation.
END
PARAMETER: Looping Cycles
  Parameter Type = Integer
  Default = 1
  Description = Indicates the number of cycles that the Animation loop \
                should complete before stopping automatically. A value \
                of -1 will repeat the cycles forever.
END
PARAMETER: Timestep Interpolation Method
  Parameter Type = String
  Default = Timestep
  Allowed String List = Timestep, TimeValue, Sequential
  Description = Indicates what timestep information to interpolate \
                if timesteps are to be animated.
END
PARAMETER: Playback Status
  Parameter Type = String
  Default = Stopped
  Allowed String List = Stopped, Forward, Backward, Paused
  Description = This parameter indicates whether the animation is stopped \
                or playing forward or backward. This is an internal \
                parameter for status display purposes only.
END
PARAMETER: Current Frame
  Parameter Type = Integer
  Default = 1
  Description = The current frame that is displayed or calculated. \
                This is useful to determine where in the animation \
                you are when stepping through the frames. This \
                is an internal parameter for status display purposes \
                only.
END
PARAMETER: Animate Camera
  Parameter Type = Logical
  Default = On
  Description = Indicates whether to animate the camera (flythrough)\
                along with the other objects, or leave the camera \
                at the current position.
END
PARAMETER: Save Hardcopy
  Parameter Type = Logical
  Default = Off
  Description = Boolean indicating whether to save the current animation \
                to a file, as it progresses. A filename needs to be \
                specified.
END
PARAMETER: Animation Quality
  Parameter Type = String
  Allowed String List = Highest, High, Medium, Low, Custom
  Default = Medium
  Description = Modifies the Frame Pattern to one of three predefined values \
                providing a variety of quality settings.  If 'Custom' is selected, \
                then users may enter their own pattern via the 'Animation Frame \
                Pattern' parameter.
END
PARAMETER: Animation Frame Pattern
  Parameter Type = String
  Default = IBBPBB
  Description = The MPEG frame type pattern.  This must be a list of B, P and I characters. \
        If any of the characters are not B, P or I, then the default value will be used. \
        I ("intra-frame") encoded frames are complete frames (i.e. contain all the data to \
        completely render themselves). P ("predicted") encoded frames use data from previous \
        frames to render themselves.  B ("bi-directional") frames use data from previous and \
        following frames to render themselves.
END
PARAMETER: Drop Last MPEG Frame
  Parameter Type = Logical
  Default = false
  Description = When creating looping animations, it may be desireable to drop the last frame \
                in the animation from the generated MPEG since it may be the same as the first \
                frame, and that would not create a smooth looping animation.
END

PARAMETER: Animation Hardcopy Filename
  Parameter Type = String
  Description = The path of the file to save a hardcopy to.
END

PARAMETER: Video Format
  Parameter Type = String
  Description = The video format to encode the animation in.
END

PARAMETER: Variable Bit Rate
  Parameter Type = Logical
  Default = On
  Description = Boolean indicating whether to apply the specified Bit Rate.  If this \
        parameter is 'false', then a specified Bit Rate will not be sent to the encoder \
        which will then use a variable bit rate.
END
PARAMETER: Animation Bit Rate
  Parameter Type = Integer
  Default = 5152000
  Description = The number of Bits per Second maximum rate.
END
PARAMETER: Intermediate File Format
  Parameter Type = String
  Default = jpg
  Allowed String List = jpg, ppm
  Description = The format in which to save intermediate files when generating \
                animation MPEGs.
END
PARAMETER: Keep Intermediate Files
  Parameter Type = Logical
  Default = Off
  Description = Boolean indicating whether or not CFD-Post should delete the \
                intermediate files after the MPEG generation is complete.
END
PARAMETER: Output to User Directory
  Parameter Type = Logical
  Default = Off
  Description = If set, the frame image files will be output to the directory \
                specified in 'Output Directory' parameter. Otherwise, they will \
                saved to TEMP directory.
END
PARAMETER: Output Directory
  Parameter Type = String
  Default = .
  Description = Animation frame images will be saved to this directory if \
                'Output to User Directory' parameter is set.
END
PARAMETER: Local Output Directory
  Parameter Type = String
  Description = Animation frame images will be saved to this directory if \
                'Output to User Directory' parameter is set. This is the \
                local (GUI) directory in remote server mode. 'Output \
                Directory' contains the remote (engine) directory.
END

PARAMETER: Animation Frame Rate
  Parameter Type = String
  Default = 24
  Allowed String List = 23.976, 24, 25, 29.97, 30, 50, 59.94, 60
  Description = The Frame Rate at which to generate the Animation MPEG.
END
PARAMETER: Use Screen MPEG Size
  Parameter Type = Logical
  Default = Off
  Description = DEPRECATED \
                When set to On, the current screen size is used as the MPEG size
END
PARAMETER: MPEG Size
  Parameter Type = String
  Allowed String List = Use Screen Size, 320 x 240, 640 x 480, 720 x 480, 720 x 576, 720p, 1080p, Custom
  Default = 640 x 480
  Description = Selects which size to create the MPEG.
END
PARAMETER: MPEG Scale
  Parameter Type = Integer
  Default = 100
  Description = The amount to scale the viewer image for the Animation MPEG output.
END
PARAMETER: MPEG Width
  Parameter Type = Integer
  Default = 640
  Description = The image width (used when MPEG Size is set to Use Screen Size)
END
PARAMETER: MPEG Height
  Parameter Type = Integer
  Default = 480
  Description = The image height (used when MPEG Size is set to Use Screen Size)
END
PARAMETER: Frame Increment
  Parameter Type = Integer
  Default = 1
  Description = DEPRECATED \
                The number of frames to increment the frame counter by \
                when incrementing to go to the next frame.
END
PARAMETER: Speed Adjustment Selection
  Parameter Type = String
  Allowed String List = Normal, Slower, Faster
  Default = Normal
  Description = Indicates how to interpret the Animation Speed Factor.
END
PARAMETER: Animation Speed Factor
  Parameter Type = Real
  Default = 2.0
  Description = Specifies the amount of scaling that should apply to the \
                speed of the animation.  Whether the speed is reduced or \
                increased depends on the Speed Adjustment Selection \
                parameter.
END
PARAMETER: Speed Scaling Method
  Parameter Type = String
  Allowed String List = Pad or Clip MPEG Frames, Distribute Frames Smoothly
  Default = Distribute Frames Smoothly
  Description = The 'Pad or Clip MPEG Frames' option only applies the scaling to the \
                generated MPEG frames, reducing the number of frames or reusing \
                some of the frames to generate the MPEG animation.  For this \
                option, no visible changes will occur in Post as you run through \
                the animation.  The 'Distribute Frames Smoothly' option will scale the \
                number of frames that exist between keyframes by the given factor. \
                As the animation plays, you will see more or fewer frames in the \
                animation.  The scaling will occur whether or not an MPEG will be \
                generated.
END
PARAMETER: QAnim Object List
  Parameter Type = String List
  Description = The list of named objects to Quick Animate.
END
PARAMETER: QAnim Frames
  Parameter Type = Integer
  Default = 20
  Description = The number of frames per Quick Animation loop.
END
PARAMETER: QAnim Looping
  Parameter Type = String
  Default = Bounce
  Allowed String List = Bounce, Loop
  Description = Indicates the type of looping to perform for the quick animation.
END
PARAMETER: QAnim Looping Cycles
  Parameter Type = Integer
  Default = -1
  Description = Indicates the number of cycles that the quick animation loop \
                should complete before stopping automatically. A value \
                of -1 will repeat the cycles forever.
END
PARAMETER: QAnim Save MPEG
  Parameter Type = Logical
  Default = Off
  Description = Indicates whether to create an MPEG file out of the Quick Animation.
END
PARAMETER: QAnim MPEG Filename
  Parameter Type = String
  Description = The filename of the Quick Animation MPEG to create.
END
PARAMETER: QAnim Symbol Spacing
  Parameter Type = Real
  Default = 0.6
  Description = The proportional spacing to provide
END
PARAMETER: QAnim Override Symbol
  Parameter Type = Logical
  Default = On
  Description = Indicates whether to override the object Symbol settings when animating \
        Streamlines or Particle Tracks.
END
PARAMETER: QAnim Symbol Size
  Parameter Type = Real
  Default = 1.0
  Description = A scaling factor for the Streamline or Particle Track Symbol size.
END
PARAMETER: QAnim Symbol Type
  Parameter Type = String
  Default = Ball
  Allowed String List = Crosshair, Octahedron, Cube, Ball, Arrow2D, \
          Arrow3D, Line Arrow, Arrowhead, Arrowhead3D, Fish3D
  Description = Name of streamline symbol to be used for plot.
END

# Timestep Animation parameters
PARAMETER: TimeAnim Looping Cycles
  Parameter Type = Integer
  Default = 1
  Description = Indicates the number of cycles that the Timestep Animation loop \
                should complete before stopping automatically. A value \
                of -1 will repeat the cycles forever.
END
PARAMETER: TimeAnim Save MPEG
  Parameter Type = Logical
  Default = Off
  Description = Indicates whether to create an MPEG file out of the Timestep Animation.
END
PARAMETER: TimeAnim MPEG Filename
  Parameter Type = String
  Description = The filename of the Timestep Animation MPEG to create.
END
PARAMETER: TimeAnim Control Case
  Parameter Type = String
  Description = Case used to control the timestep animation available timesteps
END
PARAMETER: TimeAnim Control Variable
  Parameter Type = String
  Allowed Values List = Timestep, Time, Crank Angle
  Description = Variable used to control timestep selection for animation
END
PARAMETER: TimeAnim Specify Range
  Parameter Type = Logical
  Default = Off
END
PARAMETER: TimeAnim Start Timestep
  Parameter Type = Integer
  Default = 0
END
PARAMETER: TimeAnim End Timestep
  Parameter Type = Integer
  Default = -1
END
PARAMETER: TimeAnim Start Time
  Parameter Type = Float
END
PARAMETER: TimeAnim End Time
  Parameter Type = Float
END
PARAMETER: TimeAnim Start Crank Angle
  Parameter Type = Float
END
PARAMETER: TimeAnim End Crank Angle
  Parameter Type = Float
END
PARAMETER: TimeAnim Frame Interval
  Parameter Type = String
  Allowed Values List = All Timesteps, Specified Number Of Frames, \
                        Specified Timestep Interval, Specified Time Interval, \
                        Specified Crank Angle Interval
END
PARAMETER: TimeAnim Number Of Frames
  Parameter Type = Integer
  Default = 21
END
PARAMETER: TimeAnim Frame Spacing
  Parameter Type = String
  Allowed Values List = Equal In Timestep, Equal In Time, Equal In Crank Angle
END
PARAMETER: TimeAnim Time Interval
  Parameter Type = Float
END
PARAMETER: TimeAnim Crank Angle Interval
  Parameter Type = Float
END
PARAMETER: TimeAnim Timestep Interval
  Parameter Type = Integer
  Default = 1
END

# Keyframe Parameter:
PARAMETER: Keyframe Name
  Parameter Type = String
  Description = A string containing the name of the keyframe to display to the user.
END
PARAMETER: Number Of Frames
  Parameter Type = Integer
  Default = 10
  Description = The number of frames in the animation to insert between this \
                keyframe and the next.
END
PARAMETER: Keyframe Filename
  Parameter Type = String
  Description = A string containing the name of the state file associated with this keyframe.
END

# Preferred Units:
PARAMETER: Preferred Units System
  Parameter Type = String
  Default = SI
  Local Type = top
  Description = This specifies the Units System to use.
END

PARAMETER: Update Units to Preferred
  Parameter Type = Logical
  Default = false
  Description = This logical indicates whether all displayed units should always \
                 be updated to display the preferred units.  If this is 'false', \
                 quantities will be converted to preferred types.
END

PARAMETER: Custom Units Setting
  Parameter Type = String List
  Local Type = top
  Description = This is a comma delimited list of Quantities and their selected \
                units for the Custom Units Setting.  The list will contain both \
                Quantities and the units: e.g. Acceleration, m s^-2, Angle, radian, ...
END

PARAMETER: Custom Units Override
  Parameter Type = String List
  Local Type = top
  Description = This is a comma delimited list of Quantities and their selected \
                units for the Custom Units Override.  This parameter is defined in the \
                same format as the Custom Units Setting parameter.  Units in this parameter \
                will override the units for the specified quantity in the Custom Units Setting. \
                This accomodates user edited custom units.
END

# FFT Related Parameters

PARAMETER: Reference Acoustic Pressure 
  Parameter Type = Real
#  Default = 2.0e-5 [pa]
  Description = Reference pressure value when calculating Sound Pressure Level \
                in FFT calculation.
END

PARAMETER: Reference Length
  Parameter Type = Real
#  Default = 1.0 [m]
  Description = Reference length value used in using Strouhal Number X Function \
                in FFT calculation.
END

PARAMETER: Reference Velocity
  Parameter Type = Real
#  Default = 1.0 [m s^-1]
  Description = Reference velocity value used in using Strouhal Number X Function \
                in FFT calculation.
END

SINGLETON: UNIT SYSTEM
   CCLObject Class = UnitsCCLObject
   Category = internal
   Scheduler = top
   Essential Parameter List = Preferred Units System
   Optional Parameter List = Update Units to Preferred, Custom Units Setting, Custom Units Override
   Allowed Parent List = ROOT
   Description = This object stores the preferred units.
END

SINGLETON: MASS FLOW CALC OPTION ON PHYSICAL SURFACES 
   CCLObject Class = MassFlowCalcOptionCCLObject
   Category = internal
   Scheduler = top
   Essential Parameter List = Option
   Allowed Option List = Interpolated, Approximated
   Allowed Parent List = ROOT
   Description = This object defines the mass flow calculation option \
                 that is applied in the current state.
END

  # POINT and POINTCLOUD
# PARAMETER: Parametric Distance
#   Parameter Type = Real
#   Local Type = top
#   Default = 0.0
#   Remote Type = expression
# END
# PARAMETER: S Parameter
#   Parameter Type = Real
#   Local Type = top
#   Default = 0.0
#   Remote Type = expression
# END
# PARAMETER: T Parameter
#   Parameter Type = Real
#   Local Type = top
#   Default = 0.0
#   Remote Type = expression
# END
  PARAMETER: Random Seed
    Parameter Type = Integer
    Local Type = top
    Default = 1
    Description = The seed to be used for a random number series.
  END
  PARAMETER: Add Sample Vertex Normals
    Parameter Type = Logical
    Local Type = top
    Default = On
    Description = If true, calculate vertex normals for sampling geometry.
  END
#
#
# #LINE and POLYLINE
# PARAMETER: Line Type
#   Parameter Type = String
#   Local Type = top
#   Default = Linear
#   Allowed String List = Linear, Spline
# END
# PARAMETER: Line Sampling Method
#   Parameter Type = String
#   Local Type = top
#   Default = Uniform
#   Allowed String List = Uniform, Grid Density, On Defining Points
# END
  PARAMETER: Number of Samples
    Parameter Type = Integer
    Local Type = top
    Default = 10
    Description = The number of random samples to be taken in the plot.
  END
# PARAMETER: Distance Vector
#   Parameter Type = Real List
#   Local Type = top
#   Default = 1.0, 0.0, 0.0
# END
  PARAMETER: Input File
    Parameter Type = String
    Local Type = top
    Description = The name of the file to be read that contains the definition \
                  of one or more polylines or user surfaces and associated \
                  path variables.
  END
  PARAMETER: Section Name
    Parameter Type = String
    Local Type = top
    Description = The section name in the file to be read that contains the \
                  definition of the polyline or user surface and associated \
                  path variables.
  END
# END
# PARAMETER: Point List
#   Parameter Type = String List
#   Local Type = top
#   Remote Type = top
# END

# #PLANE
#  PARAMETER: Plane Resolution
#   Parameter Type = String
#   Local Type = top
#   Allowed String List = Grid Spacing, Uniform Spacing
#   Default = Grid Spacing
# END
# PARAMETER: Bounded Plane
#   Parameter Type = Logical
#   Local Type = top
#   Default = Off
# END
# PARAMETER: Preview Plane Size
#   Parameter Type = Real
# END
# PARAMETER: Side 1 Size
#   Parameter Type = Real
#   Local Type = top
#   Remote Type = expression
# END
# PARAMETER: Side 2 Size
#   Parameter Type = Real
#   Local Type = top
#   Remote Type = expression
# END
# PARAMETER: Side 1 Divisions
#   Parameter Type = Integer
#   Local Type = top
#   Default = 5
# END
# PARAMETER: Side 2 Divisions
#   Parameter Type = Integer
#   Local Type = top
#   Default = 5
# END
#
#
#
#STREAMLINE
PARAMETER: Streamline Type
  Parameter Type = String
  Allowed String List = 3D Streamline, Surface Streamline
  Default = 3D Streamline
  Local Type = top
  Description = Specifies the streamline type. Surface Streamlines are \
        restricted to a surface location.
END
PARAMETER: Seed Point Type
  Parameter Type = String
  Allowed String List = Equally Spaced Samples, Random Samples, \
                        Rectangular Grid, Vertices, \
                        Face Centers, Free Edges, Locations
  Default = Equally Spaced Samples
  Local Type = top
  Description = Specifies seed points used for Surface Streamlines.
END
PARAMETER: Seed Location List
   Parameter Type = String List
   Local Type = top
   Remote Type = geometry
   Description = A comma delimited list of locator names.
END
PARAMETER: Streamline Direction
  Parameter Type = String
  Allowed String List = Forward, Backward, Forward and Backward
  Default = Forward
  Local Type = top
  Description = The direction in which 3D streams are to be calculated
END
PARAMETER: Surface Streamline Direction
  Parameter Type = String
  Allowed String List = Forward, Backward, Forward and Backward
  Default = Forward and Backward
  Local Type = top
  Description = The direction in which surface streams are to be calculated
END
PARAMETER: Streamline Solver Type
  Parameter Type = String
  Allowed String List = Euler, RungeKutta2, RungeKutta4
  Default = RungeKutta2
  Local Type = top
  Description = The solver to use to calculate the streamlines
END
PARAMETER: Tolerance Mode
  Parameter Type = String
  Allowed String List = Grid Relative, Absolute
  Default = Grid Relative
  Local Type = top
  Description = whether Grid Tolerance or Absolute Tolerance are used
END
PARAMETER: Grid Tolerance
  Parameter Type = Real
  Default = 0.01
# Expects a number
  Local Type = top
  Description = Fraction of local grid size to use as a maximum step tolerance
END
PARAMETER: Absolute Tolerance
  Parameter Type = Real
# Expects a length
  Local Type = top
  Description = Length to use as a maximum step tolerance
END
PARAMETER: Streamline Maximum Time
  Parameter Type = Real
  Local Type = top
  Description = Stops streamline calculation when particle age exceeds this
END
PARAMETER: Streamline Maximum Segments
  Parameter Type = Integer
  Default = 10000
  Local Type = top
  Description = Stops streamline calculation when number of segments exceeds this
END
PARAMETER: Cross Periodics
  Parameter Type = Logical
  Default = Yes
  Local Type = top
  Description = If true allows a streamline to cross a periodic boundary
END
PARAMETER: Simplify Geometry
  Parameter Type = Logical
  Default = No
  Local Type = top
  Description = Flag indicates if nodes would be 'coarsened' for \
                surface streamline geometry
END
PARAMETER: Streamline Maximum Periods
  Parameter Type = Integer
  Default = 20
  Local Type = top
  Description = Limits the number of times a streamline may cross a periodic boundary
END
PARAMETER: Draw Symbols
  Parameter Type = Logical
  Default = No
  Local Type = symbol
  Description = Draw symbols on the streams at specified times
END
PARAMETER: Draw Streams
  Parameter Type = Logical
  Default = Yes
  Local Type = render
  Description = If false do not draw streams, but allow drawing of symbols
END
PARAMETER: Symbol Start Time
  Parameter Type = Real
  Default = 10.0 [s]
  Local Type = symbol
  Remote Type = expression
  Description = The particle age at which to draw the first symbol
END
PARAMETER: Symbol Stop Time
  Parameter Type = Real
  Default = -10.0 [s]
  Local Type = symbol
  Remote Type = expression
  Description = Draw no symbols with particle age lower than this
END
PARAMETER: Symbol Time Interval
  Parameter Type = Real
  Default = 1.0 [s]
  Local Type = symbol
  Remote Type = expression
  Description = Draw symbols at regular times separated by this value
END
PARAMETER: Stream Size
  Parameter Type = Real
  Default = 1.0
  Local Type = colour
  Remote Type = expression
  Description = The initial width of stream ribbons or tubes
END
PARAMETER: Stream Drawing Mode
  Parameter Type = String
  Allowed String List = Line, Tube, Ribbon
  Default = Line
  Local Type = colour
  Description = The streamline drawing mode.
END

PARAMETER: Number of Sides
  Parameter Type = Integer
  Default = 8
  Local Type = colour
  Description = The number of sides of a 'round' tube
END
PARAMETER: Streamline Width
  Parameter Type = Integer
  Default = 2
  Local Type = render
  Description = The width of the streamline.
END
PARAMETER: Stream Initial Direction
  Parameter Type = Direction
  Default = 0.0, 0.0, 0.0
  Local Type = top
  Description = Defines the initial plane of a stream ribbon
END
PARAMETER: Reduction or Max Number
  Parameter Type = String
  Default = Max Number
  Allowed String List = Max Number, Reduction
  Local Type = top
  Description = This indicates whether to use 'Reduction Factor' to reduce the \
        number of items, or to use 'Maximum Number of Items'.
END
PARAMETER: Reduction Factor
  Parameter Type = Real
  Default = 1.0
  Local Type = top
  Description = Reduces the number of items that should be displayed for a \
        particular locator.
END
PARAMETER: Maximum Number of Items
  Parameter Type = Integer
  Default = 10
  Local Type = top
  Description = Specifies the maximum number of items that should be displayed. \
        This parameter is mutually exclusive with the Reduction Factor Parameter.
END
PARAMETER: Object State
  Parameter Type = String
  Allowed String List = unavailable, partially available, available, \
                        incomplete, complete, invalid
  Default = available
  Description = Indicates the state of item (for GUI marking etc)
END

PARAMETER: Streamline Totals
   Parameter Type = String List
   Description = List of domains to number of streams (i.e. domain1,2,domain2,3)
END

OBJECT: STREAMLINE
  CCLObject Class = PointCloudGeometricCCLObject
  Category = point, line, line-only, deletable, constant-colour, selectable, \
      viewer-viewable, geometry, domain-dependent, has-variable, \
      has-variable-colour, has-local-variable, quick-animatable, suspendable
  Scheduler = top, geometry, colour, render, symbol
  Scheduler Links = top, geometry, geometry, colour, colour, render, render, symbol
  Calculate Function = top, streamlinecalc, StreamlineCalcFunc, \
                       geometry, streamlinecalc, StreamlineCalcFunc, \
                       symbol, streamlinecalc, StreamlineCalcFunc, \
                       colour, streamlinecalc, StreamlineCalcFunc, \
                       render, streamlinecalc, StreamlineCalcFunc
  Description = Calculates streamline plots as lines, ribbons or tubes
  Essential Parameter List = Location List, Variable
  Optional Child List = OBJECT VIEW TRANSFORM
  Optional Parameter List = Domain List, Streamline Direction, Tolerance Mode,\
                Grid Tolerance, Absolute Tolerance, Cross Periodics, Draw Symbols, \
                Stream Symbol, Draw Streams, Symbol Start Time, Symbol Stop Time, \
                Symbol Time Interval, Colour Scale, \
                Variable Boundary Values, Colour Mode, Colour Variable, Colour Map, \
                Colour Variable Boundary Values, Colour, Range, Min, Max, Symbol Size, \
                Visibility, Transparency, Draw Faces, Surface Drawing, Lighting, \
                Draw Lines, Specular Lighting, Culling Mode, Line Width, Line Colour, \
                Streamline Maximum Time, Streamline Solver Type, Reduction or Max Number, \
                Reduction Factor, Maximum Number of Items, Instancing Transform, \
                Apply Instancing Transform, Streamline Maximum Periods, \
                Stream Drawing Mode, Stream Size, Stream Initial Direction, \
                Number of Sides, Streamline Width, Streamline Type, \
                Seed Point Type, Seed Location List, Surface Streamline Direction, \
                Streamline Maximum Segments, Simplify Geometry, \
                Locator Sampling Method, Number of Samples, \
                Sampling Accuracy, Random Seed, Sampling Grid Angle, \
                Sample Spacing, Sampling Aspect Ratio, Add Sample Vertex Normals

  Internal Parameter List = Local Variable Ranges, Streamline Totals
  Allowed Parent List = ROOT
  PARAMETER: Variable Boundary Values
    Default = Conservative
  END
  PARAMETER: Maximum Number of Items
    Default = 25
    Local Type = top
  END
  PARAMETER: Number of Samples
    Default = 25
  END
  PARAMETER: Add Sample Vertex Normals
    Default = Off
  END
END

OBJECT:INTERNAL STREAMLINE
  CCLObject Class = PointCloudGeometricCCLObject
  Category = point, line, line-only, deletable, constant-colour, \
      viewer-viewable, geometry, domain-dependent, has-variable, \
      has-variable-colour, has-local-variable, has-local-legend, suspendable
  Scheduler = top, geometry, variable, colour, render, symbol
  Scheduler Links = top, geometry, geometry, variable, variable, colour, colour, render, render, symbol
  Calculate Function = top, streamlinecalc, StreamlineCalcFunc, \
                       geometry, streamlinecalc, StreamlineCalcFunc, \
                       variable, streamlinecalc, StreamlineCalcFunc, \
                       symbol, streamlinecalc, StreamlineCalcFunc, \
                       colour, streamlinecalc, StreamlineCalcFunc, \
                       render, streamlinecalc, StreamlineCalcFunc
  Description = Calculates streamline plots as lines, ribbons or tubes
  Essential Parameter List = Location List, Variable
  Optional Child List = OBJECT VIEW TRANSFORM
  Optional Parameter List = Domain List, Streamline Direction, Tolerance Mode,\
                Grid Tolerance, Absolute Tolerance, Cross Periodics, Draw Symbols, \
                Stream Symbol, Draw Streams, Symbol Start Time, Symbol Stop Time, \
                Symbol Time Interval, Colour Scale, \
                Variable Boundary Values, Colour Mode, Colour Variable, Colour Map, \
                Colour Variable Boundary Values, Colour, Range, Min, Max, Symbol Size, \
                Visibility, Transparency, Draw Faces, Surface Drawing, Lighting, \
                Draw Lines, Specular Lighting, Culling Mode, Line Width, Line Colour, \
                Streamline Maximum Time, Streamline Solver Type, Reduction or Max Number, \
                Reduction Factor, Maximum Number of Items, Instancing Transform, \
                Apply Instancing Transform, Streamline Maximum Periods, \
                Stream Drawing Mode, Stream Size, Stream Initial Direction, \
                Number of Sides, Streamline Width, Streamline Type, \
                Seed Point Type, Seed Location List, Surface Streamline Direction, \
                Streamline Maximum Segments, Simplify Geometry, \
                Locator Sampling Method, Number of Samples, \
                Sampling Accuracy, Random Seed, Sampling Grid Angle, \
                Sample Spacing, Sampling Aspect Ratio, Add Sample Vertex Normals


  Internal Parameter List = Local Variable Ranges, Streamline Totals
  Allowed Parent List = ROOT, CASE COMPARISON
  PARAMETER: Variable Boundary Values
    Default = Conservative
  END
  PARAMETER: Maximum Number of Items
    Default = 25
    Local Type = top
  END
  PARAMETER: Number of Samples
    Default = 25
  END
  PARAMETER: Add Sample Vertex Normals
    Default = Off
  END
END

# # VECTOR
  PARAMETER: Normalized
    Parameter Type = Logical
    Local Type = symbol
    Default = Off
    Description = If set On, all vectors are plotted with the same length (show \
                  direction only).
  END
  PARAMETER: Surface Sampling
    Parameter Type = Logical
    Local Type = top
    Default = Off
    Description = If set On, results are displayed at a subset of points in the plot.
  END

 #USER SURFACE 
PARAMETER: Offset Variable
   Parameter Type = String
   Local Type = top
   Remote Type = top
   Description = Specifies the variable to be used for the offset \
                 (used in Offset From Surface mode).
END
PARAMETER: Offset Type
   Parameter Type = String
   Local Type = top
   Default = Normal
   Allowed String List = Normal, Translational
   Description = Specifies the offset type (used in Offset From Surface mode).
END
PARAMETER: Offset Mode
   Parameter Type = String
   Local Type = top
   Default = Uniform
   Allowed String List = Uniform, Variable
   Description = Specifies the offset mode (used in Offset From Surface mode).
END
PARAMETER: Offset Distance
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.0
   Description = The offset distance (used in Offset From Surface mode).
END
PARAMETER: Offset Direction
   Parameter Type = Real List
   Local Type = top
   Default = 1.0, 0.0, 0.0
   Description = Specifies the offset direction vector (used in Offset From Surface mode).
END

PARAMETER: Surface Name
   Parameter Type = String
   Local Type = top
   Remote Type = geometry
   Description = The name of the surface object to offset from.
END
PARAMETER: Contour Name
   Parameter Type = String
   Local Type = top
   Remote Type = colour
   Description = The name of the contour object specified in a user surface.
END
PARAMETER: Contour Level
   Parameter Type = Integer
   Local Type = top
   Default = 1
   Description = The contour level specified in a user surface.
END
PARAMETER: Surface Element Type
  Parameter Type = String
  Default = 152
  Description = This Internal parameter stores the Type of Surface Elements that the\
                Geometry consists of for ANSYS Import Geometries.
END
PARAMETER: ANSYS Volumetric Temperature Transfer
  Parameter Type = Logical
  Default = false
  Description = Indicates whether the User Surface defines a Volumetric Temperature Transfer \
                or not.
END
PARAMETER: ANSYS Key Option
  Parameter Type = String
  Description = This Internal parameter stores the ANSYS KEYOPT command value for the\
        specified element type.  We only care about KEYOPT 8 for SURF152's, and \
        KEYOPT 11 for SURF154's.  Therefore, depending on the value of "Surface Element Type",\
        this will have the value of the appropriate KEYOPT.
END
PARAMETER: ANSYS Mapping Success Status
  Parameter Type = String
  Default = Unknown
  Description = This Internal parameter stores the ANSYS surface mapping success status \
    as a percentage value.  If a status is not yet specified, this parameter will be set \
    to 'Unknown'.
END
PARAMETER: File Units
  Parameter Type = String
  Local Type = top
  Default = m
  Description = Specifies the units of the data in the ANSYS CDB file \
                to be imported.
END
PARAMETER: Associated Boundary Specified
  Parameter Type = Logical
  Local Type = top
  Default = true
  Description = Indicates whether to associate a boundary with this geometry.
END
PARAMETER: Associated Boundary
  Parameter Type = String
  Local Type = top
  Remote Type = geometry
  Description = The name of the boundary that the user wishes to associate with\
                the imported ANSYS mesh.
END
PARAMETER: Maintain Conservative Values
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to scale the variable values by an appropriate factor to\
                ensure that the results are conservative with respect to the values on the\
                Associated Boundary.
END
PARAMETER: Use Mid Side Nodes
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to include reading the mid-side nodes when reading \
                the ANSYS surface.  The mid-side nodes will only be used when exporting \
                Node Temperatures.
END
PARAMETER: ANSYS Diagnostics File
  Parameter Type = String
  Default = CFX2ANSYSDiagnostics.xml
  Description = Specifies the file to which to write the Import and Export Diagnostics.
END



 #CONTOUR
 PARAMETER: Use Face Values
   Parameter Type = Logical
   Local Type = colour
   Default = false
   Description = Specifies whether Contours are computed using face values. \
                 If set to "false", Contours are computed using node values.
 END
 PARAMETER: Number of Contours
   Parameter Type = Integer
   Local Type = colour
   Default = 11
   Description = Specifies number of contour lines in a contour plot.
 END
 PARAMETER: Clip Contour
   Parameter Type = Logical
   Local Type = colour
   Default = Off
   Description = Enables/disables clipping in a contour plot.
 END
 PARAMETER: Draw Contours
   Parameter Type = Logical
   Local Type = render
   Default = On
   Description = Enables/disables drawing of the contour lines. 
 END
 PARAMETER: Show Numbers
   Parameter Type = Logical
   Local Type = render
   Default = Off
   Description = Toggles contour numbering. 
 END
 PARAMETER: Fringe Fill
   Parameter Type = Logical
   Local Type = render
   Default = On
   Description = If set to On, the space between contours in a contour plot is \
                 filled with fringe bands.
 END
 PARAMETER: Contour Range
   Parameter Type = String
   Allowed String List = Global, Local, User Specified, Value List
   Local Type = colour
   Default = Global
   Description = Sets the method used to calculate a contour plot.\
                 "Global" uses the range of variable values in the \
                 problem domain. "Local" uses the range of values on the \
                 specified list of objects. "User Specified" uses Min and Max \
                 parameter value. "Value List" plots contours on the values \
                 specified in Value List parameter.
 END
 PARAMETER: Value List
   Parameter Type = Real List
   Local Type = colour
   Default = 0.0, 1.0
   Description = Specifies a list of variable values for a contour plot. In \
                 order for this list to be used, Contour Range has to be set \
                 to "Value List".
 END
 PARAMETER: Constant Contour Colour
   Parameter Type = Logical
   Local Type = colour
   Default = Off
   Description = If set to On, then the "Line Colour" parameter is used to \
                 determine the contour colour. Otherwise, the contour is \
                 coloured by the contour variable.
 END

 PARAMETER: Fractional Value
   Parameter Type = Real
   Local Type = top
  # Remote Type = expression
   Default = 0.01
   Description = The fractional value of the variable at which the isosurface is to be plotted.
 END
  #ISOSURFACE
  PARAMETER: Value
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0
    Description = The value of the variable at which the isosurface is to be plotted.
  END

    PARAMETER: Value 1
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0
    Description = The value of the variable at which the isovolume is to be plotted.
  END

   PARAMETER: Value 2
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0
    Description = The value of the variable at which the isovolume is to be plotted \
                  it is used when the isovolume mode is between values.
  END

#  PARAMETER: Table Index
#    Parameter Type = Real
#    Local Type = top
#    Default = ALL
#  END

  #WIREFRAME
  PARAMETER: Show Surface Mesh
     Parameter Type = Logical
     Local Type = top
     Default = Off
     Description = If set to On, all mesh lines are displayed in the \
                   wireframe, and Edge Angle setting is ignored.
  
    END
  PARAMETER: Edge Angle
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 30 [degree]
    Description = The angle between two faces used to limit visible edges in a \
                  wireframe.
  END
  PARAMETER: Render Edge Angle
    Parameter Type = Real
    Local Type = colour
    Remote Type = expression
    Default = 0 [degree]
    Description = The angle between two faces used to limit visible edges in a \
                  wireframe.
  END
#
 #GROUP
PARAMETER: Member List
   Parameter Type = String List
   Local Type = geometry
   Remote Type Links = top, top, geometry, geometry
   Description = A list of objects included in the group.
END

PARAMETER: Turbo Member List
   Parameter Type = String List
   Local Type = turbo
   Remote Type = turbo
   Description = A list of objects included in the group.
END

 #TRANSFORM

PARAMETER: Apply Scale
   Parameter Type = Logical
   Local Type = top
   Default = true
   Description = Toggles scale in the transformation.
END
PARAMETER: Scale Factor
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 1.0
   Description = The object scale factor used in the transformation
END
PARAMETER: Instancing Info From Domain
   Parameter Type = Logical
   Local Type = instance
   Default = true
   Description = logical parameter indicating if instancing info \
                 should come from each domain for a geometric object.

END
PARAMETER: Apply Reflection
   Parameter Type = Logical
   Local Type = instance
   Default = false
   Description = Toggles reflection in the transformation.
END
PARAMETER: Apply Translation
   Parameter Type = Logical
   Local Type = instance
   Default = false
   Description = Toggles translation in the transformation.
END
PARAMETER: Apply Rotation
   Parameter Type = Logical
   Local Type = instance
   Default = true
   Description = Toggles rotation in the transformation.
END
PARAMETER: Reflection Plane Option
   Parameter Type = String
   Local Type = instance
   Allowed String List = XY Plane, YZ Plane, ZX Plane, From Plane
   Default = From Plane
   Description = Specifies how to define the plane that is used to \
        create the reflection plane.  It can be defined as either \
        some axis-parallel planes, or from an existing plane object.
END
PARAMETER: Reflection Plane
   Parameter Type = String
   Local Type = instance
   Remote Type = geometry
   Description = Specifies the REFLECTION PLANE object to use in a \
        transformation.
END
PARAMETER: Rotation Axis Type
   Parameter Type = String
   Local Type = instance
   Default = Principal Axis
   Allowed String List = Principal Axis, Rotation Axis
   Description = Specifies the rotation axis type in the \
      transformation. \
      If it is set to `Principal Axis', Principal Axis parameter \
      setting is used. It is set to `Rotation Axis', parameters \
      Rotation Axis From and Rotation Axis To are used for the axis \
      definition.
END
PARAMETER: Principal Axis
   Parameter Type = String
   Local Type = instance
   Default = Z
   Allowed String List = X, Y, Z
   Description = Specifies the principal axis used in instance rotation.
END
PARAMETER: Rotation Axis From
   Parameter Type = Real List
   Local Type = instance
   Default = 0.0, 0.0, 0.0
   Description = An XYZ triple defining the first point of the \
        rotation axis.
END
PARAMETER: Rotation Axis To
   Parameter Type = Real List
   Local Type = instance
   Default = 1.0, 0.0, 0.0
   Description = An XYZ triple defining the second point of the \
        rotation axis.
END
PARAMETER: Rotation Angle
   Parameter Type = Real
   Local Type = instance
   Remote Type = expression
   Default = 0 [degree]
   Description = Specifies the rotation angle.
END
PARAMETER: Number of Passages in Component
  Parameter Type = Integer
  Local Type = instance
  Default = 1
  Description = Number of passages in a component
END           
PARAMETER: Number of Passages in 360
  Parameter Type = Integer
  Local Type = instance
  Default = 12
  Description = Number of passages in 360 degrees 
END
# Number of Components in 360 = (Number of Passages in 360) /
#                               (Number of Passages in Component)
PARAMETER: Number of Components in 360
  Parameter Type = Real
  Local Type = instance
  Default = 12
  Description = Number of Components in 360 degrees 
END

PARAMETER: Number of Data Instances
  Parameter Type = Integer
  Local Type = geometry
  Default = 1
  Description = "Specifies the number of replications of the original \
  Geometry associated with the domain that are to be made."
END


PARAMETER: Translation Vector
   Parameter Type = Real List
   Local Type = instance
   Default = 0.0, 0.0, 0.0
   Description = Specifies the translation vector.
END
PARAMETER: Scale Vector
   Parameter Type = Real List
   Local Type = instance
   Default = 1.0, 1.0, 1.0
   Description = Specifies the scale vector.
END
PARAMETER: Number of Copies
   Parameter Type = Integer
   Local Type = instance
   Default = 1
   Description = Specifies the number of transformed copies.
END
PARAMETER: Full Circle
  Parameter Type = Logical
  Local Type = instance
  Default = Off
  Description = If set to On, the instances are placed uniformly about \
        the instance rotation axis. Note that the Number of Copies has to be \
        greater than two when this option is used.
END
PARAMETER: Angle Definition Method
   Parameter Type = String
   Local Type = instance
   Default = Instances in 360
   Allowed String List = Value, Instances in 360
   Description = Specifies angle definition method. If it is set to \
                 `Value', parameter Rotation Angle \
                  value will be used for angular instancing. \
                  If it is set to `Instances in 360', \
                  parameter 'Number of Components in 360' will be used.
END

# INSTANCE DEFINITION Parameters: From File ###############
PARAMETER: Number of Passages in Component From File
  Parameter Type = Integer
  Local Type = instance
  Default = 1
  Description = Internal version of 'Number of Passages in Component' parameter.
END           
PARAMETER: Number of Passages in 360 From File
  Parameter Type = Integer
  Local Type = instance
  Default = 1
  Description = Internal version of 'Number of Passages in 360' parameter.
END
PARAMETER: Number of Components in 360 From File
  Parameter Type = Real
  Local Type = instance
  Default = 1
  Description = Internal version of 'Number of Components in 360' parameter.
END
###########################################################


# TEXT
PARAMETER: Font
   Parameter Type = String
   Local Type = colour
   Allowed String List = Serif, Sans Serif
   Default = Sans Serif
   Description = The font name for an item of text.
 END
 PARAMETER: Text String
   Parameter Type = String
   Local Type = colour
   Default = 
   Description = The contents of an item of text.
 END
 PARAMETER: Text Height
   Parameter Type = Real
   Local Type = colour
   Default = 0.024
   Description = The height an item of text should be, proportional to the screen.
 END
 PARAMETER: Text Position
   Parameter Type = Real List
   Local Type = colour
   Default = 0, 0.96, 0
   Parameter Category = Position
   Description = The location an item of text should be placed.
 END
 PARAMETER: Position Mode
   Parameter Type = String
   Local Type = colour
   Allowed String List = Two Coords, Three Coords
   Default = Two Coords
   Description = Defines whether a text item is attached to two-dimensional \
screen coordinate, or a three-dimensional spatial coordinate.
 END
 PARAMETER: Overlay Size
   Parameter Type = Real
   Local Type = colour
   Default = 1
   Description = A factor by which to scale the size of a two-dimensional overlay.
 END
 PARAMETER: Text Rotation
   Parameter Type = Real
   Local Type = colour
   Default = 0
   Description = Counter-clockwise rotation, in degrees, to be applied to a text item.
 END
 PARAMETER: X Justification
   Parameter Type = String
   Local Type = colour
   Allowed String List = None, Center, Left, Right
   Default = Center
   Description = Specifies the horizontal justification of a text or overlay item.
 END
 PARAMETER: Y Justification
   Parameter Type = String
   Local Type = colour
   Allowed String List = None, Center, Top, Bottom
   Default = None
   Description = Specifies the vertical justification of a text or overlay item.
 END
  PARAMETER: Text Colour Mode
   Local Type = colour
   Allowed String List = Default, User Specified
   Default = Default
   Description = Determines where to get the text colour from.
  END
  PARAMETER: Text Colour
    Parameter Type = Real List
    Local Type = colour
    Default = 0, 0, 0
    Description = A list of three numbers between 0 and 1, which represent the \
                RGB (Red/Green/Blue) values to be used when colouring the text.
  END

 PARAMETER: Text Item Active
   Parameter Type = Logical
   Local Type = colour
   Default = false
   Description = Indicates whether to use this TEXT ITEM object in the final \
        output of the TEXT overlay.  This is used to disable the TEXT ITEM objects \
        that the user no longer wishes to display.
 END
 PARAMETER: Embed Auto Annotation
   Parameter Type = Logical
   Local Type = colour
   Default = false
   Description = Specifies whether to embed an auto annotation item in the string.
 END
 PARAMETER: Auto Annotation Type
   Parameter Type = String
   Local Type = colour
   Allowed String List = Filename, File Date, File Time, Timestep, Time Value, Expression, Crank Angle
   Default = Expression
   Description = Specifies which type of annotation to show.
 END
 PARAMETER: Auto Annotation Filename Format
    Parameter Type = String
    Local Type = colour
    Allowed String List = Entire Path, Filename Only
    Default = Filename Only
    Description = Specifies the Filename display format.
 END
 PARAMETER: Auto Annotation File Date Format
    Parameter Type = String
    Local Type = colour
    Default = DD/MM/YY
    Description = Specifies the Date display format. 'D' or 'DD' specifies the day of \
        the month, 'M' or 'MM' specifies the month as a number (e.g. 06 = June), \
        'MMM' specifies the month as a short form text (e.g. Jun = June, Aug = August), \
        'MMMM' specifies the full month name as text, 'Y' or 'YY' specifies a two digit \
        year (e.g. 03 = 2003), and 'YYY' or 'YYYY' specifies a four digit year.  Any \
        consecutive duplicates beyond what is already stated will be reduced to the closest \
        form.
 END
 PARAMETER: Auto Annotation File Time Format
    Parameter Type = String
    Local Type = colour
    Default = h:m:s t
    Description = Specifies the Time display format. 'H' is hours in 24 hour format, \
        'h' is hours in 12 hour format, 'm' is minutes, 's' is seconds, and 't' is \
        AM or PM, depending on the time of day.  Any consecutive duplicates will be \
        reduced to a single item.
 END
 PARAMETER: Auto Annotation Expression
   Parameter = Real
   Local Type = colour
   Remote Type = expression
   Default = 
   Description = Specifies the expression to display.
 END
 PARAMETER: Auto Annotation Float Format
    Parameter Type = String
    Local Type = colour
    Default = %10.3e
    Description = Specifies the floating point number display format.
 END
 PARAMETER: Auto Annotation Use Automatic Number Formatting
    Parameter Type = Boolean
    Local Type = colour
    Default = true
    Description = Specifies whether the floating point number format is used.
 END

OBJECT: TEXT 
  CCLObject Class = PostTextCCLObject
  Category = deletable, constant-colour, selectable, viewer-viewable, suspendable
  Scheduler = colour, render
  Scheduler Links = colour, render
  Essential Child List = \
        TEXT ITEM
  Essential Parameter List = Position Mode
  Context Rule = Position Mode
  Allowed Option List = Two Coords, Three Coords
  Optional Parameter List = Text Position, Text Height, Text Rotation, \
                        Colour, Overlay Size, Font, Visibility, Text Colour Mode
  CONTEXT: Two Coords
    Optional Parameter List = X Justification, Y Justification
  END
  PARAMETER: Colour
   Default = 0, 0, 0
  END

  Allowed Parent List = ROOT
  Description = A single piece of text.  This text item can be attached to \
        a point on screen (specified in two dimensions), or attached to a point in \
        three dimensions, following that point through any viewer transformations. \
        Font, size, colour, rotation and justification options are provided.
END

OBJECT: TEXT ITEM
  CCLObject Class = PostTextCCLObject
  Category = deletable, constant-colour, suspendable
  Scheduler = colour, render
  Scheduler Links = colour, render
  Optional Parameter List = Text Item Active, Text String, Embed Auto Annotation, \
        Auto Annotation Type, Auto Annotation Filename Format, \
        Auto Annotation File Date Format, Auto Annotation File Time Format, \
        Auto Annotation Expression, Auto Annotation Float Format, \
        Auto Annotation Use Automatic Number Formatting
  Context Rule = Auto Annotation Type
  Allowed Option List = Filename, File Date, File Time, \
                        Timestep, Time Value, \
                        Expression, \
                        Crank Angle
  CONTEXT: Filename
    Optional Parameter List = Auto Annotation Filename Format
  END
  CONTEXT: File Date
    Optional Parameter List = Auto Annotation File Date Format
  END
  CONTEXT: File Time
    Optional Parameter List = Auto Annotation File Time Format
  END
  CONTEXT: Timestep
  END
  CONTEXT: Time Value
    Optional Parameter List = Auto Annotation Use Automatic Number Formatting, \
                              Auto Annotation Float Format
  END
  CONTEXT: Crank Angle
    Optional Parameter List = Auto Annotation Use Automatic Number Formatting, \
                              Auto Annotation Float Format
  END
  CONTEXT: Expression
    Optional Parameter List = Auto Annotation Expression, \
                              Auto Annotation Use Automatic Number Formatting, \
                              Auto Annotation Float Format
  END
  Allowed Parent List = TEXT
  Description = This defines the text to display for the associated TEXT \
                object, and specifies the Auto-Annotation parameters.
END

# Legend
PARAMETER: Legend Plot
  Parameter Type = String
  Description = Name of the locator for which to provide information.
END

PARAMETER: Legend Position
  Parameter Type = Real List
  Local Type = colour
  Default = 0.02, 0.15
  Description = XY position of the legend.
END
 PARAMETER: Legend X Justification
   Parameter Type = String
   Local Type = colour
   Allowed String List = None, Center, Left, Right
   Default = Right
   Description = Specifies the horizontal justification of a text or overlay item.
 END
 PARAMETER: Legend Y Justification
   Parameter Type = String
   Local Type = colour
   Allowed String List = None, Center, Top, Bottom
   Default = Top
   Description = Specifies the vertical justification of a text or overlay item.
 END
PARAMETER: Legend Size
  Parameter Type = Real
  Local Type = colour
  Default = 0.6 
  Description = Scale factor to apply to legend.
END
PARAMETER: Legend Ticks
  Parameter Type = Integer
  Local Type = colour
  Default = 5
  Description = Number of points to provide variable values next to the \
        Legend bar.
END
PARAMETER: Legend Resolution
  Parameter Type = Integer
  Local Type = colour
  Default = 256
  Description = Number of colour subdivisions on the legend bar.
END
PARAMETER: Legend Shading
  Parameter Type = String
  Local Type = colour
  Allowed String List = Smooth, Flat
  Default = Smooth
  Description = Controls interpolated shading of colour on the legend bar.
END
PARAMETER: Legend Aspect
  Parameter Type = Real
  Local Type = colour
  Default = 0.07
  Description = Legend bar width control parameter
END
PARAMETER: Legend Format
  Parameter Type = String
  Local Type = colour
  Default = %10.3e
  Description = Parameter to modify string format of values on legend.
END
PARAMETER: Show Legend Units
  Parameter Type = Logical
  Local Type = colour
  Default = On 
  Description = Toggles display of units in the legend. 
END
PARAMETER: Legend Title Mode
  Parameter Type = String
  Local Type = colour
  Allowed String List = No Title, Variable, Variable and Location, User Specified
  Default = Variable and Location
  Description = Controls the legend title type. 
END
PARAMETER: Legend Title
  Parameter Type = String
  Local Type = colour
  Default = Legend
  Description = Specifies the legend title when Legend Title Mode is set to User Specified. 
END
PARAMETER: Legend Orientation
  Parameter Type = String
  Local Type = colour
  Allowed String List = Vertical, Horizontal
  Default = Vertical
  Description = Specifies whether to display the legend Vertically or Horizontally.
END
PARAMETER: Legend Object List
  Parameter Type = String List
  Description = Specifies a list of objects to use for the Default (auto) Legend, \
        and the order in which to use them.
END

PARAMETER: Colour Map Colours
  Parameter Type = Real List
  # Rainbow
  Default = \
        0,     0,   0,   1,   1, \
        0.10,  0,   0.5, 1,   1, \
        0.25,  0,   1,   1,   1, \
        0.44,  0,   1,   0.5, 1, \
        0.50,  0,   1,   0,   1, \
        0.57,  0.5, 1,   0,   1, \
        0.75,  1,   1,   0,   1, \
        0.90,  1,   0.5, 0,   1, \
        1,     1,   0,   0,   1 
  Local Type = top
  Description = List of sets containing interpolation value, red, green, \
                blue, and alpha values in real that make up a colour map.
END
PARAMETER: Colour Map Custom Colours
  Parameter Type = Real List
  Default = 2.0, 0.0, 0.0, 0.0, 1.0, \
            3.0, 1.0, 1.0, 1.0, 1.0
  Local Type = top
  Description = List of colors that are at indices above 1.0 for special \
                applications.
END
PARAMETER: Colour Map Type
  Parameter Type = String
  Allowed String List = Gradient, Zebra
  Default = Gradient
  Local Type = top
  Description = Sets the type of colour map (Gradient or Zebra).
END
PARAMETER: Colour Map Divisions
  Parameter Type = Integer
  Default = 2
  Local Type = top
  Description = When Colour Map Type is Zebra, this value determines \
                the number of gradient stripes.
END
PARAMETER: Colour Map Storage Type
  Parameter Type = String
  Allowed String List = System, Preferences, State
  Default = State
  Local Type = top
  Description = This determines the type of storage this colour map \
                comes from.
END
OBJECT: COLOUR MAP
  CCLObject Class = ColourMapCCLObject
  Category = colourmap, suspendable
  Scheduler = top
  Description = Contains a user-defined colour map for contouring.
  Optional Parameter List = Colour Map Colours, Colour Map Type, Colour Map Divisions, \
                       Colour Map Storage Type
  Internal Parameter List = Colour Map Custom Colours
  Allowed Parent List = ROOT
END
OBJECT: SYSTEM COLOUR MAP
  CCLObject Class = ColourMapCCLObject
  Category = internal, colourmap, suspendable
  Scheduler = top
  Description = Contains a system-defined colour map for contouring.
  Optional Parameter List = Colour Map Colours, Colour Map Type, Colour Map Divisions, \
                       Colour Map Storage Type
  Internal Parameter List = Colour Map Custom Colours
  Allowed Parent List = ROOT
END

# Colour Map
PARAMETER: Colour Map Name
  Parameter Type = String
  Default = Rainbow
  Local Type = top
  Remote Type = top
END

OBJECT: COLOUR MAP DEFAULT
  Category = internal, colourmap, suspendable
  Scheduler = top
  Description = Contains the name of the current default colour map.
  Essential Parameter List = Colour Map Name
  Optional Parameter List = Colour Map Colours, Colour Map Type, Colour Map Divisions, \
                       Colour Map Storage Type, Colour Map Custom Colours
  Allowed Parent List = ROOT
END


# Boundary Intersection

PARAMETER: Boundary List
  Parameter Type = String List
  Local Type = top
  Remote Type = geometry
  Description = A list of boundary objects
END

#
# ARRAY
PARAMETER: Dimensions
  Parameter Type = Integer List
  Description = The dimensions of a hybrid object such as composite.\
                (0-point, 1-line, 2-surface, 3-volume).
END

# COORDINATE FRAME

PARAMETER: Reference Coord Frame
  Parameter Type = String
  Default = Coord 0
  Description = The Coordinate Frame in which the physical locations used to \
                set this coordinate frame are described.
END
PARAMETER: Coord Frame Type
  Parameter Type = String
  Allowed String List = Cartesian
  Default = Cartesian
  Description = The orthonormal space used to define the coordinate frame.
END

PARAMETER: Origin Point
  Parameter Type = Real List
  Local Type = top
  Default = 0, 0, 0
  Remote Type = expression
  Parameter Category = Position
  Description = The location of the coordinate frame origin.
END
PARAMETER: Axis 3 Point
  Parameter Type = Real List
  Local Type = top
  Default = 0, 0, 1
  Remote Type = expression
  Parameter Category = Position
  Description = The location of the point in the Z axis of the coordinate frame.
END
PARAMETER: Plane 13 Point
  Parameter Type = Real List
  Local Type = top
  Default = 1, 0, 0
  Remote Type = expression
  Parameter Category = Position
  Description = The location of the a point in the XZ plane of the coordinate frame.
END

  #DOMAIN
# PARAMETER:  Apply Transforms
#   Parameter Type = Logical
#   Local Type = top
#   Default = Off
# END
# PARAMETER: Transform List
#   Parameter Type = String List
#   Local Type = top
#   Remote Type = top
# END
# PARAMETER: Replica List
#   Parameter Type = String List
#   Local Type = top
#   Remote Type = top
# END
# PARAMETER: Transform Matrix
#   Parameter Type = Real List
#   Default = 1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1
#   Local Type = top
# END

#
# #EXPRESSION
# PARAMETER:  Result
#   Parameter Type = String
#   Local Type = top
# END
# PARAMETER:  Genicode
#   Parameter Type = String
#   Local Type = top
# END
#
 
 #CLIP PLANE
 PARAMETER: Slice Plane
   Parameter Type = String
   Local Type = top
   Remote Type = geometry
   Description = Specifies the name of the PLANE object to use for the clip \
        plane definition.
 END
 PARAMETER: Flip Normal
   Parameter Type = Logical
   Default = false
   Local Type = top
   Description = If this parameter is set to true, the normal of the clip \
    plane will be flipped, effectively inverting the clipping region. 
 END

  # Misc.
  PARAMETER: Projection Type
    Parameter Type = String 
    Local Type = top
    Allowed String List = None, Coord Frame, Normal, Tangential, \
                          Streamwise, Span, Axial, Radial, Circumferential
    Default = None
    Description = The vector projection type to be used in creating this plot.
  END
  PARAMETER: Option
    Parameter Type = String
    Local Type = top
    Description = A generic parameter used to define the context \
                  setting for a variety of objects.
  END
  
  PARAMETER: Inclusive
   Parameter Type = Logical
   Default = false
   Local Type = top
   Description = If this parameter set to true, then the volume for \
                 above or below intersection includes intersections .  
 END


  PARAMETER: Element Type List
    Parameter Type = String List
    Local Type = top
    Default = Tet, Pyramid, Wedge, Hex, Polyhedron
    Description = The element type(s) to include in the volume \
        (Tet, Pyramid, Wedge, Hex, Polyhedron). If left blank, all types are included.
  END

  PARAMETER: Volume Intersection Mode
    Parameter Type = String
    Allowed String List = Intersection, Below Intersection, Above Intersection
    Default = Intersection
    Local Type = top
    Description = A parameter used to define the context setting for volume object.
  END

   PARAMETER: Isovolume Intersection Mode
    Parameter Type = String
    Allowed String List = At Value, Below Value, Above Value, Between Values
    Default = At Value
    Local Type = top
    Description = A parameter used to define the context setting for isovolume object.
  END

  PARAMETER: Domain List
    Parameter Type = String List
    Local Type = top
        Remote Type Links = top, top, geometry, geometry
#    Default = /DOMAIN GROUP:All Domains
    Default = All Domains
    Description = The list of domains over which to define this object.
  END

  PARAMETER: Set Number
    Parameter Type = Integer List
    Description = Solver face/element set number for a primitive region.
  END

  PARAMETER: Region List
    Parameter Type = String List
    Description = The list of regions over which to define this object \
                  (used by domain, subdomain and boundary).
  END

  PARAMETER: Has Primitives
    Parameter Type = Logical
    Description = Flag indicating if a 'composite' region is defined by \
                  primitives
  END

  PARAMETER: Time Step List
    Parameter Type = Integer List
    Description = The list of time steps that a res object is associated with.
  END

  PARAMETER: Case Name
    Parameter Type = String
    Description = Internal CFD-Post name for the analysed problem or the results set to use.
  END

########################## TURBO RELATED PARAMETERS ##########################

 OBJECT: DOMAIN
   Category = geometry, volume, point, selectable, \
              has-variable, has-instance-transform, domain, suspendable
   CCLObject Class = DomainGeometricCCLObject
   Scheduler = top, geometry, cylindrical, turbo, blade, instance, render, \
               tbrtransform
   Scheduler Links = \
                     top, cylindrical, \
                     cylindrical, turbo, \
                     turbo, blade, \
                     blade, instance, \
                     geometry, instance, \
                     instance, render
#  Optional Parameter List = Transform List, Apply Transforms, Replica List, \
#                            Transform Matrix

   Optional Parameter List = Domain Type, \
                 Blade Region, \
                 Hub Region, \
                 Shroud Region, \
                 Inlet Region, \
                 Outlet Region, \
                 Periodic 1 Region, \
                 Periodic 2 Region, \
                 Turbo 360 Case without Periodics, \
                 Background Mesh Generation Method, \
                 Background Mesh Density, \
                 Apply Reflection, \
                 Apply Translation, \
                 Apply Rotation, \
                 Rotation Axis Type, \
                 Principal Axis, \
                 Rotation Axis From, \
                 Rotation Axis To, \
                 Coord Frame,\
                 Axis,\
                 Full Circle, \
                 Angle Definition Method, \
                 Rotation Angle, \
                 Number of Components in 360, \
                 Number of Passages in 360, \
                 Number of Passages in Component, \
                 Number of Data Instances, \
                 Translation Vector, \
                 Number of Copies, \
                 Axis From File, \
                 Instance Definition, \
                 Hub Curve Mode, \
                 Hub Line Object, \
                 Shroud Curve Mode, \
                 Shroud Line Object, \
                 Inlet Curve Mode, \
                 Inlet Line Object, \
                 Outlet Curve Mode, \
                 Outlet Line Object, \
                 Components to Initialize, \
                 Components to Update, \
                 Components to Ignore, \
                 Reflection Plane Option, \
                 Create Additional Turbo Variables, \
                 Do Cylindrical Initialization, \
                 Blade Aligned Variable Available, \
                 Linear Blade Aligned Variable Available, \
                 TBR User Theta Correction
   
   Internal Parameter List = Results File, \
                 Case Name, \
                 Is Immersed Object, \
                 Is Rotating, \
                 UpStream Domain, \
                 DownStream Domain, \
                 Angular Velocity, \
                 Solid Motion Angular Velocity, \
                 Reference Pressure, \
                 Ignore Theta Offset, \
                 Component List, \
                 Initialized Components, \
                 Failed Components, \
                 Current Rotation Axis From, \
                 Current Rotation Axis To, \
                 Number of Nodes, Number of Elements, \
                 Number of Tetrahedra, Number of Wedges, \
                 Number of Pyramids, Number of Hexahedra, \
                 Number of Polyhedra, \
                 Region List, \
                 LE BA Location, \
                 TE BA Location, \
                 Create Blade Aligned Variable, \
                 Object State, \
                 Is TBR Flutter Domain, \
                 Is Turbo Config Domain, \
                 Zero Theta Point, \
                 Is Zero Theta Point Defined, \
                 Time Step List, \
                 TBR Number of Modes, \
                 TBR Theta Correction, \
                 TBR Period, \
                 TBR Phase Factor , \
                 TBR Instancing Factor, \
                 TBR Pitch Instancing, \
                 TBR Time Lag, \
                 TBR Variable List, \
                 Number of Components in 360 From File, \
                 Number of Passages in 360 From File, \
                 Number of Passages in Component From File

   Allowed Parent List = ROOT, CASE
   Description = An automatically created object for each domain read \
         from the results file.
   
   Context Rule = Reflection Plane Option
   Allowed Option List = XY Plane, YZ Plane, ZX Plane, From Plane
   CONTEXT: YZ Plane
     Optional Parameter List =  X
   END
   CONTEXT: ZX Plane
     Optional Parameter List =  Y
   END
   CONTEXT: XY Plane
     Optional Parameter List =  Z
   END
   CONTEXT: From Plane
     Optional Parameter List = Reflection Plane
   END
   PARAMETER: X
     Local Type = instance
   END
   PARAMETER: Y
     Local Type = instance
   END
   PARAMETER: Z
     Local Type = instance
   END

   PARAMETER: Coord Frame
     Default =  
   END
   PARAMETER: Rotation Axis Type
     Local Type = cylindrical
     Allowed String List = Principal Axis, Rotation Axis, Coordinate Frame
     Default = Principal Axis
   END
   PARAMETER: Principal Axis
     Local Type = cylindrical
   END
   PARAMETER: Rotation Axis From
     Local Type = cylindrical
   END
   PARAMETER: Rotation Axis To
     Local Type = cylindrical
   END
   PARAMETER: Axis
     Local Type = cylindrical
   END
 END

 PARAMETER: Is Immersed Object
   Parameter Type = Logical
   Default = false
   Description = flag indicating if the object is an immersed solid.
 END

 PARAMETER: Is Permeable
   Parameter Type = Logical
   Default = true
   Description = flag indicating if the boundary object is permeable.
 END
 
 PARAMETER: Turbo Domain List
   Parameter Type = String List
   Local Type = top
   Remote Type = geometry
#   Default = /DOMAIN GROUP:All Domains
   Default = All Domains
   Description = The list of domains over which to define this object.
 END

 PARAMETER: Component List
   Parameter Type = String List
   Description = The list of components for a domain. This is the initial \
                 'turbo' component list set by engine. Because a user \
                 can manually tag a component as turbo or non-turbo, \
                 the real turbo component list is given by \
                 ('Component List' - 'Components to Ignore').
 END

 PARAMETER: Components to Ignore
   Parameter Type = String List
   Description = The list of components that are tagged as non-turbo \
                 components. This a subset of 'Component List'.
 END

 PARAMETER: Initialized Components
   Parameter Type = String List
   Description = The list of components that have been initialized as turbo components. 
 END

 PARAMETER: Failed Components
   Parameter Type = String List
   Description = The list of components that have failed turbo initialization. 
 END

 PARAMETER: Components to Initialize
   Parameter Type = String List
   Local Type = turbo
   Description = The list of components to initialize for a domain. 
 END

 PARAMETER: Components to Update
   Parameter Type = String List 
   Local Type = turbo
   Description = The list of components to be initialized or updated. \
                 This list is used only by GUI for component initialization \
                 using popup menu or by apply/initialize button. \
                 It precede 'Components to Initialize',
 END

 PARAMETER: File Is Turbo
   Parameter Type = Logical
   Default = false
   Description = Internal parameter indicating whether it is a turbo problem.
 END

 PARAMETER: Load Domain Geometry On Demand
   Parameter Type = Logical
   Default = false
   Description = Internal parameter for domain geometry access option.
 END

 PARAMETER: File Has Multiple Configurations
   Parameter Type = Logical
   Default = false
   Description = Internal parameter indicating whether it is \
                 multi-configuration file
 END

 PARAMETER: Case Is Transient
   Parameter Type = Logical
   Default = false
   Description = Internal parameter indicating whether a case is transient.
 END

 PARAMETER: Turbo Variable Type
   Parameter Type = String
   Allowed String List = Not Turbo, Turbo, Cylindrical
   Default = Not Turbo
   Description = Internal parameter specifying the turbo type of a variable. 
 END


 PARAMETER: Domain Type
   Parameter Type = String
   Local Type = turbo
   Allowed String List = Normal, Axisymmetric, Turbo Component
   Default = Normal
   Description = The type of the domain. For types other than \
      Normal, additional geometric variables will be generated.
 END

PARAMETER: Current Rotation Axis From
   Parameter Type = Real List
   Default = 0.0, 0.0, 0.0
   Description = An XYZ triple defining the first point of the \
        rotation axis used currently in this domain.
END

PARAMETER: Current Rotation Axis To
   Parameter Type = Real List
   Default = 0.0, 0.0, 1.0
   Description = An XYZ triple defining the second point of the \
        rotation axis used currently in this domain.
END

 PARAMETER: Hub Region
    Parameter Type = String List
    Local Type = turbo
    Description = A comma delimited list of locator names.
 END

 PARAMETER: Shroud Region
    Parameter Type = String List
    Local Type = turbo
    Description = A comma delimited list of locator names.
 END

 PARAMETER: Inlet Region
    Parameter Type = String List
    Local Type = turbo
    Description = A comma delimited list of locator names.
 END

 PARAMETER: Outlet Region
    Parameter Type = String List
    Local Type = turbo
    Description = A comma delimited list of locator names.
 END

 PARAMETER: Periodic 1 Region
    Parameter Type = String List
    Local Type = turbo
    Description = A comma delimited list of locator names.
 END

 PARAMETER: Periodic 2 Region
    Parameter Type = String List
    Local Type = turbo
    Description = A comma delimited list of locator names.
 END

 PARAMETER: Turbo 360 Case without Periodics
   Parameter Type = Logical
   Default = false
   Local Type = turbo
   Description = A domain parameter indicating a 360 case without \
                 periodic regions. If true, engine will create an \
                 internal cut plane through axis and intersect \
                 it with other regions to generate background \
                 mesh outline.
 END

 PARAMETER: Blade Region
    Parameter Type = String List
    Local Type = blade
    Description = A comma delimited list of locator names.
 END

 PARAMETER: LE BA Location
   Parameter Type = Real
   Default = 0.0
   Description = blade leading edge position in terms of the \
                 BA Streamwise Location variable.
 END

 PARAMETER: TE BA Location
   Parameter Type = Real
   Default = 0.0
   Description = blade trailing edge position in terms of the \
                 BA Streamwise Location variable.
 END

 PARAMETER: Angular Velocity
   Parameter Type = Real
   Default = 0.0
   Description = The rotational speed of a DOMAIN described by DOMAIN MOTION
 END

 PARAMETER: Solid Motion Angular Velocity
   Parameter Type = Real
   Default = 0.0
   Description = The rotational speed of a solid DOMAIN described by SOLID MOTION
 END

 PARAMETER: Axis From File
   Parameter Type = String
   Allowed String List = From File, Custom
   Local Type = cylindrical
   Default = From File
   Description = Parameter indicating if axis of rotation is \
                 defined in the res file, or is a custom definition.
 END

 PARAMETER: Instance Definition
   Parameter Type = String
   Allowed String List = From File, Custom
   Local Type = instance
   Default = From File
   Description = Logical parameter indicating if instances and passages info is \
                 defined in the res file.
 END

 PARAMETER: Hub Curve Mode
    Parameter Type = String
    Allowed String List = From Turbo Region, From Line
    Default = From Turbo Region
    Local Type = turbo
    Description = The type of line used to define Hub curve. The Hub line \
        is needed for calculation of the Background Mesh. By default \
        it is calculated from the corresponding Hub Region(s), but optionally \
        it can be defined via a line or a polyline. 
 END

 PARAMETER: Hub Line Object
    Parameter Type = String List
    Local Type = turbo
    Remote Type = geometry
    Description = Specifies the line object(s) to be used for the definition \
        of the Hub curve. This parameter is used when Hub Curve Mode is set \
        to From Line.
 END

 PARAMETER: Shroud Curve Mode
    Parameter Type = String
    Allowed String List = From Turbo Region, From Line
    Default = From Turbo Region
    Local Type = turbo
    Description = The type of line used to define Shroud curve. The Shroud line \
        is needed for calculation of the Background Mesh. By default \
        it is calculated from the corresponding Shroud Region(s), but optionally \
        it can be defined via a line or a polyline. 
 END

 PARAMETER: Shroud Line Object
    Parameter Type = String List
    Local Type = turbo
    Remote Type = geometry
    Description = Specifies the line object(s) to be used for the definition \
        of the Shroud curve. This parameter is used when Shroud Curve Mode is set \
        to From Line.
 END

 PARAMETER: Inlet Curve Mode
    Parameter Type = String
    Allowed String List = From Turbo Region, From Line
    Default = From Turbo Region
    Local Type = turbo
    Description = The type of line used to define Inlet curve. The Inlet line \
        is needed for calculation of the Background Mesh. By default \
        it is calculated from the corresponding Inlet Region(s), but optionally \
        it can be defined via a line or a polyline. 
 END

 PARAMETER: Inlet Line Object
    Parameter Type = String List
    Local Type = turbo
    Remote Type = geometry
    Description = Specifies the line object(s) to be used for the definition \
        of the Inlet curve. This parameter is used when Inlet Curve Mode is set \
        to From Line.
 END

 PARAMETER: Outlet Curve Mode
    Parameter Type = String
    Allowed String List = From Turbo Region, From Line
    Default = From Turbo Region
    Local Type = turbo
    Description = The type of line used to define Outlet curve. The Outlet line \
        is needed for calculation of the Background Mesh. By default \
        it is calculated from the corresponding Outlet Region(s), but optionally \
        it can be defined via a line or a polyline. 
 END

 PARAMETER: Outlet Line Object
    Parameter Type = String List
    Local Type = turbo
    Remote Type = geometry
    Description = Specifies the line object(s) to be used for the definition \
        of the Outlet curve. This parameter is used when Outlet Curve Mode is set \
        to From Line.
 END

 PARAMETER: Background Mesh Generation Method
   Parameter Type = String
   Allowed String List = Linear, Quasi Orthogonal
   Default = Quasi Orthogonal
   Local Type = turbo
   Description = The method that TurboTransform module will use to \
                 generate the background mesh
 END

 PARAMETER: Background Mesh Density
   Parameter Type = Integer
   Local Type = turbo
   Default = 2000
   Description = background mesh density for turbo component
 END

 PARAMETER: Is Rotating
   Parameter Type = Logical
   Default = false
   Description = flag indicating if the domain is rotating.
 END

 PARAMETER: UpStream Domain
   Parameter Type = String
   Description = upstream domain for the domain.
 END

 PARAMETER: DownStream Domain
   Parameter Type = String
   Description = downstream domain for the domain.
 END

 PARAMETER: TBR Number of Modes
   Parameter Type = Integer
   Description = Number of Fourier Coefficients
 END

 PARAMETER: TBR Pitch Instancing
   Parameter Type = Float
   Description = Pitch for Instancing
 END
 
 PARAMETER: TBR Theta Correction
   Parameter Type = Float
   Description = Theta correction 
 END

 PARAMETER: TBR User Theta Correction
   Parameter Type = Float
   Default = 0.0
   Local Type = tbrtransform
   Description = TBR User Theta Correction to provide pseudo TBR Passage control.
 END
 
 PARAMETER: TBR Period
   Parameter Type = String List
   Description = Period for Domain
 END

 PARAMETER: TBR Phase Factor
   Parameter Type = Float List
   Description = Correction Factor for Phase
 END

 PARAMETER: TBR Instancing Factor
   Parameter Type = Float
   Description = Correction Factor for Instancing
 END

 PARAMETER: TBR Time Lag
   Parameter Type = String List
   Description = Time Lag
 END

 PARAMETER: TBR Variable List
   Parameter Type = String List
   Description = Related TBR variables
 END

 PARAMETER: Reference Pressure
   Parameter Type = Real
   Default = 0.0 
   Description = reference pressure for a domain
 END

 PARAMETER: Do Cylindrical Initialization
   Parameter Type = Logical
   Default = false
   Description = flag indicating whether cylindrical initialization will \
                 be performed on the domain.
 END

 PARAMETER: Is TBR Flutter Domain
   Parameter Type = Logical
   Default = false
   Description = flag indicating a TBR domain with mesh displacement
 END

 PARAMETER: Is Turbo Config Domain
   Parameter Type = Logical
   Default = true
   Description = flag indicating a turbo configuration domain.
 END

 PARAMETER: Zero Theta Point
   Parameter Type = Real List
   Default = 0.0, 0.0, 0.0
   Parameter Category = Position
   Description = A point which defines the reference potion for theta variable.
 END
 
 PARAMETER: Is Zero Theta Point Defined
   Parameter Type = Logical
   Default = false
   Description = flag indicating if Zero Theta Point has been defined.
 END

 PARAMETER: Ignore Theta Offset
   Parameter Type = Logical
   Default = true
   Description = flag indicating whether the calculated theta value will be \
               offset against the global min.
 END


############# END OF TURBO VARIABLES


########################## TURBO SURFACE AND LINE ##########################

 OBJECT: TURBO SURFACE
   CCLObject Class = TurboGeometricCCLObject
   Category = point, surface, plane, deletable, constant-colour, \
              geometry, domain-dependent, selectable, \
              viewer-viewable, has-variable, has-variable-colour, \
              edge-based, turbo-object, mesh-density, quick-editable, \
              quick-animatable, has-local-variable, suspendable
   Scheduler = top, geometry, circ average, colour, render
   Scheduler Links = top, geometry, geometry, circ average, circ average, colour, colour, render
   Calculate Function = top, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        geometry, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        circ average, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        colour, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        render, turbosurfacecalc, TurboSurfaceCalcFunc
   Essential Parameter List = Option
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Turbo Domain List, Colour Scale, \
                             Colour Mode, Colour, Colour Variable, Colour Map, \
                             Colour Variable Boundary Values, \
                             Circumferential Average Mode, \
                             Maximum Number of Sampling Points, \
                             Range, Min, Max, \
                             Visibility, Transparency, Draw Faces, \
                             Surface Drawing, Draw Lines, \
                             Line Width, Line Colour, Line Colour Mode, \
                             Surface Type, Surface Bound, \
                             Streamwise Min, Streamwise Max, \
                             Theta Min, Theta Max, \
                             Span Min, Span Max, \
                             Streamwise Points, Theta Points, Span Points, \
                             Axial Points, Radial Points, \
                             Invert Surface Bound, \
                             Lighting, Specular Lighting, Culling Mode, \
                             Instancing Transform, Apply Instancing Transform, \
                             Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture, Related Variable List

   Internal Parameter List = Local Variable Ranges, \
                             Override CA Params, CA Mode Override, CA Variable Override, \
                             Update CA Variable CCL

#  Methods
   Allowed Option List = Constant Span, \
                       Constant Streamwise Location, \
                       Constant Blade Aligned, \
                       Constant Blade Aligned Linear, \                
                       Constant Theta, \  
                       Cone
   CONTEXT: Constant Streamwise Location
     Optional Parameter List = Streamwise Location 
   END
   CONTEXT: Constant Blade Aligned
     Optional Parameter List = Streamwise Location
   END
   CONTEXT: Constant Blade Aligned Linear
     Optional Parameter List = Streamwise Location
   END
   CONTEXT: Constant Theta
     Optional Parameter List = Theta, Theta Surface Variable
   END
   CONTEXT: Constant Span
     Optional Parameter List = Span
   END
   CONTEXT: Cone
     Optional Parameter List = Point Coord System, Point 1, Point 2, Clip Cone
   END
   Allowed Parent List = ROOT
   Description = A locator generated by the surface of a constant turbo coordinate.
   
   PARAMETER: Colour Variable
     Local Type = circ average
   END
   PARAMETER: Colour Variable Boundary Values
     Local Type = circ average
   END
   PARAMETER: Colour Mode
     Local Type = circ average
   END

 END

 OBJECT: INTERNAL TURBO SURFACE
   CCLObject Class = TurboGeometricCCLObject
   Category = point, surface, plane, deletable, constant-colour, \
              geometry, domain-dependent, \
              viewer-viewable, has-variable, has-variable-colour, \
              edge-based, turbo-object, mesh-density, quick-editable, \
              has-local-variable, has-local-legend, suspendable
   Scheduler = top, geometry, circ average, colour, render
   Scheduler Links = top, geometry, geometry, circ average, circ average, colour, colour, render
   Calculate Function = top, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        geometry, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        circ average, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        colour, turbosurfacecalc, TurboSurfaceCalcFunc, \
                        render, turbosurfacecalc, TurboSurfaceCalcFunc
   Essential Parameter List = Option
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Turbo Domain List, Colour Scale, \
                             Colour Mode, Colour, Colour Variable, Colour Map, \
                             Colour Variable Boundary Values, \
                             Circumferential Average Mode, \
                             Maximum Number of Sampling Points, \
                             Range, Min, Max, \
                             Visibility, Transparency, Draw Faces, \
                             Surface Drawing, Draw Lines, \
                             Line Width, Line Colour, Line Colour Mode, \
                             Surface Type, Surface Bound, \
                             Streamwise Min, Streamwise Max, \
                             Theta Min, Theta Max, \
                             Span Min, Span Max, \
                             Streamwise Points, Theta Points, Span Points, \
                             Axial Points, Radial Points, \
                             Invert Surface Bound, \
                             Lighting, Specular Lighting, Culling Mode, \
                             Instancing Transform, Apply Instancing Transform, \
                             Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture, \
                              Turbo View Plot Type, Related Variable List

   Internal Parameter List = Local Variable Ranges, \
                             Override CA Params, CA Mode Override, CA Variable Override, \
                             Update CA Variable CCL

#  Methods
   Allowed Option List = Constant Span, \
                       Constant Streamwise Location, \
                       Constant Blade Aligned, \
                       Constant Blade Aligned Linear, \                
                       Constant Theta, \  
                       Cone
   CONTEXT: Constant Streamwise Location
     Optional Parameter List = Streamwise Location
   END
   CONTEXT: Constant Blade Aligned
     Optional Parameter List = Streamwise Location
   END
   CONTEXT: Constant Blade Aligned Linear
     Optional Parameter List = Streamwise Location
   END
   CONTEXT: Constant Theta
     Optional Parameter List = Theta, Theta Surface Variable
   END
   CONTEXT: Constant Span
     Optional Parameter List = Span
   END
   CONTEXT: Cone
     Optional Parameter List = Point Coord System, Point 1, Point 2, Clip Cone
   END
   Allowed Parent List = ROOT
   Description = A locator generated by the surface of a constant turbo coordinate \
        (internal version).

   PARAMETER: Colour Variable
     Local Type = circ average
   END
   PARAMETER: Colour Variable Boundary Values
     Local Type = circ average
   END
   PARAMETER: Colour Mode
     Local Type = circ average
   END
 END

 OBJECT: TURBO LINE
   CCLObject Class = TurboLineCCLObject
   Category = point, line, line-only, deletable, constant-colour, \
              geometry, domain-dependent, selectable, \
              viewer-viewable, has-variable, has-variable-colour, \
              has-local-variable, turbo-object, suspendable
   Scheduler = top, geometry, circ average, colour, render
   Scheduler Links = top, geometry, geometry, circ average, circ average, colour, colour, render
   Essential Parameter List = Option
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Turbo Domain List, Colour Scale, \
                             Colour Mode, Colour, Colour Variable, Colour Map, \
                             Colour Variable Boundary Values, \
                             Visibility, Range, Min, Max, \
                             Line Width, Line Colour, \
                             Line Type, Line Bound, \
                             Circumferential Average Mode, \
                             Maximum Number of Sampling Points, \
                             Reduction or Max Number, \
                             Reduction Factor, \
                             Maximum Number of Items, \
                             Streamwise Min, Streamwise Max, \
                             Theta Min, Theta Max, \
                             Span Min, Span Max, \
                             Streamwise Points, Theta Points, Span Points, \
                             Invert Line Bound, \
                             Instancing Transform, Apply Instancing Transform, \
                             Related Variable List

   Internal Parameter List = Local Variable Ranges, \
                             Override CA Params, CA Mode Override, CA Variable Override, \
                             Update CA Variable CCL

#  Methods
   Allowed Option List = Inlet to Outlet, Hub to Shroud, Circumferential
   CONTEXT: Inlet to Outlet
     Optional Parameter List = Span, Theta
   END
   CONTEXT: Hub to Shroud
     Optional Parameter List = Turbo Line Mode, Streamwise Location, \
        Theta, Point Type, Point 1, Point 2, Position 1, Position 2, \
        Point Distribution Method, Include Boundary Points
   END
   CONTEXT: Circumferential
     Optional Parameter List = Span, Streamwise Location
   END
   Allowed Parent List = ROOT
   PARAMETER: Line Width
     Default = 2
   END
   Description = A locator defined by two constant turbo coordinate

   PARAMETER: Colour Variable
     Local Type = circ average
   END
   PARAMETER: Colour Variable Boundary Values
     Local Type = circ average
   END
   PARAMETER: Colour Mode
     Local Type = circ average
   END
 END

 OBJECT: INTERNAL TURBO LINE
   CCLObject Class = TurboLineCCLObject
   Category = point, line, line-only, deletable, constant-colour, \
              geometry, domain-dependent, \
              viewer-viewable, has-variable, has-variable-colour, \
              has-local-variable, turbo-object, has-local-legend, suspendable
   Scheduler = top, geometry, circ average, colour, render
   Scheduler Links = top, geometry, geometry, circ average, circ average, colour, colour, render
   Essential Parameter List = Option
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Turbo Domain List, Colour Scale, \
                             Colour Mode, Colour, Colour Variable, Colour Map, \
                             Colour Variable Boundary Values, \
                             Visibility, Range, Min, Max, \
                             Line Width, Line Colour, \
                             Line Type, Line Bound, \
                             Circumferential Average Mode, \
                             Maximum Number of Sampling Points, \
                             Reduction or Max Number, \
                             Reduction Factor, \
                             Maximum Number of Items, \
                             Streamwise Min, Streamwise Max, \
                             Theta Min, Theta Max, \
                             Span Min, Span Max, \
                             Streamwise Points, Theta Points, Span Points, \
                             Invert Line Bound, \
                             Instancing Transform, Apply Instancing Transform, \
                             Related Variable List

  Internal Parameter List = Local Variable Ranges, \
                             Override CA Params, CA Mode Override, CA Variable Override, \
                             Update CA Variable CCL

#  Methods
   Allowed Option List = Inlet to Outlet, Hub to Shroud, Circumferential
   CONTEXT: Inlet to Outlet
     Optional Parameter List = Span, Theta
   END
   CONTEXT: Hub to Shroud
     Optional Parameter List = Turbo Line Mode, Streamwise Location, \
        Theta, Point Type, Point 1, Point 2, Position 1, Position 2, \
        Point Distribution Method, Include Boundary Points
   END
   CONTEXT: Circumferential
     Optional Parameter List = Span, Streamwise Location
   END
   Allowed Parent List = ROOT
   PARAMETER: Line Width
     Default = 2
   END
   Description = A locator defined by two constant turbo coordinate (internal version)

   PARAMETER: Colour Variable
     Local Type = circ average
   END
   PARAMETER: Colour Variable Boundary Values
     Local Type = circ average
   END
   PARAMETER: Colour Mode
     Local Type = circ average
   END
 END

 #### turbo variables for turbo surface and line:       

 PARAMETER: Streamwise Location
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.5
   Description = The normalized M' turbo coordinate value for the \
                  location of this object.
 END

 PARAMETER: Theta
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.0 [degree]
   Description = The Theta coordinate value for the location of this object.
 END

 PARAMETER: Span
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.5
   Description = The normalized Span turbo coordinate value for the \
                  location of this object.
 END

 # dummy variable used to establish a link between turbo constant theta
 # surface and the theta variable which is used in the surface creation
 PARAMETER: Theta Surface Variable
   Parameter Type = String
   Local Type = top
   Remote Type = top
   Default = Theta
   Description = The name of the variable used to create turbo constant theta surface.
 END
 
 PARAMETER: Streamwise Points
   Parameter Type = Integer
   Local Type = top
   Remote Type = expression
   Default = 10
   Description = Number of Sample points in M direction (turbo coordinate).
 END

 PARAMETER: Theta Points
   Parameter Type = Integer
   Local Type = top
   Remote Type = expression
   Default = 10
   Description = Number of Sample points in T direction (turbo coordinate).
 END

 PARAMETER: Span Points
   Parameter Type = Integer
   Local Type = top
   Remote Type = expression
   Default = 10
   Description = Number of Sample points in S direction (turbo coordinate).
 END

 PARAMETER: Axial Points
   Parameter Type = Integer
   Local Type = top
   Remote Type = expression
   Default = 10
   Description = Number of Sample points in Axial direction (AR coordinate).
 END

 PARAMETER: Radial Points
   Parameter Type = Integer
   Local Type = top
   Remote Type = expression
   Default = 10
   Description = Number of Sample points in Radial direction (AR coordinate).
 END

 PARAMETER: Streamwise Min
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.0
   Description = Lower bound of M' coordinate for a turbo surface.
 END

 PARAMETER: Streamwise Max
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 1.0
   Description = Upper bound of M' coordinate for a turbo surface.
 END

 PARAMETER: Theta Min
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0 [degree]
   Description = Lower bound of Theta coordinate for the surface.
 END

 PARAMETER: Theta Max
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 360 [degree]
   Description = Upper bound of Theta coordinate for the surface.
 END

 PARAMETER: Span Min
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.0
   Description = Lower bound of Span coordinate for a turbo surface.
 END

 PARAMETER: Span Max
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 1.0
   Description = Upper bound of Span coordinate for a turbo surface.
 END
                              
 PARAMETER: Turbo View Plot Type
   Allowed String List = Outline, Colour, Contour, Vector, Stream
   Parameter Type = String
   Default = Colour
   Description = Plot types for B2B and Meridional plots in Turbo View.
 END

 PARAMETER: Point Coord System
   Allowed String List = Cartesian, Cylindrical
   Parameter Type = String
   Local Type = top
   Default = Cartesian
   Description = Specifies the coordinate system in which the points are specified.
 END

 PARAMETER: Clip Cone
   Parameter Type = Logical
   Local Type = top
   Default = On
   Description = Enables/disables clipping in a cone surface
 END

 PARAMETER: Surface Type
   Parameter Type = String
   Local Type = top
   Allowed String List = Slice, Sample
   Default = Slice
   Description = Indicates if the surface is a slice or sample surface.
 END

 PARAMETER: Turbo Line Mode
   Parameter Type = String
   Allowed String List = Two Points Linear, Streamwise Location, \
                       Blade Aligned Linear, Blade Aligned
   Default = Streamwise Location
   Local Type = top
   Description = The method of generation of 'Hub to Shroud'  Turbo Line
 END

 PARAMETER: Point Type
   Parameter Type = String
   Allowed String List = AR, XYZ, \
                  Blade Aligned Linear, Streamwise Location
   Default = AR
   Local Type = top
   Description = The definition method for 'Hub to Shroud' Turbo Line \
               under the option of 'Two Points Linear'.
 END

 PARAMETER: Maximum Number of Sampling Points
   Parameter Type = Integer
   Default = 20
   Local Type = circ average
   Description = Specifies the maximum number of sampling points for \
                 circumferential averaging.
 END

 PARAMETER: Include Boundary Points
   Parameter Type = Logical
   Local Type = top
   Default = On
   Description = If true, place end points on range limits for a hub to \
               shroud line.
 END

 PARAMETER: Point Distribution Method
   Parameter Type = String
   Allowed String List = Equal Distance, Equal Mass Flow, Equal Area, \
                         Mesh Density Based 
   Local Type = top
   Default = Equal Distance
   Description = method used to distribute points along the hub to shroud line.
 END

 PARAMETER: Circumferential Average Mode
   Parameter Type = String
   Allowed String List = None, Length, Area, Mass
   Local Type = circ average
   Default = None
   Description = method used to calculate circumferential average for \
                 colouring variable on a turbo object
 END

 PARAMETER: CA Mode Override
   Parameter Type = String
   Allowed String List = None, Length, Area, Mass
   Default = None
   Description = method used to calculate circumferential average on \
                 a turbo surface (internal parameter).
 END

 PARAMETER: CA Variable Override
   Parameter Type = String
   Local Type = colour
   Remote Type = top
   Description = The name of the variable to be used in circumferential \
                 averaging (internal parameter).
 END

 PARAMETER: Override CA Params
   Parameter Type = Logical
   Default = Off
   Description = flag used to calculate circumferential average on \
                 a turbo surface (internal parameter).
 END

 PARAMETER: Update CA Variable CCL
   Parameter Type = Logical
   Default = On
   Description = flag used to update local circumferential average \
                 variable ccls on a turbo geometry.
 END
                             

############# END OF TURBO SURFACE AND LINE:



############ SESSION AND STATE PARAMETERS:

PARAMETER: Session Filename
  Parameter Type = String
  Default = session.cse
  Description = The name of the session file to which session data will be saved.
END

PARAMETER: Write Session Mode
  Parameter Type = String
  Default = None
  Allowed String List = None, Overwrite, Append
  Description = This parameter indicates whether the session file \
                should be overwritten or appended to if it exists.
END

PARAMETER: State Filename
  Parameter Type = String
  Default = state.cst
  Description = The name of the state file to which state data will be saved.
END

PARAMETER: Save State Mode
  Parameter Type = String
  Default = None
  Allowed String List = None, Overwrite
  Description = This parameter indicates whether the state file \
                should be overwritten if it exists.
END

PARAMETER: Save State Objects
  Parameter Type = String List
  Description = A list of objects to save to the state file.  If this list is \
        empty, then all user created objects will be saved.
END

PARAMETER: Read State Mode
  Parameter Type = String
  Default = Overwrite
  Allowed String List = Overwrite, Append
  Description = This parameter indicates whether the current system state \
                information should be overwritten or appended to.
END

PARAMETER: Load Data
  Parameter Type = Logical
  Default = True
  Description = This parameter indicates whether to load the results file \
                or not if a DATA READER object exists in the STATE File \
                for a READSTATE action.
END

PARAMETER: Keep Results Expressions
  Parameter Type = Logical
  Default = True
  Description = Indicates whether to preserve the expressions from the currently \
                loaded result file(s) when loading the state.
END


########### REPORTING ADDITIONS:

PARAMETER: Generation
  Parameter Type = String
  Allowed String List = Automatic, Manual
  Default = Manual
  Description = Specifies whether this object is generated Manually \
                        or Automatically.
END
PARAMETER: Automatic Item
  Parameter Type = String
  Default = None
  Allowed String List = None, File Information Table, Mesh Information Table, Mesh Statistics Table, \
                Domain Physics Table, Boundary Physics Table, \
                Boundary Flow Table, Force And Torque Table
  Description = Specifies which of the automatic items this particular \
                Object should display.
END
# TO BE ADDED IN THE FUTURE:
#               Particle Forces Table, Particle Momentum Flows Table
#               Setup Summary Table, Iteration Data Table, \
#               Results Summary Table, Convergence Chart, Monitor Points Chart, \
#               Mesh Quality Figure, Boundary Conditions Figure, \
#               Error Estimation Figure
PARAMETER: Associated Case Name
  Parameter Type = String
  Description = Specifies the case associated with this particular autogenerated object.
END
PARAMETER: Report Caption
  Parameter Type = String
  Default =
  Description = Specifies the caption to place under a Chart or View image \
                in a Report.
END
SINGLETON: OBJECT REPORT OPTIONS
  CCLObject Class = GenericCCLObject
  Category = selectable, suspendable
  Scheduler = top
  Allowed Parent List = CHART, VIEW, TABLE
  Optional Parameter List = Generation, Automatic Item, Associated Case Name, Report Caption
  Description = Defines options for the Report, specific to each object.
END

########### X-Y Plotting Parameters:


#############################
# The CHART parameters are: #
#############################

PARAMETER: Chart Title
  Parameter Type = String
  Default = Title
  Local Type = render
  Description = Specifies the title for the chart.
END

PARAMETER: Chart Title Visibility
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Specifies whether the Chart Title should be displayed.
END


PARAMETER: Chart Type
  Parameter Type = String
  Default = XY
  Allowed String List = XY, Time, Histogram
  Local Type = top
  Description = Specifies the kind of chart to create - either XY, Time, or Histogram.
END

PARAMETER: Chart Axes
  Parameter Type = String
  Default = Both
  Allowed String List = None, X Only, Y Only, Both
  Local Type = render
  Description = Indicates whether the X=0 or Y=0 lines should be \
                displayed on the chart. Neither, either or both may be \
                displayed.
END

PARAMETER: Use Data For X Axis Labels
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Boolean indicating whether to use the line axis data as the \
                X axis labels. (e.g. When plotting Pressure vs. X, the axis labels \
                would be Pressure and X.)
END

PARAMETER: Use Data For Y Axis Labels
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Boolean indicating whether to use the line axis data as the \
                Y axis labels.
END

PARAMETER: Chart X Axis Label
  Parameter Type = String
  Default = X Axis <units>
  Local Type = render
  Description = The label to use for the X-Axis. The <units> token will be replaced \
                with the X Axis units of the first line in the chart.
END

PARAMETER: Chart X Axis Automatic Number Formatting
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Parameter to display x axis numbers in an automatic format.
END

PARAMETER: Chart X Axis Number Format
  Parameter Type = String
  Local Type = render
  Default = %10.3e
  Description = Parameter to modify string format of values on the x axis.
END

PARAMETER: Chart Y Axis Label
  Parameter Type = String
  Default = Y Axis <units>
  Local Type = render
  Description = The label to use for the Y-Axis. The <units> token will be replaced \
                with the Y Axis units of the first line in the chart.
END

PARAMETER: Chart Y Axis Automatic Number Formatting
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Parameter to display y axis numbers in an automatic format.
END

PARAMETER: Chart Y Axis Number Format
  Parameter Type = String
  Local Type = render
  Default = %10.3e
  Description = Parameter to modify string format of values on the y axis.
END

PARAMETER: Chart Text Colour
  Parameter Type = String
  Default = White
  Allowed String List = Black, Red, Yellow, Green, Aquamarine, \
                        Pink, Wheat, Grey, Brown, Blue, Blueviolet, \
                        Cyan, Turquoise, Magenta, Salmon, White
  Local Type = render
  Description = The colour of the chart title and X & Y Axis Labels.  DEPRECATED
END

PARAMETER: Chart Viewport Colour
  Parameter Type = String
  Default = Yellow
  Allowed String List = Black, Red, Yellow, Green, Aquamarine, \
                        Pink, Wheat, Grey, Brown, Blue, Blueviolet, \
                        Cyan, Turquoise, Magenta, Salmon, White
  Local Type = render
  Description = The colour of the chart viewport including axes, tick marks, \
                and axis numbering.  DEPRECATED
END

PARAMETER: X Axis Automatic Range
  Parameter Type = Logical
  Default = True
  Local Type = top
  Description = Indicates whether the Min and Max X values shown \
                on the chart will be automatically (true) or manually \
                determined.
END

PARAMETER: Max X
  Parameter Type = Real
  Default = 1.0
  Local Type = top
  Description = If the 'X Axis Automatic Range' parameter is False, \
                this parameter will indicate the maximum X value \
                to display.
END

PARAMETER: Min X
  Parameter Type = Real
  Default = -1.0
  Local Type = top
  Description = If the 'X Axis Automatic Range' parameter is False, \
                this parameter will indicate the minimum X value \
                to display.
END

PARAMETER: X Axis Logarithmic Scaling
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to scale the X Axis linearly \
                or logarithmically.
END

PARAMETER: X Axis Inverted
  Parameter Type = Logical
  Default = False
  Local Type = render
  Description = Indicates whether to invert the X Axis
END

PARAMETER: Y Axis Automatic Range
  Parameter Type = Logical
  Default = True
  Local Type = top
  Description = Indicates whether the Min and Max Y values shown \
                on the chart will be automatically (true) or manually \
                determined.
END

PARAMETER: Max Y
  Parameter Type = Real
  Default = 1.0
  Local Type = top
  Description = If the 'Y Axis Automatic Range' parameter is False, \
                this parameter will indicate the maximum Y value \
                to display.
END

PARAMETER: Min Y
  Parameter Type = Real
  Default = -1.0
  Local Type = top
  Description = If the 'Y Axis Automatic Range' parameter is False, \
                this parameter will indicate the minimum Y value \
                to display.
END

PARAMETER: Y Axis Logarithmic Scaling
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to scale the Y Axis linearly \
                or logarithmically.
END

PARAMETER: Y Axis Inverted
  Parameter Type = Logical
  Default = False
  Local Type = render
  Description = Indicates whether to invert the Y Axis
END

PARAMETER: Chart Legend
  Parameter Type = Logical
  Default = True
  Local Type = render
  Description = Specifies whether a legend should be displayed or not.
END

PARAMETER: Chart Legend Inside
  Parameter Type = String
  Allowed String List = Outside Chart, Inside Chart
  Default = Outside Chart
  Local Type = render
  Description = Specifies whether a legend should be displayed or not.
END

PARAMETER: Chart Legend Position
  Parameter Type = String
  Allowed String List = Right, Left, Bottom, Top
  Default = Bottom
  Local Type = render
  Description = Specifies which side of the chart to place the legend.
END

PARAMETER: Chart Legend Justification
  Parameter Type = String
  Allowed String List = TopOrLeft, Center, BottomOrRight, None
  Default = Center
  Local Type = render
  Description = Specifies the justification of the legend items inside of legend.
END

PARAMETER: Chart Legend X Justification
  Parameter Type = String
  Allowed String List = Left, Center, Right, None
  Default = Right
  Local Type = render
  Description = Specifies the legend orientation inside of chart on x-axis.
END

PARAMETER: Chart Legend Y Justification
  Parameter Type = String
  Allowed String List = Top, Center, Bottom, None
  Default = Center
  Local Type = render
  Description = Specifies the legend orientation inside of chart on y-axis.
END

PARAMETER: Chart Legend XY Position
  Parameter Type = Real List
  Local Type = render
  Default = 0.73,0.275
  Description = Specifies the left-bottom corner of the legend.
END

PARAMETER: Chart Legend Width Height
  Parameter Type = Real List
  Local Type = render
  Default = 0.2,0.4
  Description = Specifies the width-height of the legend.
END

PARAMETER: Chart Title Font
  Parameter Type = String
  Default = Tahoma, 12, True, False, False, False
  Local Type = render
  Description = The font definition for the Chart Title. The parameter \
                is a comma delimited list of four items: Font Name, \
                Font Size, Bold (True or False), Italics (True or False), \
                Underline (True or False), Strike Out (True or False)
END

PARAMETER: Chart Axes Font
  Parameter Type = String
  Default = Tahoma, 10, False, False, False, False
  Local Type = render
  Description = The font definition for the Chart Axes. The parameter \
                is a comma delimited list of four items: Font Name, \
                Font Size, Bold (True or False), Italics (True or False), \
                Underline (True or False), Strike Out (True or False).
END

PARAMETER: Chart Axes Titles Font
  Parameter Type = String
  Default = Tahoma, 10, True, False, False, False
  Local Type = render
  Description = The font definition for the Chart Axes Titles. The parameter \
                is a comma delimited list of four items: Font Name, \
                Font Size, Bold (True or False), Italics (True or False), \
                Underline (True or False), Strike Out (True or False).
END

PARAMETER: Chart Legend Font
  Parameter Type = String
  Default = Tahoma, 8, False, False, False, False
  Local Type = render
  Description = The font definition for the Chart Legend. The parameter \
                is a comma delimited list of four items: Font Name, \
                Font Size, Bold (True or False), Italics (True or False), \
                Underline (True or False), Strike Out (True or False).
END

PARAMETER: Chart Line Width
  Parameter Type = Integer
  Default = 2
  Local Type = render
  Description = Defines the line width for the chart lines.
END

PARAMETER: Chart Symbol Size
  Parameter Type = Integer
  Default = 4
  Local Type = render
  Description = Defines the size of the chart symbols.
END

PARAMETER: Chart Horizontal Grid
  Parameter Type = Logical
  Default = True
  Local Type = render
  Description = Shows or hides the horizontal major grid.
END

PARAMETER: Chart Vertical Grid
  Parameter Type = Logical
  Default = True
  Local Type = render
  Description = Shows or hides the Vertical major grid.
END

PARAMETER: Chart Minor Grid
  Parameter Type = Logical
  Default = False
  Local Type = render
  Description = Shows or hides both Horizontal and Vertical Minor grid.
END

PARAMETER: Chart Grid Line Width
  Parameter Type = Integer
  Default = 1
  Local Type = render
  Description = Defines the line width for the major grid lines.
END

PARAMETER: Chart Minor Grid Line Width
  Parameter Type = Integer
  Default = 1
  Local Type = render
  Description = Defines the line width for the minor grid lines.
END

PARAMETER: Refresh Required
  Parameter Type = Logical
  Default = False
  Description = Internal Parameter used to indicate whether or not \
                this chart should be refreshed.
END

PARAMETER: Is FFT Chart
  Parameter Type = Logical
  Default = False
  Local Type = fft
  Description = Toggles if FFT should be run on the data.
END

PARAMETER: FFT Window Type
  Parameter Type = String
  Default = Hanning
  Local Type = fft
  Allowed String List = None, Barlett, Blackman, Hamming, Hanning
  Description = The window type to be used in processing signal data.
END

PARAMETER: FFT Full Input Range
  Parameter Type = Logical
  Default = True
  Local Type = fft
  Description = The data should be clipped to the specified range.
END

PARAMETER: FFT Min
  Parameter Type = Real
  Default = 0.0
  Local Type = fft
  Description = The minimum range value to clip fft signal by.
END

PARAMETER: FFT Max
  Parameter Type = Real
  Default = 0.0
  Local Type = fft
  Description = The maximum range value to clip fft signal by.
END

PARAMETER: FFT Subtract Mean
  Parameter Type = Logical
  Default = False
  Local Type = fft
  Description = Subtract the mean value of the signal data.
END

PARAMETER: FFT X Original Min Max
  Parameter Type = Real List
  Default = -1.0, 1.0
  Description = The min max of x axis values prior to processing.
END

PARAMETER: FFT X Function
  Parameter Type = String
  Default = Frequency
  Local Type = fft
  Allowed String List = Frequency, Fourier Mode, Octave Band Full, \
                        Octave Band Pref, One Third Full, One Third Pref, \
                        Strouhal Number
  Description = The x function to be applied to the FFT signal processing.
END

PARAMETER: FFT Y Function
  Parameter Type = String
  Default = Power Spectral Density
  Local Type = fft
  Allowed String List = Power Spectral Density, A Weighted, B Weighted, C Weighted, Sound Amplitude, \
                        Sound Pressure Level, Magnitude
  Description = The x function to be applied to the FFT signal processing.
END

# Histogram parameters
PARAMETER: Histogram Automatic Divisions
  Parameter Type = String
  Allowed String List = Automatic, User Defined
  Local Type = top
  Default = Automatic
  Description = Determines how to process the histogram bins.
END

PARAMETER: Histogram Divisions Count
  Parameter Type = Integer
  Default = 10
  Local Type = top
  Description = The number of divisions when automatically calculating \
                category histogram bins.
END

PARAMETER: Histogram Divisions
  Parameter Type = Real List
  Default = -1.0, 1.0
  Local Type = top
  Description = List of user defined category histogram bins.
END

PARAMETER: Histogram Y Axis Value
  Parameter Type = String
  Allowed String List = Count, Percentage
  Default = Count
  Local Type = top
  Description = Specifies how to calculate bin information.
END

PARAMETER: Default Histogram Y Axis Weighting
  Parameter Type = String
  Allowed String List = None, Geometrical, Mass Flow
  Default = None
  Local Type = top
  Description = Specifies how to calculate mesh bin information.
END

PARAMETER: Chart Print Base Width
  Parameter Type = Integer
  Default = 700
  Description = The image width for which the scaling is based on.
END

PARAMETER: Chart Print Base Height
  Parameter Type = Integer
  Default = 700
  Description = The image height for which the scaling is based on.
END

# Default params for Chart Line

PARAMETER: Default Chart X Variable
  Parameter Type = String
  Default = Chart Count
  Local Type = top
  Remote Type = top
  Description = Specifies the name of the X-Axis variable to chart.
END

PARAMETER: Default X Variable Boundary Values
  Parameter Type = String
  Allowed String List = Conservative, Hybrid
  Default = Conservative
  Local Type = top
  Description = Sets the type of boundary values to be used for the \
                X Axis variable (Conservative or Hybrid).
END

PARAMETER: Default X Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the X Axis data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Default Time Chart X Expression
  Parameter = Real
  Local Type = top
  Default = Time
  Remote Type = expression
  Description = Specifies the expression to evaluate at each timestep and plot in\
        the chart.
END

PARAMETER: Default Chart Y Variable
  Parameter Type = String
  Local Type = top
  Remote Type = top
  Description = Specifies the name of the Y-Axis variable to chart.
  Default = Pressure
END

PARAMETER: Default Y Variable Boundary Values
  Parameter Type = String
  Allowed String List = Conservative, Hybrid
  Default = Conservative
  Local Type = top
  Description = Sets the type of boundary values to be used for the \
                Y Axis variable (Conservative or Hybrid).
END

PARAMETER: Default Y Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the Y Axis data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Default Difference Line Calculation
  Parameter Type = String
  Allowed String List = From Variable, From Points
  Default = From Points
  Local Type = top
END

PARAMETER: Chart Lines Order
  Parameter Type = String List
  Local Type = render
  Description = List of line names that determines order.
END

PARAMETER: Default Time Chart Variable
  Parameter Type = String
  Local Type = top
  Remote Type = top
  Description = Specifies the name of the variable to track over time at the \
        specified point.
  Default = Pressure
END

PARAMETER: Default Time Variable Boundary Values
  Parameter Type = String
  Allowed String List = Conservative, Hybrid
  Default = Conservative
  Local Type = top
  Description = Sets the type of boundary values to be used for the \
                Time Chart variable (Conservative or Hybrid).
END

PARAMETER: Default Time Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the Time Variable data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Time Chart Keep Single Case
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = If true, then do not calculate time chart using multicase or comparison, \
                                if originally created in single case mode.
END

OBJECT: CHART
  CCLObject Class = ChartCCLObject
  Category = deletable, selectable, reportable, has-local-variable, suspendable
  Scheduler = top, fft, render
  Scheduler Links = top, fft, \
                    fft, render
  # TOP SCHEDULER PARAMETERS
  # VARIABLE SCHEDULER PARAMETERS
  # RENDER SCHEDULER PARAMETERS
  # NO SCHEDULER PARAMETERS
  Optional Parameter List = \
    Chart Type, \
    X Axis Automatic Range, \
    Max X, \
    Min X, \
    X Axis Logarithmic Scaling, \
    Y Axis Automatic Range, \
    Max Y, \
    Min Y, \
    Y Axis Logarithmic Scaling, \
    Histogram Automatic Divisions, \
    Histogram Divisions Count, \
    Histogram Divisions, \
    Histogram Y Axis Value, \
    Default Histogram Y Axis Weighting, \
    Time Chart Keep Single Case, \
    \
    Default Chart X Variable, \
    Default X Variable Boundary Values, \
    Default X Variable Absolute Value, \
    Default Chart Y Variable, \
    Default Y Variable Boundary Values, \
    Default Y Variable Absolute Value, \
    Default Time Chart X Expression, \
    Default Time Chart Variable, \
    Default Time Variable Boundary Values, \
    Default Time Variable Absolute Value, \
    Default Difference Line Calculation, \
    \
    Chart Title, \
    Chart Title Visibility, \
    Chart Axes, \
    Use Data For X Axis Labels, \
    Use Data For Y Axis Labels, \
    Chart X Axis Label, \
    Chart X Axis Automatic Number Formatting, \
    Chart X Axis Number Format, \
    Chart Y Axis Label, \
    Chart Y Axis Automatic Number Formatting, \
    Chart Y Axis Number Format, \
    Chart Text Colour, \
    Chart Viewport Colour, \
    X Axis Inverted, \
    Y Axis Inverted, \
    Chart Legend, \
    Chart Legend Inside, \
    Chart Legend Position, \
    Chart Legend Justification, \
    Chart Legend X Justification, \
    Chart Legend Y Justification, \
    Chart Legend XY Position, \
    Chart Legend Width Height, \
    Chart Title Font, \
    Chart Axes Font, \
    Chart Axes Titles Font, \
    Chart Legend Font, \
    Chart Line Width, \
    Chart Symbol Size, \
    Chart Horizontal Grid, \
    Chart Vertical Grid, \
    Chart Minor Grid, \
    Chart Grid Line Width, \
    Chart Minor Grid Line Width, \
    Is FFT Chart, \
    FFT Window Type, \
    FFT Full Input Range, \
    FFT Min, \
    FFT Max, \
    FFT Subtract Mean, \
    FFT X Function, \
    FFT Y Function, \
    Chart Lines Order, \
    \
    Chart Print Base Width, \
    Chart Print Base Height
    
  Internal Parameter List = \
    Refresh Required, \
    FFT X Original Min Max
  Allowed Parent List = ROOT
  Optional Child List = CHART SERIES, OBJECT REPORT OPTIONS

  Description = This object is used to create a chart and specify general \
        chart parameters, including the CHART LINE objects that \
        define the chart lines.
END

####################################
# The CHART SERIES parameters are: #
####################################

PARAMETER: Chart Series Type
  Parameter Type = String
  Allowed String List = Regular, From File, From Monitor Data
  Default = Regular
  Local Type = top
  Description = Indicates whether this line should be defined the regular way \
    (i.e. get data from a locator in the loaded file), or defined via data \
    from a file.
END

PARAMETER: Chart X Variable
  Parameter Type = String
  Default = Chart Count
  Local Type = top
  Remote Type = top
  Description = Specifies the name of the X-Axis variable to chart. \
                The default value of `Chart Count' indicates that the \
                X-Axis will be a locator point counter.
END

PARAMETER: X Variable Boundary Values
  Parameter Type = String
  Allowed String List = Conservative, Hybrid
  Default = Conservative
  Local Type = top
  Description = Sets the type of boundary values to be used for the \
                X Axis variable (Conservative or Hybrid).
END

PARAMETER: X Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the X Axis data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Chart Y Variable
  Parameter Type = String
  Local Type = top
  Remote Type = top
  Description = Specifies the name of the Y-Axis variable to chart.
END

PARAMETER: Y Variable Boundary Values
  Parameter Type = String
  Allowed String List = Conservative, Hybrid
  Default = Conservative
  Local Type = top
  Description = Sets the type of boundary values to be used for the \
                Y Axis variable (Conservative or Hybrid).
END

PARAMETER: Y Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the Y Axis data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Time Chart Type
  Parameter Type = String
  Allowed String List = Point, Expression
  Default = Point
  Local Type = top
  Description = Indicates the type of Time Chart to create - the options are 'Point'\
        which will track the value of a variable at that point over time, or 'Expression',\
        which must evaluate to a single value, and will be evaluated for each timestep.
END

PARAMETER: Time Chart Variable
  Parameter Type = String
  Local Type = top
  Remote Type = top
  Description = Specifies the name of the variable to track over time at the \
        specified point.
END

PARAMETER: Time Variable Boundary Values
  Parameter Type = String
  Allowed String List = Conservative, Hybrid
  Default = Conservative
  Local Type = top
  Description = Sets the type of boundary values to be used for the \
                Time Chart variable (Conservative or Hybrid).
END

PARAMETER: Time Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the Time Variable data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Time Chart X Expression
  Parameter = Real
  Default = Time
  Local Type = top
  Remote Type = expression
  Description = Specifies the expression to evaluate at each timestep and plot in\
        the chart.
END

PARAMETER: Time Chart Expression
  Parameter = Real
  Local Type = top
  Default = Time
  Remote Type = expression
  Description = Specifies the expression to evaluate at each timestep and plot in\
        the chart on the y axis.
END

PARAMETER: Time Chart Location
  Parameter = String
  Local Type = top
  Remote Type = geometry
  Description = Specifies the location to use for the Time Chart.
END

# Text Data File Related Parameters
PARAMETER: Chart Line Filename
  Parameter = String
  Local Type = top
  Description = Specifies the file from which to read the line data.
END

PARAMETER: File Data Section Name
  Local Type = top
  Parameter Type = String
  Description = The name of file section to read xy data from
END

PARAMETER: File Data X Variable
  Local Type = top
  Parameter Type = String
  Description = The name of variable to plot on the X Axis
END

PARAMETER: File Data Y Variable
  Local Type = top
  Parameter Type = String
  Description = The name of variable to plot on the Y Axis
END

PARAMETER: Chart Line Custom Data Selection
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = If true, use variable information stored in line object.
END

# Histogram related parameters

PARAMETER: Histogram Y Axis Weighting
  Parameter Type = String
  Allowed String List = None, Geometrical, Mass Flow
  Default = None
  Local Type = top
  Description = Specifies how to calculate mesh bin information.
END

# Monitor Data Related Parameters
PARAMETER: Monitor Data Source
  Local Type = top
  Parameter Type = String
  Allowed String List = File, Case
  Default = Case
  Description = Whether the monitor data is to be read from the case or filename
END

PARAMETER: Monitor Data Filename
  Local Type = top
  Parameter Type = String
  Description = The name of file from which the monitor data will be read
END

PARAMETER: Monitor Data X Variable
  Local Type = top
  Parameter Type = String
  Description = The name of variable to plot on the X Axis
END

PARAMETER: Monitor Data Y Variable
  Local Type = top
  Parameter Type = String
  Description = The name of variable to plot on the Y Axis
END

PARAMETER: Monitor Data X Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the X Axis data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Monitor Data Y Variable Absolute Value
  Parameter Type = Logical
  Default = False
  Local Type = top
  Description = Indicates whether to take the absolute value of \
                the Y Axis data before plotting the chart.  If plotting \
                a logarithmic chart, the minimum value will be \
                1e-100.
END

PARAMETER: Series Name
  Parameter Type = String
  Default = Series 1
  Local Type = render
  Description = The name of this chart line. This string will be used as \
                the label in the Legend if one is displayed.
END

PARAMETER: Results Set
  Parameter Type = String List
  Local Type = render
  Description = Specifies which result sets to use.
END

OBJECT: CHART SERIES
  CCLObject Class = ChartSeriesCCLObject
  Category = deletable, selectable, has-local-variable, suspendable
  Scheduler = top, render
  Scheduler Links = top, render

  # TOP SCHEDULER PARAMETERS:
  # RENDER SCHEDULER PARAMETERS:
  Optional Parameter List = \
    Location, \
    Chart Series Type, \
    Chart X Variable, \
    X Variable Boundary Values, \
    X Variable Absolute Value, \
    Chart Y Variable, \
    Y Variable Boundary Values, \
    Y Variable Absolute Value, \
    Time Chart Type, \
    Time Chart Variable, \
    Time Variable Boundary Values, \
    Time Variable Absolute Value, \
    Time Chart X Expression, \
    Time Chart Expression, \
    Time Chart Location, \
    Chart Line Filename, \
    File Data Section Name, \
    File Data X Variable, \
    File Data Y Variable, \
    Chart Line Custom Data Selection, \
    Histogram Y Axis Weighting, \
    Monitor Data Source, \
    Monitor Data Filename, \
    Monitor Data X Variable, \
    Monitor Data Y Variable, \
    Monitor Data X Variable Absolute Value, \
    Monitor Data Y Variable Absolute Value, \
    \
    Series Name, \
    Results Set

  Description = This object defines the variables to use for a chart line.
  Allowed Parent List = CHART
  Optional Child List = CHART LINE
END

##################################
# The CHART LINE parameters are: #
##################################

PARAMETER: Line Name
  Parameter Type = String
  Local Type = render
  Description = The name of this chart line. This string will be used as \
                the label in the Legend if one is displayed.
END

PARAMETER: Chart Line Style
  Parameter Type = String
  Default = Automatic
  Allowed String List = Automatic, None, Solid, Dash, Dot, Dash Dot, Dash Dot Dot
  Local Type = render
  Description = Specifies the line style to use.
END

PARAMETER: Chart Line Type
  Parameter Type = String
  Default = Lines
  Allowed String List = Lines, Bars, Steps
  Local Type = render
  Description = Specifies the line type to use for non-FFT charts.
END

PARAMETER: Chart FFT Line Type
  Parameter Type = String
  Default = Bars
  Allowed String List = Lines, Bars, Steps
  Local Type = render
  Description = Specifies the line type to use for FFT charts.
END

PARAMETER: Auto Chart Line Colour
  Parameter Type = Logical
  Default = True
  Local Type = render
  Description = Indicates whether to automatically choose the Line Colours or to \
        allow the user to manually select it.
END

PARAMETER: Chart Line Colour
  Parameter Type = Real List
  Local Type = render
  Default = 1.0, 0.0, 0.0
  Parameter Category = RGBColour
  Description = A list of three numbers between 0 and 1, which represent the \
              RGB (Red/Green/Blue) values to be used when colouring the Chart Line.
END

PARAMETER: Chart Symbol Style
  Parameter Type = String
  Default = None
  Allowed String List = None, Ellipse, Rectangle, Diamond, Triangle, Cross, XCross, \
            HLine, VLine, Star1, Star2, Hexagon
  Local Type = render
  Description = Specifies the symbol style to use.
END

PARAMETER: Chart Symbol Colour
  Parameter Type = Real List
  Local Type = render
  Default = 0.0, 1.0, 0.0
  Parameter Category = RGBColour
  Description = A list of three numbers between 0 and 1, which represent the \
              RGB (Red/Green/Blue) values to be used when colouring the Chart Symbol.
END

PARAMETER: Chart Line Visibility
  Parameter Type = Logical
  Default = True
  Local Type = render
  Description = Toggles the visibility of this chart line in the chart.
END

PARAMETER: Fill Area
  Parameter Type = Logical
  Default = True
  Local Type = render
  Description = Fill in the area under the curve depending on options.
END

PARAMETER: Fill Area Options
  Allowed String List = Automatic, Always On
  Default = Automatic
  Local Type = render
  Description = Determines how to process the fill area of line.
END

PARAMETER: Category Values
  Parameter Type = Real List
  Default = 0
  Description = Histogram information of the count values per bin.
END

PARAMETER: Is Valid
  Parameter Type = Logical
  Default = True
  Description = If False, then the line case name is no longer valid.
END

PARAMETER: Use Automatic Line Naming
  Parameter Type = Logical
  Default = True
  Description = If True, then the line name will be automatically generated.
END

# Output statistics values
PARAMETER: Statistics Min
  Parameter Type = Real List
  Default = 0
  Description = The stored value of the min value of the signal data.
END

PARAMETER: Statistics Max
  Parameter Type = Real List
  Default = 0
  Description = The stored value of the max value of the signal data.
END

PARAMETER: Statistics Mean
  Parameter Type = Real List
  Default = 0
  Description = The stored value of the mean value of the signal data.
END

PARAMETER: Statistics Variance
  Parameter Type = Real List
  Default = 0
  Description = The stored value of the variance value of the signal data.
END

# FFT Related Parameters

PARAMETER: FFT Peaks
  Parameter Type = Real List
  Default = 0
  Description = The list of peak points found during FFT signal processing.
END

OBJECT: CHART LINE
  CCLObject Class = ChartLineCCLObject
  Category = selectable, suspendable
  Scheduler = top, render
  Scheduler Links = top, render

  # TOP SCHEDULER PARAMETERS:
  # RENDER SCHEDULER PARAMETERS:
  # NO SCHEDULER PARAMETERS:
  Optional Parameter List = \
    Case Name, \
    \
    Line Name, \
    Chart Line Style, \
    Chart Line Type, \
    Chart FFT Line Type, \
    Auto Chart Line Colour, \
    Chart Line Colour, \
    Chart Symbol Style, \
    Chart Symbol Colour, \
    Chart Line Visibility, \
    Fill Area, \
    Fill Area Options, \
    \
    Category Values, \
    Is Valid, \
    Use Automatic Line Naming

  Internal Parameter List = \
    FFT Peaks, \
    Statistics Min, \
    Statistics Max, \
    Statistics Mean, \
    Statistics Variance
  Description = This object defines the line style, symbol style, \
        and colours to use for a chart line.
  Allowed Parent List = CHART SERIES
  PARAMETER: Case Name
    Local Type = top
  END
END

#---------------  PARTICLE TRACKS  ----------------------

PARAMETER: Track Filename
  Parameter Type = String
  Local Type = top
  Description = The path and filename of the Particle Track File to load.
END
PARAMETER: Reduction or Max Tracks
  Parameter Type = String
  Default = Max Tracks
  Allowed String List = Max Tracks, Reduction
  Local Type = top
  Description = This indicates whether to use 'Reduction Factor' to reduce the \
        number of tracks, or to use 'Maximum Number of Tracks'
END
PARAMETER: Maximum Number of Tracks
  Parameter Type = Integer
  Default = 25
  Local Type = top
  Description = Specifies the maximum number of tracks that should be displayed. \
        This parameter is mutually exclusive with the Reduction Factor Parameter.
END
PARAMETER: Track Material
  Parameter Type = String List
  Local Type = top
  Description = Specifies the material of the track for this object.
END
PARAMETER: Limit Track Option
  Parameter Type = String
  Default = Up To Current Timestep
  Allowed String List = Up To Current Timestep, Since Last Timestep, User Specified
  Local Type = top
  Description = Specifies how the tracks should be limited.
END
PARAMETER: Track Limit Type
  Parameter Type = String
  Allowed String List = Time, Distance
  Default = Time
  Local Type = top
  Description = Indicates whether to limit the portion of the track to be \
        displayed by time or by distance.
END
PARAMETER: Track Start Time
  Parameter Type = Real
  Local Type = top
  Remote Type = expression
  Description = The particle age at which to start drawing the track.
END
PARAMETER: Track End Time
  Parameter Type = Real
  Local Type = top
  Remote Type = expression
  Description = The particle age at which to stop drawing the track.
END
PARAMETER: Track Start Distance
  Parameter Type = Real
  Local Type = top
  Remote Type = expression
  Description = The particle travelling distance at which to start drawing the track.
END
PARAMETER: Track End Distance
  Parameter Type = Real
  Local Type = top
  Remote Type = expression
  Description = The particle travelling distance at which to stop drawing the track.
END
PARAMETER: Activate Filter
  Parameter Type = Logical
  Default = Off
  Local Type = top
  Description = A Logical field indicating whether to use the filter to select \
        which tracks to display.
END
PARAMETER: Filter On Start
  Parameter Type = Logical
  Default = Off
  Local Type = top
  Description = A Logical field indicating whether to use the \
    Starting Boundary when filtering.
END
PARAMETER: Starting Boundary
  Parameter Type = String List
  Local Type = top
  Description = A list of Boundary names to filter particle tracks that \
    start on the specified boundaries.
END
PARAMETER: Filter On End
  Parameter Type = Logical
  Default = Off
  Local Type = top
  Description = A Logical field indicating whether to use the \
    Ending Boundary when filtering.
END
PARAMETER: Ending Boundary
  Parameter Type = String List
  Local Type = top
  Description = A list of Boundary names to filter particle tracks that \
    end on the specified boundaries.
END
PARAMETER: Filter On Diameter
  Parameter Type = Logical
  Default = Off
  Local Type = top
  Description = A Logical field indicating whether to use \
    Particle Diameter when filtering.
END
PARAMETER: Particle Diameter
  Parameter Type = Real
  Local Type = top
  Description = The Particle Diameter to use in filtering tracks.
END
PARAMETER: Particle Diameter Condition
  Parameter Type = String
  Default = gt
  Allowed String List = gt, gte, lt, lte, eq
  Local Type = top
  Description = The condition to test for when filtering with Particle \
    Diameter. The values with their equivalent meanings are: \
    gt (>), gte (>=), lt (<), lte (<=), eq (==)
END
PARAMETER: Particle Diameter Two
  Parameter Type = Real
  Local Type = top
  Description = The Particle Diameter to use in filtering tracks.
END
PARAMETER: Particle Diameter Condition Two
  Parameter Type = String
  Default = NA
  Allowed String List = NA, gt, gte, lt, lte, eq
  Local Type = top
  Description = The condition to test for when filtering with Particle \
    Diameter. The values with their equivalent meanings are: \
    gt (>), gte (>=), lt (<), lte (<=), eq (==).  If this parameter is set\
    to NA, then this parameter is not applicable, and can be ignored.
END
PARAMETER: Filter On Track Selection
  Parameter Type = Logical
  Default = Off
  Local Type = top
  Description = A Logical field indicating whether to use the Track \
    Selection when filtering.
END
PARAMETER: Track Selection
  Parameter Type = String List
  Local Type = top
  Description = A string list containing a subset of track numbers to \
    select the tracks to display.
END
PARAMETER: Any All Condition
  Parameter Type = String
  Default = Match ALL
  Allowed String List = Match ANY, Match ALL
  Local Type = top
  Description = The way the Filtering conditions should be combined. \
    `Any' means that all tracks that meet any of the conditions will \
    be displayed. `All' means that only the tracks that meet all of the \
    conditions will be displayed.
END
PARAMETER: Draw Tracks
  Parameter Type = Logical
  Default = Yes
  Local Type = render
  Description = If false do not draw tracks, but allow drawing of symbols
END
PARAMETER: Symbol Max Time Selection
  Parameter Type = String
  Default = User Specified
  Local Type = render
  Allowed String List = User Specified, Current Time
  Description = Indicates how to determine the 'Symbol Start Time', either \
                allow the user to set the parameter, or use the current time.
END
PARAMETER: Track File Type
  Parameter Type = String
  Default = CFX4
  Allowed String List = CFX4, FLUENT
  Local Type = top
  Description = The type of file to read the particle tracks from. This is only \
        available if the Particle Track Option is 'From File'. \
        Currently supports CFX4 and FLUENT PT files.
END
PARAMETER: Injection ID List
  Parameter Type = String
  Local Type = top
  Description = Contains a list of the Injection IDs associated with this FLUENT\
    particle track object.
END
PARAMETER: Injection Filter
  Parameter Type = String
  Local Type = top
  Description = Contains a list of the Injection names that should be filtered for \
    in this FLUENT Particle Track object.
END
PARAMETER: Injection Filter List
  Parameter Type = String
  Description = Internal Parameter listing all available injections for FLUENT Particle Tracks
END
PARAMETER: Material
  Parameter Type = String
  Description = Specifies the type of material that this particle track \
        is made out of.  This parameter differentiates it from other particle \
        tracks stored in the same result file.
END
PARAMETER: Track Symbol
  Parameter Type = String
  Local Type = symbol
  Default = Ball
  Allowed String List = Crosshair, Octahedron, Cube, Ball, Arrow2D, Arrow3D, \
        Line Arrow, Arrowhead, Arrowhead3D, Fish3D
  Description = Name of streamline symbol to be used for plot.
END
PARAMETER: Symbol Size Option
  Parameter Type = String
  Allowed String List = Constant, Particle Diameter
  Default = Constant
  Local Type = symbol
  Description = Use this parameter to change how the the size of the particle track symbols is determined.
END
PARAMETER: Symbol Scale Type
  Parameter Type = String
  Allowed String List = Relative, Absolute
  Default = Relative
  Local Type = symbol
  Description = Indicates whether to scale the parameters in a relative or absolute manner.
END
PARAMETER: Track Size
  Parameter Type = Real
  Default = 1.0
  Local Type = colour
  Remote Type = expression
  Description = The initial width of stream ribbons or tubes
END
PARAMETER: Track Drawing Mode
  Parameter Type = String
  Allowed String List = Line, Tube, Ribbon
  Default = Line
  Local Type = colour
  Description = The streamline drawing mode.
END
PARAMETER: Track Line Width
  Parameter Type = Integer
  Default = 2
  Local Type = render
  Description = The width of the streamline.
END
PARAMETER: Track Initial Direction
  Parameter Type = Direction
  Default = 0.0, 1.0, 0.0
  Local Type = top
  Description = Defines the initial plane of a stream ribbon
END
PARAMETER: Show Track Labels
  Parameter Type = Logical
  Default = No
  Local Type = render
  Description = Indicates whether or not to show the track number labels.
END
PARAMETER: Start Boundary List
  Parameter Type = String List
  Description = A string list containing the list of valid starting \
        boundaries for this track.
END
PARAMETER: End Boundary List
  Parameter Type = String List
  Description = A string list containing the list of valid ending \
        boundaries for this track.
END
PARAMETER: Diameter Max
  Parameter Type = Real
  Description = The maximum diameter of all tracks read from the file.
END
PARAMETER: Diameter Min
  Parameter Type = Real
  Description = The minimum diameter of all tracks read from the file.
END
PARAMETER: Number of Tracks
  Parameter Type = Integer
  Description = The total number of tracks that are available for viewing.
END
PARAMETER: Number of Displayed Tracks
  Parameter Type = Integer
  Description = The number of tracks filtered to be displayed in the viewer.
END
PARAMETER: Track Index Range
  Parameter Type = String
  Description = The range of valid track indices.  The indices may extend \
        beyond the number of tracks, specifically when track reduction was \
        selected for the solver.
END
PARAMETER: Tracks Displayed
  Parameter Type = String List
  Description = A list of the track numbers that are displayed in the viewer.
END

PARAMETER: Locator Sampling Method
  Parameter Type = String
  Allowed String List = Equally Spaced, Random, Rectangular Grid, Vertex, \
                        Face Center, Free Edge
  Default = Equally Spaced
  Local Type = top
  Description = Specifies point cloud sampling method on a surface.
END
                              
PARAMETER: Sampling Accuracy
  Parameter Type = String
  Allowed String List = Low, Medium, High
  Local Type = top
  Default = High
  Description = An indicator for points sampling accuracy. 
END

PARAMETER: Sample Spacing
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.1
   Description = A value between 0 and 1 relative to domain extents \
                 indicating number points in one direction for grid sampling.
END

PARAMETER: Sampling Aspect Ratio
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 1
   Description = Specifies spacing aspect ratio for grid sampling.
END

PARAMETER: Sampling Grid Angle
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0 [degree]
   Description = Specifies the rotation angle for a sampling grid.
END

PARAMETER: Size Range Factor
   Parameter Type = Real
   Local Type = symbol
   Default = 0
   Description = Specifies the scaling factor for particle symbol.
END

# -------------- OBJECTS --------------------

 SINGLETON: ROOT
   Description = The ROOT object lists all the object types that can be defined \
               in CFD-Post.
 END

 SINGLETON: RULES
   Allowed Parent List = ROOT
   Description = RULES is automatically read from the rules.ccl library file.
 END

 SINGLETON: LIBRARY
   Allowed Parent List = ROOT
   Description = LIBRARY is automatically read from the VARIABLES library file.
   Optional Child List = CEL
 END

 # Locator Objects

  OBJECT: POINT
    CCLObject Class = SymbolGeometricCCLObject
    Category = point, point-only, deletable, constant-colour, \
        selectable, viewer-viewable, geometry, domain-dependent, \
        has-variable, has-variable-colour, suspendable
    Scheduler = top, geometry, symbol, colour, render
    Scheduler Links = top, geometry, geometry, symbol, symbol, colour, colour, render
    Calculate Function = top, pointcalc, PointCalcFunc, \
                         geometry, pointcalc, PointCalcFunc, \
                         symbol, pointcalc, PointCalcFunc, \
                         colour, pointcalc, PointCalcFunc, \
                         render, pointcalc, PointCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, Colour Map, \
                                Colour Variable Boundary Values, Colour Scale, \
                                Range, Max, Min, Transparency, Visibility, \
                                Surface Drawing, Draw Faces, Draw Lines, \
                                Line Colour, Line Width, Point Symbol,\
                                Symbol Size, Normalized, Lighting, \
                                Specular Lighting, Culling Mode, \
                                Instancing Transform, Apply Instancing Transform
    Internal Parameter List = Local Variable Ranges, Nearest Node Number
    Allowed Option List = XYZ, Node Number, Variable Minimum, Variable Maximum
    CONTEXT: XYZ
      Optional Parameter List = Point
    END
    CONTEXT: Node Number 
      Optional Parameter List = Domain List, Node Number
    END
    CONTEXT: Variable Minimum 
      Optional Parameter List = Domain List, Location, Variable, \
                                Variable Boundary Values
    END
    CONTEXT: Variable Maximum 
      Optional Parameter List = Domain List, Location, Variable, \
                                Variable Boundary Values
    END
    Description = Defines a point using X, Y and Z coordinates.
    Allowed Parent List = ROOT
    PARAMETER: Point Symbol
      Allowed String List = Crosshair, Octahedron, Cube, Ball
      Default = Crosshair
    END
    PARAMETER: Colour
     Default = 1, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
  END

  OBJECT: INTERNAL POINT
    CCLObject Class = SymbolGeometricCCLObject
    Category = point, point-only, constant-colour, \
        viewer-viewable, geometry, domain-dependent, preview, suspendable
    Scheduler = top, geometry, symbol, colour, render
    Scheduler Links = top, geometry, geometry, symbol, symbol, colour, colour, render
    Calculate Function = top, pointcalc, PointCalcFunc, \
                         geometry, pointcalc, PointCalcFunc, \
                         symbol, pointcalc, PointCalcFunc, \
                         colour, pointcalc, PointCalcFunc, \
                         render, pointcalc, PointCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, Colour Map, \
                                Colour Variable Boundary Values, Colour Scale, \
                                Range, Max, Min, Transparency, Visibility, \
                                Surface Drawing, Draw Faces, Draw Lines, \
                                Line Colour, Line Width, Point Symbol,\
                                Symbol Size, Normalized, Lighting, \
                                Specular Lighting, Culling Mode, \
                                Instancing Transform, Apply Instancing Transform, \
                                Symbol Size Mode
    Internal Parameter List = Local Variable Ranges, Nearest Node Number
    Allowed Option List = XYZ, Node Number, Variable Minimum, Variable Maximum
    CONTEXT: XYZ
      Optional Parameter List = Point
    END
    CONTEXT: Node Number 
      Optional Parameter List = Domain List, Node Number
    END
    CONTEXT: Variable Minimum 
      Optional Parameter List = Domain List, Location, Variable, \
                                Variable Boundary Values
    END
    CONTEXT: Variable Maximum 
      Optional Parameter List = Domain List, Location, Variable, \ 
                                Variable Boundary Values
    END
    Description = Defines a point using X, Y and Z coordinates.
    Allowed Parent List = ROOT, CASE COMPARISON
    PARAMETER: Colour
     Default = 1, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    PARAMETER: Point Symbol
      Allowed String List = Point2D, Crosshair, Octahedron, Cube, Ball
      Default = Point2D
    END
    PARAMETER: Symbol Size Mode
      Default = Absolute
    END
  END

  OBJECT: INTERNAL PARTICLE INJECTION REGION
    Category = internal
    Scheduler = top
    CCLObject Class = GenericCCLObject
    Category = pir, selectable, suspendable
    Optional Parameter List = Case Name
    Description = The location of a particle injection region
    Allowed Parent List = CASE
  END

  OBJECT: POINT CLOUD
    CCLObject Class = SymbolGeometricCCLObject
    Category = point, point-only, deletable, constant-colour, \
        selectable, viewer-viewable, geometry, domain-dependent, \
        has-variable, has-variable-colour, suspendable
    Scheduler = geometry, top, symbol, colour, render
    Scheduler Links = top, geometry, geometry, symbol, symbol, colour, colour, render
    Calculate Function = geometry, pointcloudcalc, PointCloudCalcFunc, \
                         top, pointcloudcalc, PointCloudCalcFunc, \
                         symbol, pointcloudcalc, PointCloudCalcFunc, \
                         colour, pointcloudcalc, PointCloudCalcFunc, \
                         render, pointcloudcalc, PointCloudCalcFunc
    Essential Parameter List = Location List
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Locator Sampling Method, Domain List, \
                              Number of Samples, Sampling Grid Angle, \
                              Sample Spacing, Sampling Aspect Ratio, \
                              Sampling Accuracy, Random Seed, Colour Mode,\
                              Colour, Colour Variable, Colour Map, \
                              Colour Variable Boundary Values, Colour Scale, \
                              Range, Max, Min, Transparency, Visibility, \
                              Surface Drawing, Draw Faces, Draw Lines, \
                              Line Colour, Line Colour Mode, Line Width, Point Symbol,\
                              Symbol Size, Normalized, Lighting, \
                              Specular Lighting, Culling Mode, \
                              Instancing Transform, Apply Instancing Transform, \
                              Reduction or Max Number, Reduction Factor, \
                              Maximum Number of Items, Add Sample Vertex Normals
    Internal Parameter List = Local Variable Ranges
    Description = Generate a cloud of points on a locator(s) using a \
                  specified sampling method.
    Allowed Parent List = ROOT
    PARAMETER: Colour
     Default = 1, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    PARAMETER: Maximum Number of Items
      Default = 100
    END
    PARAMETER: Number of Samples
      Default = 100
    END
    PARAMETER: Point Symbol
     Allowed String List = Crosshair, Octahedron, Cube, Ball
     Default = Crosshair
    END
  END
        
  OBJECT: PARTICLE CLOUD
    CCLObject Class = ParticleCloudGeometricCCLObject
    Category = viewer-viewable, suspendable, geometry, domain-dependent, \
               res-dependent, res-surface, constant-colour, has-variable, \
               has-variable-colour, point, selectable, \
               has-local-variable, quick-editable
    Scheduler = top, geometry, symbol, colour, render
    Scheduler Links = top, geometry, geometry, symbol, symbol, colour, colour, render
    Optional Parameter List = Colour Mode, Colour, Colour Variable, \
                              Colour Variable Boundary Values, Colour Scale, \
                              Symbol, Symbol Size, Symbol Size Mode, Normalized, \
                              Variable, \
                              Visibility, \
                              Line Width, Draw Lines, Draw Faces, \
                              Surface Drawing, Lighting, Transparency, \
                              Specular Lighting, Culling Mode, \
                              Instancing Transform, Apply Instancing Transform, \
                              Max, Min, Range, \
                              Reduction or Max Number, \
                              Reduction Factor, \
                              Maximum Number of Items, \
                              Domain List
    Allowed Parent List = CASE
    Optional Child List = OBJECT VIEW TRANSFORM
    Description = A particle cloud object to display discrete particles \
                  and their variables.

    PARAMETER: Visibility
      Default = false
    END
    PARAMETER: Maximum Number of Items
      Default = 1000
    END
    PARAMETER: Reduction or Max Number
      Default = Reduction
    END
    PARAMETER: Normalized
      Default = On
    END
    PARAMETER: Symbol
      Default = Ball
    END
  END


# non-selectable point cloud
  OBJECT: INTERNAL POINT CLOUD
    CCLObject Class = SymbolGeometricCCLObject
    Category = viewer-viewable, domain-dependent, preview, suspendable
    Scheduler = geometry, top, symbol, colour, render
    Scheduler Links = top, geometry, geometry, symbol, symbol, colour, colour, render
    Calculate Function = geometry, pointcloudcalc, PointCloudCalcFunc, \
                         top, pointcloudcalc, PointCloudCalcFunc, \
                         symbol, pointcloudcalc, PointCloudCalcFunc, \
                         colour, pointcloudcalc, PointCloudCalcFunc, \
                         render, pointcloudcalc, PointCloudCalcFunc
    Essential Parameter List = Location List
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Locator Sampling Method, Domain List, \
                              Number of Samples, Sampling Grid Angle, \
                              Sample Spacing, Sampling Aspect Ratio, \
                              Sampling Accuracy, Random Seed, Colour Mode,\
                              Colour, Colour Variable, Colour Map, \
                              Colour Variable Boundary Values, Colour Scale, \
                              Range, Max, Min, Transparency, Visibility, \
                              Surface Drawing, Draw Faces, Draw Lines, \
                              Line Colour, Line Colour Mode, Line Width, Point Symbol,\
                              Symbol Size, Symbol Size Mode, Normalized, Lighting, \
                              Specular Lighting, Culling Mode, \
                              Instancing Transform, Apply Instancing Transform, \
                              Reduction or Max Number, Reduction Factor, \
                              Maximum Number of Items, Add Sample Vertex Normals
    Internal Parameter List = Local Variable Ranges
    Description = Generate a cloud of points on a locator(s) using a \
                  specified sampling method.
    Allowed Parent List = ROOT, CASE COMPARISON
    PARAMETER: Colour
     Default = 1, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    PARAMETER: Point Symbol
     Allowed String List = Crosshair, Octahedron, Cube, Ball, Point2D
     Default = Point2D
    END
    PARAMETER: Maximum Number of Items
      Default = 100
    END
    PARAMETER: Number of Samples
      Default = 100
    END
  END

#   Optional Parameter List = Visibility, Symbol Type, Symbol Size, Symbol Colour, \
#                             Coord Frame, Domain List, Colour Mode, Colour, \
#              Draw Faces, Line Colour, Line Width, \
#                             Draw Lines, Surface Drawing, Transparency, Variable
#  Optional Parameter List = Visibility,  \
#                            Domain List, Colour Mode, Colour, \
#                            Draw Faces, Line Colour, Line Width, \
#                            Draw Lines, Surface Drawing, Transparency, \
#                            Colour Variable, Lighting
#    Allowed Option List = XYZ, On Line, On Surface
#   CONTEXT: On Line
#     Essential Parameter List = Location
#     Optional Parameter List = Parametric Distance
#   END
#   CONTEXT: On Surface
#     Essential Parameter List = Location
#     Optional Parameter List = S Parameter, T Parameter
#   END

  
  PARAMETER: Line Seqment Indexes
    Parameter Type = String List
    Description = A list of line geometry indexes, by domain.
  END

  OBJECT: POLYLINE
    CCLObject Class = ExternalFileUserCCLObject
    Category = line, line-only, point, deletable, constant-colour, geometry, \
             domain-dependent, selectable, viewer-viewable, \
             has-variable, has-variable-colour, has-local-variable, suspendable
    Scheduler = top, geometry, colour, glyph, render
    Scheduler Links = top, geometry, geometry, colour, colour, glyph, glyph, render
    Calculate Function = top, polylinecalc, PolylineCalcFunc, \
                         geometry, polylinecalc, PolylineCalcFunc, \
                         colour, polylinecalc, PolylineCalcFunc, \
                         glyph, polylinecalc, PolylineCalcFunc, \
                         render, polylinecalc, PolylineCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, Colour Map, \
                        Colour Scale, Colour Variable Boundary Values, Visibility, \
                        Line Width, Range, Min, Max, Instancing Transform, \
                        Apply Instancing Transform
    Internal Parameter List = Local Variable Ranges, Add Local Variable, Line Seqment Indexes


    Allowed Option List = From File, Boundary Intersection, From Contour
    CONTEXT: From File
       Essential Parameter List = Input File
       Optional Parameter List = Section Name
    END
    CONTEXT: Boundary Intersection
       Essential Parameter List = Location, Boundary List
       Optional Parameter List = Domain List
    END
    CONTEXT: From Contour
       Essential Parameter List = Contour Name
       Optional Parameter List = Contour Level
    END
    Allowed Parent List = ROOT
    PARAMETER: Colour
     Default = 0, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    Description = A locator defined by multiple sets of points read from \
                a data file or by the intersection of a boundary and a locator. \
                The points may have local (path) variables associated \
                with them.  The polyline can interact with CFD data and can be coloured \
                using path variables or domain variables.
  END

  OBJECT: INTERNAL POLYLINE
    CCLObject Class = ExternalFileUserCCLObject
    Category = line, line-only, point, deletable, constant-colour, geometry, \
             domain-dependent, viewer-viewable, \
             has-variable, has-variable-colour, has-local-variable, has-local-legend, suspendable
    Scheduler = top, geometry, colour, glyph, render
    Scheduler Links = top, geometry, geometry, colour, colour, glyph, glyph, render
    Calculate Function = top, polylinecalc, PolylineCalcFunc, \
                         geometry, polylinecalc, PolylineCalcFunc, \
                         colour, polylinecalc, PolylineCalcFunc, \
                         glyph, polylinecalc, PolylineCalcFunc, \
                         render, polylinecalc, PolylineCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, Colour Map, \
                        Colour Scale, Colour Variable Boundary Values, Visibility, \
                        Line Width, Range, Min, Max, Instancing Transform, \
                        Apply Instancing Transform
    Internal Parameter List = Local Variable Ranges, Add Local Variable, Line Seqment Indexes

    Allowed Option List = From File, Boundary Intersection, From Contour
    CONTEXT: From File
       Essential Parameter List = Input File
       Optional Parameter List = Section Name
    END
    CONTEXT: Boundary Intersection
       Essential Parameter List = Location, Boundary List
       Optional Parameter List = Domain List
    END
    CONTEXT: From Contour
       Essential Parameter List = Contour Name
       Optional Parameter List = Contour Level, Domain List
    END
    Allowed Parent List = ROOT, CASE COMPARISON
    PARAMETER: Colour
     Default = 0, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    Description = A locator defined by multiple sets of points read from \
                a data file or by the intersection of a boundary and a locator.\
                The points may have local (path) variables associated \
                with them.  The polyline can interact with CFD data and can be coloured \
                using path variables or domain variables (internal version).
  END
  
  OBJECT: PARTICLE TRACK
    CCLObject Class = ParticleTrackGeometricCCLObject
    Category = point, line, line-only, deletable, constant-colour, selectable, \
      viewer-viewable, geometry, domain-dependent, has-variable, \
      has-variable-colour, quick-animatable, has-local-variable, \
      time-dependent, suspendable
    Scheduler = geometry, top, colour, render, symbol
    Scheduler Links = top, geometry, geometry, colour, colour, render, render, symbol
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Reduction or Max Tracks, Reduction Factor, \
                Maximum Number of Tracks, Track Material, Limit Track Option, Track Limit Type, \
                Track Start Time, Track End Time, Track Start Distance, \
                Track End Distance, Activate Filter, \
                Filter On Start, Starting Boundary, Filter On End, Ending Boundary, \
                Filter On Diameter, Particle Diameter, Particle Diameter Condition, \
                Particle Diameter Two, Particle Diameter Condition Two, \
                Filter On Track Selection, Track Selection, Any All Condition, \
                Draw Symbols, Track Symbol, Symbol Size Option, Symbol Scale Type, Draw Tracks, Symbol Size, \
                Symbol Max Time Selection, Symbol Start Time, Symbol Stop Time, \
                Symbol Time Interval, Colour Mode, Colour Variable, Colour Map, \
                Colour Variable Boundary Values, Colour, Colour Scale, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Surface Drawing, Lighting, Draw Lines, Specular Lighting, \
                Culling Mode, Line Width, Line Colour, Instancing Transform, \
                Apply Instancing Transform, Track Drawing Mode, Number of Sides, \
                Track Line Width, Track Initial Direction, Track Size, \
                Show Track Labels, Text Height, Font, Text Colour, Text Colour Mode, \
                Size Range Factor
    Internal Parameter List = Local Variable Ranges, Material, \
                Start Boundary List, End Boundary List, Diameter Max, Diameter Min, \
                Number of Tracks, Number of Displayed Tracks, Track Index Range, \
                Tracks Displayed
    Allowed Option List = From Res, From File
    CONTEXT: From Res
    END
    CONTEXT: From File
       Essential Parameter List = Track File Type, Input File
       Optional Parameter List = Injection ID List, Injection Filter, Injection Filter List
    END
    Allowed Parent List = ROOT, CASE
    Description = A particle track object providing the filtering of the display \
        of particle tracks that exist in the current result file (if any) \
        and/or tracks loaded from a separate tracks file.
  END

  OBJECT: RES PARTICLE TRACK
    CCLObject Class = ParticleTrackGeometricCCLObject
    Category = point, line, line-only, constant-colour, selectable, \
      viewer-viewable, geometry, domain-dependent, has-variable, \
      has-variable-colour, quick-animatable, res-dependent, \
      time-dependent, suspendable
    Scheduler = geometry, top, colour, render, symbol
    Scheduler Links = top, geometry, geometry, colour, colour, render, render, symbol
    Calculate Function = geometry, particletrackcalc, ParticleTrackCalcFunc, \
                         top, particletrackcalc, ParticleTrackCalcFunc, \
                         symbol, particletrackcalc, ParticleTrackCalcFunc, \
                         colour, particletrackcalc, ParticleTrackCalcFunc, \
                         render, particletrackcalc, ParticleTrackCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Reduction or Max Tracks, Reduction Factor, \
                Maximum Number of Tracks, Track Material, Limit Track Option, Track Limit Type, \
                Track Start Time, Track End Time, Track Start Distance, \
                Track End Distance, Activate Filter, \
                Filter On Start, Starting Boundary, Filter On End, Ending Boundary, \
                Filter On Diameter, Particle Diameter, Particle Diameter Condition, \
                Particle Diameter Two, Particle Diameter Condition Two, \
                Filter On Track Selection, Track Selection, Any All Condition, \
                Draw Symbols, Track Symbol, Symbol Size Option, Symbol Scale Type, Draw Tracks, Symbol Size, \
                Symbol Max Time Selection, Symbol Start Time, Symbol Stop Time, \
                Symbol Time Interval, Colour Mode, Colour Variable, Colour Map, \
                Colour Variable Boundary Values, Colour, Colour Scale, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Surface Drawing, Lighting, Draw Lines, Specular Lighting, \
                Culling Mode, Line Width, Line Colour, Instancing Transform, \
                Apply Instancing Transform, Track Drawing Mode, Number of Sides, \
                Track Line Width, Track Initial Direction, Track Size, \
                Show Track Labels, Text Height, Font, Text Colour, \
                Text Colour Mode, Size Range Factor
    Internal Parameter List = Local Variable Ranges, Material, \
                Start Boundary List, End Boundary List, Diameter Max, Diameter Min, \
                Number of Tracks, Number of Displayed Tracks, Track Index Range, \
                Tracks Displayed, Case Name, Object State, Time Step List

    Allowed Option List = From Res, From File
    CONTEXT: From Res
    END
    CONTEXT: From File
    END
    Allowed Parent List = ROOT, CASE
    Description = A particle track object that provides the default displaying \
        of particle tracks that exist in the loaded result file.  If the result file \
        has no Track data, this object is not created.
  END

  OBJECT: SUBDOMAIN
    CCLObject Class = RegionGeometricCCLObject
    Category = geometry, point, constant-colour, selectable, \
               viewer-viewable, has-variable, has-variable-colour, \
               volume, \
               domain-geometry-dependent, res-dependent, res-surface, \
               suspendable
    Scheduler = geometry, top, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, \
                Colour Scale, Colour Variable, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Draw Lines, Line Width, Line Colour, Line Colour Mode, \
                Surface Drawing, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges, Region List, Case Name,  \
                              Is Immersed Object, Object State, Time Step List
    Allowed Parent List = ROOT, CASE
    PARAMETER: Colour
      Default = 0.2, 0.5, 1
    END
    PARAMETER: Visibility
      Default = false
    END

    Description = A volume region of a domain defined as a subdomain.
  END

  OBJECT: PRIMITIVE2D
   CCLObject Class = RegionGeometricCCLObject
   Category = point, surface, region, region2d, constant-colour, \
              geometry, selectable, viewer-viewable, \
              has-variable, has-variable-colour, \
              domain-geometry-dependent, res-dependent, res-surface, \
              mesh-density, suspendable
   Scheduler = top, geometry, colour, render, instance
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List =  Domain List, Colour Mode, Colour, Colour Variable, Colour Map, Colour Scale, \
                Colour Variable Boundary Values, Range, Min, Max, Visibility, \
                Transparency, Draw Faces, Surface Drawing, Draw Lines, Line Width, \
                Line Colour, Line Colour Mode, Lighting, Specular Lighting, Culling Mode, \
                Instancing Transform, Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture, Set Number

   Internal Parameter List = Local Variable Ranges, Internal Name, \
                             Case Name,  Is Immersed Object, Object State, Time Step List
   Allowed Parent List = ROOT, CASE
   PARAMETER: Colour
     Default = 1, 0.5, 0
   END
   PARAMETER: Visibility
     Default = false
   END

   Description = A primitive 2D region defined in the GTM database         
  END

  OBJECT: PRIMITIVE3D
    CCLObject Class = RegionGeometricCCLObject
    Category = geometry, point, constant-colour, selectable, \
               viewer-viewable, has-variable, has-variable-colour, \
               volume, region, \
               domain-geometry-dependent, res-dependent, res-surface, \
               suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, \
                Colour Scale, Colour Variable, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Draw Lines, Line Width, Line Colour, Line Colour Mode, Surface Drawing, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture, Set Number

    Internal Parameter List = Local Variable Ranges, Internal Name, \
                              Case Name,  Is Immersed Object, Object State, Time Step List
    Allowed Parent List = ROOT, CASE
    PARAMETER: Colour
      Default = 1, 0.5, 0
    END
    PARAMETER: Visibility
      Default = false
    END

    Description = A primitive 3D region defined in the GTM database.
  END
  
  OBJECT: COMPOSITE
    CCLObject Class = RegionGeometricCCLObject
    Category = geometry, point, surface, volume, region, region2d, \
               constant-colour, selectable, \
               viewer-viewable, has-variable, has-variable-colour, \
               domain-geometry-dependent, res-dependent, res-surface, \
               mesh-density, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, \
                Colour Scale, Colour Variable, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Draw Lines, Line Width, Line Colour, Line Colour Mode, Surface Drawing, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

   Internal Parameter List = Local Variable Ranges, Internal Name, Dimensions, \
                             Region List, Has Primitives, Case Name, \
                             Is Immersed Object, Object State, Time Step List
   Allowed Parent List = ROOT, CASE
   PARAMETER: Colour
     Default = 1, 0.5, 0
   END
   PARAMETER: Visibility
     Default = false
   END
   Description = A composite region defined in the GTM database    
  END

  OBJECT: COMPOSITE PERIODIC
    CCLObject Class = RegionGeometricCCLObject
    Category = geometry, point, surface, volume, region, region2d, \
               constant-colour, selectable, \
               viewer-viewable, has-variable, has-variable-colour, \
               domain-geometry-dependent, res-dependent, res-surface, \
               mesh-density, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, \
                Colour Scale, Colour Variable, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Draw Lines, Line Width, Line Colour, Line Colour Mode, Surface Drawing, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

   Internal Parameter List = Local Variable Ranges, Internal Name, Dimensions, \
                             Region List, Has Primitives, Case Name, \
                             Is Immersed Object, Object State, Time Step List
   Allowed Parent List = ROOT, CASE
   PARAMETER: Colour
     Default = 1, 0.5, 0
   END
   PARAMETER: Visibility
     Default = false
   END
   Description = A periodic region used by CFX4.
  END

  OBJECT: COMPOSITE INTER BLOCK
    CCLObject Class = RegionGeometricCCLObject
    Category = geometry, point, surface, volume, region, region2d, \
               constant-colour, selectable, \
               viewer-viewable, has-variable, has-variable-colour, \
               domain-geometry-dependent, res-dependent, res-surface, \
               mesh-density, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, \
                Colour Scale, Colour Variable, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Draw Lines, Line Width, Line Colour, Line Colour Mode, Surface Drawing, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

   Internal Parameter List = Local Variable Ranges, Internal Name, Dimensions, \
                             Region List, Has Primitives, Case Name,  \
                             Is Immersed Object, Object State, Time Step List
   Allowed Parent List = ROOT, CASE
   PARAMETER: Colour
     Default = 1, 0.5, 0
   END
   PARAMETER: Visibility
     Default = false
   END
   Description = An inter-block region used by CFX4.
  END

# OBJECT BOUNDARY
# Internal parameters to deal with periodicity
PARAMETER: Opposite Boundary List
    Description = The boundaries that form the other side of a periodic link
    Parameter Type = String List
END
PARAMETER: Periodicity Type
    Description = Says whether the boundary is periodic in rotation or translation
    Parameter Type = String 
    Allowed String List = Rotation, Translation
END
PARAMETER: Old Periodicity
    Description = Says whether the periodic boundary is specified in old or \
                new format.
    Parameter Type = Logical    
    Default = false
END
  PARAMETER: Interface Type
    Parameter Type = String
    Allowed String List = \
      Periodic Fluid Solid, \
      Fluid Fluid, \
      Fluid Porous, \
      Fluid Solid, \
      Porous Porous, \
      Solid Porous, \
      Solid Solid, \
      Periodic
    Description = Matches the solver CCL parameter, saying what kind of GGI interface this is
  END

  OBJECT: BOUNDARY
   CCLObject Class = BoundaryGeometricCCLObject
   Category = point, surface, region2d, constant-colour, \
              geometry, selectable, viewer-viewable, has-variable, \
              has-variable-colour, \
              domain-geometry-dependent, res-dependent, res-surface, \
              mesh-density, suspendable
   Scheduler = top, geometry, colour, render, instance
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Domain List, Colour Mode, Colour, Colour Variable, Colour Map, Colour Scale, \
                Colour Variable Boundary Values, Range, Min, Max, Visibility, \
                Transparency, Draw Faces, Surface Drawing, Draw Lines, Line Width, \
                Line Colour, Line Colour Mode, Lighting, Specular Lighting, Culling Mode, \
                Instancing Transform, Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

   Internal Parameter List = Solver Name, Boundary Type, Periodicity Type, \
                Rotation Axis From, Rotation Axis To, Rotation Angle, Translation Vector, \
                Opposite Boundary List, Interface Type, Old Periodicity, \
                Local Variable Ranges, Region List, Case Name, \
                Is Immersed Object, Object State, Is Permeable, Time Step List
   PARAMETER: Colour
     Default = 0.2, 0.5, 1
   END
   PARAMETER: Visibility
     Default = false
   END
        
   Allowed Parent List = ROOT, CASE
   Description = A locator defined by a boundary condition that exists in the results file.
  END

  OBJECT: RES SURFACE
   CCLObject Class = ResultsSurfaceGeometricCCLObject
   Category = point, surface, region2d, constant-colour, \
              geometry, selectable, viewer-viewable, \
              has-variable, has-local-variable, has-variable-colour, \
              res-dependent, res-surface, res-user-surface, \
              suspendable
   Scheduler = top, geometry, colour, render
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List =  Case Name, Domain List, \
                            Colour Mode, Colour, Colour Variable, Colour Map,\
                            Colour Scale, Colour Variable Boundary Values, \
                            Range, Min, Max, Visibility, Transparency, \
                            Draw Faces, Surface Drawing, Draw Lines, \
                            Line Width, Line Colour, Line Colour Mode, \
                            Lighting, Specular Lighting, Culling Mode, \
                            Render Edge Angle, \
                            Instancing Transform, \
                            Apply Instancing Transform, \
                            Apply Texture, Texture Type, \
                            Texture File, Texture Material, \
                            Texture Direction, \
                            Texture Position, \
                            Texture Scale, Texture Angle, Tile Texture, \
                            Blend Texture, Transform Texture, Set Number

   Internal Parameter List = Local Variable Ranges, Internal Name, \
                             Object State, Time Step List, \
                             Is Cross Domain Surface, \
                             Update Variable Global Range, \
                             Is Immersed Object
   Allowed Parent List = ROOT, CASE
   PARAMETER: Colour
     Default = 0.75, 0.75, 0.75
   END

   PARAMETER: Visibility
     Default = false
   END

   Description = A user surface obtained from a loaded case
  END

# Plot Objects
 OBJECT: WIREFRAME
    CCLObject Class = GeometricCCLObject
    Category = constant-colour, geometry, domain-dependent, selectable, viewer-viewable, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = geometry, wirecalc, WireCalcFunc, \
                         top, wirecalc, WireCalcFunc, \
                         colour, wirecalc, WireCalcFunc, \
                         render, wirecalc, WireCalcFunc
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Show Surface Mesh, Edge Angle, Line Colour Mode, Colour, Visibility, Line Width, \
                Domain List, Instancing Transform, Apply Instancing Transform
    Allowed Parent List = ROOT
    PARAMETER: Colour
      Default = 0, 0, 0
    END
    Description = Plots an outline of the domain given by edges between elements with \
                  greater than the specified angle.
  END

  OBJECT: VECTOR
    CCLObject Class = PointCloudGeometricCCLObject
    Category = deletable, constant-colour, selectable, \
                viewer-viewable, has-variable-colour, has-local-variable, \
                domain-dependent, geometry, tbr-plot, suspendable
    Scheduler = top, geometry, symbol, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, symbol, symbol, render
    Calculate Function = geometry, vectorplotcalc, VectorPlotCalcFunc, \
                         top, vectorplotcalc, VectorPlotCalcFunc, \
                         symbol, vectorplotcalc, VectorPlotCalcFunc, \
                         colour, vectorplotcalc, VectorPlotCalcFunc, \
                         render, vectorplotcalc, VectorPlotCalcFunc
    Essential Parameter List = Location List, Variable
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, \
                       Colour Map, Colour Scale,\
                Colour Variable Boundary Values, Variable Boundary Values, \
                Range, Min, Max, Normalized, Symbol, Symbol Size, Projection Type, \
                Visibility, Transparency, Surface Drawing, Line Width, \
                Domain List, Direction, Coord Frame, \
                Reduction or Max Number, Reduction Factor, \
                Maximum Number of Items, Surface Sampling, \
                Draw Lines, Draw Faces, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Locator Sampling Method, \
                Number of Samples, Sampling Accuracy, Random Seed, \
                Sampling Grid Angle, Sample Spacing, \
                Sampling Aspect Ratio, Add Sample Vertex Normals

    Internal Parameter List = Local Variable Ranges
    Allowed Parent List = ROOT
    Description = Creates a vector plot on a given list of locators.
    PARAMETER: Reduction or Max Number
      Default = Reduction
      Local Type = top
    END
    PARAMETER: Maximum Number of Items
      Default = 100
      Local Type = top
    END
    PARAMETER: Number of Samples
      Default = 100
    END
    PARAMETER: Locator Sampling Method
      Default = Vertex
    END
  END

  OBJECT: INTERNAL VECTOR
    CCLObject Class = PointCloudGeometricCCLObject
    Category = deletable, constant-colour, \
                viewer-viewable, has-variable-colour, has-local-variable, \
                domain-dependent, has-local-legend, geometry, suspendable
    Scheduler = top, geometry, variable, symbol, colour, render
    Scheduler Links = top, geometry, geometry, variable, variable, colour, colour, symbol, symbol, render
    Calculate Function = geometry, vectorplotcalc, VectorPlotCalcFunc, \
                         top, vectorplotcalc, VectorPlotCalcFunc, \
                         variable, vectorplotcalc, VectorPlotCalcFunc, \
                         symbol, vectorplotcalc, VectorPlotCalcFunc, \
                         colour, vectorplotcalc, VectorPlotCalcFunc, \
                         render, vectorplotcalc, VectorPlotCalcFunc
    Essential Parameter List = Location List, Variable
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, \
                Colour Map, Colour Scale,\
                Colour Variable Boundary Values, Variable Boundary Values, \
                Range, Min, Max, Normalized, Symbol, Symbol Size, \
                Projection Type, \
                Visibility, Transparency, Surface Drawing, Line Width, \
                Domain List, Direction, Coord Frame, \
                Reduction or Max Number, Reduction Factor, \
                Maximum Number of Items, Surface Sampling, \
                Draw Lines, Draw Faces, Lighting, \
                Specular Lighting, Culling Mode, Instancing Transform, \
                Apply Instancing Transform, Locator Sampling Method, \
                Number of Samples, Sampling Accuracy, Random Seed, \
                Sampling Grid Angle, Sample Spacing, \
                Sampling Aspect Ratio, Add Sample Vertex Normals

    Internal Parameter List = Local Variable Ranges
    Allowed Parent List = ROOT, CASE COMPARISON
    Description = Creates a vector plot on a given list of locators (internal version).
    PARAMETER: Reduction or Max Number
      Default = Reduction
    END
    PARAMETER: Maximum Number of Items
      Default = 100
    END
    PARAMETER: Number of Samples
      Default = 100
    END
    PARAMETER: Location List
      Local Type = top
      Remote Type = render
    END
  END

  OBJECT: SYMBOL
    CCLObject Class = SymbolCCLObject
    Scheduler = top, symbol
    Scheduler Links = top, symbol
    Calculate Function = top, symbolcalc, SymbolCalcFunc, \
                         symbol,symbolcalc, SymbolCalcFunc
    Essential Parameter List = Symbol Type
    Context Rule = Symbol Type
    Allowed Option List = Arrow2D, Arrow3D, Crosshair, Octahedron, Line Arrow, \
                          Arrowhead, Arrowhead3D
    CONTEXT: Arrow2D
    END
    CONTEXT: Arrow3D
    END
    CONTEXT: Crosshair
    END
    CONTEXT: Octahedron
    END
    CONTEXT: Line Arrow
    END
    CONTEXT: Arrowhead
    END
    CONTEXT: Arrowhead3D
    END
    Allowed Parent List = ROOT
    Description = An internal object representing a plotting symbol.
  END
     
  SINGLETON: SYMBOL CONTROL
    CCLObject Class = GenericCCLObject
    Scheduler = symbol
    Optional Parameter List = Symbol Size
    Internal Parameter List = Symbol Size Conversion Factor, \
                              MTS Symbol Size Conversion Factor
    Allowed Parent List = ROOT
  END

  OBJECT: ISOSURFACE
    CCLObject Class = GeometricCCLObject
    Category = deletable, surface, constant-colour, point,\
                geometry, domain-dependent, selectable, viewer-viewable, \
                edge-based, has-variable, has-variable-colour, \
                mesh-density, quick-editable, quick-animatable, tbr-plot, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = geometry, isocalc, IsosurfaceCalcFunc, \
                         top, isocalc, IsosurfaceCalcFunc, \
                         colour, isocalc, IsosurfaceCalcFunc, \
                         render, isocalc, IsosurfaceCalcFunc
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Variable, Value, Variable Boundary Values, \
                Colour Mode, Colour, Colour Variable, Colour Map, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Surface Drawing, Draw Lines, Line Width, Line Colour, Line Colour Mode, Colour Scale, \
                Domain List, Lighting, Specular Lighting, Culling Mode, \
                Instancing Transform, Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges
    Allowed Parent List = ROOT
    Description = A locator generated by the surface which passes through a constant \
                value of a specified variable.
  END

  OBJECT: INTERNAL ISOSURFACE
    CCLObject Class = GeometricCCLObject
    Category = deletable, surface, constant-colour, point,\
                geometry, domain-dependent, viewer-viewable, \
                edge-based, has-variable, has-variable-colour, \
                mesh-density, quick-editable, has-local-legend, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = geometry, isocalc, IsosurfaceCalcFunc, \
                         top, isocalc, IsosurfaceCalcFunc, \
                         colour, isocalc, IsosurfaceCalcFunc, \
                         render, isocalc, IsosurfaceCalcFunc
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Variable, Value, Variable Boundary Values, \
                Colour Mode, Colour, Colour Variable, Colour Map, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
                Surface Drawing, Draw Lines, Line Width, Line Colour, Line Colour Mode, Colour Scale, \
                Domain List, Lighting, Specular Lighting, Culling Mode, \
                Instancing Transform, Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges
    Allowed Parent List = ROOT
    Description = A locator generated by the surface which passes through a constant \
                value of a specified variable (internal version).
  END

PARAMETER: Actual Isosurface Value
  Parameter Type = String
  Default = unknown
  Description = Indicates the current value used in ISO surface.
END

  PARAMETER: Iso Clip Geometry
    Default = Automatic
    Allowed String List = Both Faces and Lines, Lines Only, Faces Only, Automatic
    Description = Determine how to generate geometry, if there exists both faces and lines \
                  in iso clip resultant geometry.
    Parameter Type = String List
    Local Type = top
  END

  OBJECT: ISO CLIP
    CCLObject Class = IsoClipCCLObject
    Category = deletable, surface, line, point, constant-colour, has-variable-colour, \
                geometry, domain-dependent, selectable, viewer-viewable, has-variable, \
                suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render

    Calculate Function = geometry, isoclipcalc, IsoClipCalcFunc, \
                         top, isoclipcalc, IsoClipCalcFunc, \
                         colour, isoclipcalc, IsoClipCalcFunc, \
                         render, isoclipcalc, IsoClipCalcFunc
    Optional Parameter List = Visibility, Domain List, Location List, \
                Colour Mode, Colour, Colour Variable, Colour Map, \
                Colour Variable Boundary Values, Colour Scale, \
                Range, Min, Max, Transparency, Draw Faces, \
                Surface Drawing, Draw Lines, Line Width, Line Colour, \
                Line Colour Mode, Lighting, Specular Lighting, Culling Mode, \
                Render Edge Angle, Apply Texture, Texture Type, \
                Texture File, Texture Material, Texture Direction, \
                Texture Position, Texture Scale, Texture Angle, Tile Texture, \
                Blend Texture, Transform Texture, \
                Instancing Transform, Apply Instancing Transform, \
                Iso Clip Geometry, Iso Line Width

    Internal Parameter List = Local Variable Ranges
    Allowed Parent List = ROOT
    Description = A locator generated by the clipping values in given child ranges.
    Optional Child List = OBJECT VIEW TRANSFORM, ISO CLIP LIMITER
  END

  PARAMETER: Limiter Operation
    Default = Greater Or Equal To
    Allowed String List = Greater Or Equal To, Equal To, Less Or Equal To
    Description = The operation of the limitation.
    Parameter Type = String List
    Local Type = top
  END

  OBJECT: ISO CLIP LIMITER
    CCLObject Class = IsoClipCCLObject
    Scheduler = top, colour, render
    Scheduler Links = top, colour, colour, render
    Calculate Function = top, isoclipcalc, IsoClipCalcFunc, \
                         colour, isoclipcalc, IsoClipCalcFunc, \
                         render, isoclipcalc, IsoClipCalcFunc
    Optional Parameter List = Variable, Value, Variable Boundary Values, \
                Limiter Operation
    Allowed Parent List = ISO CLIP
    PARAMETER: Value
      Default = 0
      Local Type = top
    END
  END

  OBJECT: VORTEX CORE REGION
    CCLObject Class = GeometricCCLObject
    Category = deletable, surface, constant-colour, point,\
               geometry, domain-dependent, selectable, viewer-viewable, \
               edge-based, has-variable, has-variable-colour, \
               mesh-density, quick-editable, quick-animatable, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = geometry, isocalc, IsosurfaceCalcFunc, \
                         top, isocalc, IsosurfaceCalcFunc, \
                         colour, isocalc, IsosurfaceCalcFunc, \
                         render, isocalc, IsosurfaceCalcFunc
    Essential Parameter List = Method Name
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Variable, Fractional Value, Value, Variable Boundary Values, \
              Colour Mode, Colour, Colour Variable, Colour Map, Colour Variable Boundary Values, \
                Range, Min, Max, Visibility, Transparency, Draw Faces, \
          Surface Drawing, Draw Lines, Line Width, Line Colour, Line Colour Mode, Colour Scale , \
                Domain List, Lighting, Specular Lighting, Culling Mode, \
                Instancing Transform, Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Actual Isosurface Value, Local Variable Ranges
    Allowed Parent List = ROOT
    Description = A locator generated by the surface with a constant value that correponding to \
                a specified strength level for a selected vortex core identification variable.
  END


  OBJECT: USER SURFACE
    CCLObject Class = ExternalFileUserCCLObject
    Category = point, deletable, constant-colour, geometry, \
             domain-dependent, selectable, viewer-viewable, \
             has-variable, has-variable-colour, has-local-variable, surface, suspendable
    Scheduler = instance, top, geometry, colour, glyph, render
    Scheduler Links = instance, top, top, geometry, geometry, colour, colour, glyph, glyph, render
    Calculate Function = top, usersurfacecalc, UserSurfaceCalcFunc, \
                         geometry, usersurfacecalc, UserSurfaceCalcFunc, \
                         colour, usersurfacecalc, UserSurfaceCalcFunc, \
                         glyph, usersurfacecalc, UserSurfaceCalcFunc, \
                         render, usersurfacecalc, UserSurfaceCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Colour Mode, Colour, Colour Variable, Colour Map, \
        Colour Variable Boundary Values, Range, Min, Max, Visibility, \
        Transparency, Draw Faces, Surface Drawing, Draw Lines, Line Width, \
        Line Colour, Line Colour Mode, Lighting, Specular Lighting, Culling Mode, \
        Instancing Transform, Apply Instancing Transform, Render Edge Angle, \
        Colour Scale, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture
    Internal Parameter List = Local Variable Ranges, Surface Element Type, \
                                ANSYS Key Option, ANSYS Mapping Success Status

    Allowed Option List = From File, Boundary Intersection, From Contour, \
        Transformed Surface, Offset From Surface, ANSYS, Patran Import, \
        From STL File
    CONTEXT: From File
       Essential Parameter List = Input File
       Optional Parameter List = Section Name
    END
    CONTEXT: Boundary Intersection
       Essential Parameter List = Location, Boundary List
       Optional Parameter List = Domain List
    END
    CONTEXT: From Contour
       Essential Parameter List = Contour Name
       Optional Parameter List = Contour Level
    END
    CONTEXT: Transformed Surface
       Essential Parameter List = Surface Name
       Optional Parameter List = Apply Scale, Scale Factor, \
                                 Apply Translation, Translation Vector, \
                                 Apply Rotation, Rotation Angle, \
                                 Rotation Axis Type, Principal Axis, \
                                 Rotation Axis From, Rotation Axis To
    END
    CONTEXT: Offset From Surface
       Essential Parameter List = Surface Name
       Optional Parameter List = Offset Type, Offset Mode, Offset Distance, \
                                 Offset Variable, Offset Direction
    END
    CONTEXT: ANSYS
       Essential Parameter List = Input File
       Optional Parameter List = File Units, \
                                Associated Boundary, Associated Boundary Specified, \
                                Maintain Conservative Values, Use Mid Side Nodes, \
                                ANSYS Diagnostics File, ANSYS Volumetric Temperature Transfer
    END
    CONTEXT: From STL File
       Essential Parameter List = Input File
       Optional Parameter List = File Units
    END
    CONTEXT: Patran Import
       Essential Parameter List = Input File
    END
    Allowed Parent List = ROOT
    Description = Allows the user to read an external file while contains elements \
                  describing a general 3D surface, with local variable values optionally \
                  specified on each node.  The surface can interact with CFD data and can \
                  be coloured  using local variables or domain variables.
  END

  OBJECT: PLANE
    CCLObject Class = PlaneCCLObject
    Category = point, surface, plane, deletable, constant-colour, \
             geometry, domain-dependent, selectable, \
             viewer-viewable, edge-based, has-variable, \
             has-variable-colour, mesh-density, quick-editable, \
             quick-animatable, suspendable
    Scheduler = top, geometry, colour, render
    Calculate Function = geometry, planecalc, PlaneCalcFunc, \
                         top, planecalc, PlaneCalcFunc, \
                         colour, planecalc, PlaneCalcFunc, \
                         render, planecalc, PlaneCalcFunc
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, \
                              Colour, Colour Variable, Colour Map, \
                              Colour Variable Boundary Values, \
                              Range, Min, Max, Colour Scale, \
                              Visibility, Transparency, Draw Faces, \
                              Surface Drawing, Draw Lines, Line Width, \
                              Line Colour, Line Colour Mode, Plane Bound, Bound Radius, \
                              Direction 1 Bound, Direction 2 Bound, \
                              Direction 1 Orientation, Direction 1 Points, \
                              Direction 2 Points, Plane Type, \
                              Invert Plane Bound, Lighting, \
                              Specular Lighting, Culling Mode, \
                              Instancing Transform, Apply Instancing Transform, \
                              Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges
 #  Preview Plane Size, Coord Frame, Plane Resolution, Bounded Plane
    Allowed Option List = XY Plane, YZ Plane, ZX Plane, Point and Normal, \
        Three Points
    CONTEXT: YZ Plane
      Optional Parameter List = X
    END
    CONTEXT: ZX Plane
      Optional Parameter List = Y
    END
    CONTEXT: XY Plane
      Optional Parameter List = Z
    END
    CONTEXT: Point and Normal
      Optional Parameter List = Point, Normal
    END
    CONTEXT: Three Points
       Optional Parameter List = Point 1, Point 2, Point 3
    END

    Allowed Parent List = ROOT
    Description = A general object to describe a plane through the domain.  \
                  Slice planes (which can be bounded) and sample planes are supported.
  END

  OBJECT: CLIP PLANE
    CCLObject Class = PlaneCCLObject
    Category = deletable, selectable, plane, suspendable
    Scheduler = top
    Calculate Function = top, clipplanecalc, ClipPlaneCalcFunc
    Essential Parameter List = Option
    Optional Parameter List = Flip Normal
    Allowed Option List = XY Plane, YZ Plane, ZX Plane, Point and Normal, \
        Three Points, From Slice Plane
    CONTEXT: YZ Plane
      Optional Parameter List = X
    END
    CONTEXT: ZX Plane
      Optional Parameter List = Y
    END
    CONTEXT: XY Plane
      Optional Parameter List = Z
    END
    CONTEXT: Point and Normal
      Optional Parameter List = Point, Normal
    END
    CONTEXT: Three Points
       Optional Parameter List = Point 1, Point 2, Point 3
    END
    CONTEXT: From Slice Plane
       Optional Parameter List = Slice Plane
    END
    Allowed Parent List = ROOT
    Description = Defines a plane that can be used to clip graphics in the viewer.
  END

  OBJECT: VOLUME
    CCLObject Class = GeometricCCLObject
    Category = point, deletable, constant-colour, volume,\
               geometry, domain-dependent, selectable, viewer-viewable, \
               has-variable, has-variable-colour, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = geometry, volumecalc, VolumeCalcFunc, \
                         top, volumecalc, VolumeCalcFunc, \
                         colour, volumecalc, VolumeCalcFunc, \
                         render, volumecalc, VolumeCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Element Type List, \
        Colour Mode, Colour, Colour Map, Colour Scale, \
        Colour Variable, Colour Variable Boundary Values, Range, Min, Max, \
        Visibility, Transparency, Draw Faces, Draw Lines, Line Width, \
        Line Colour, Line Colour Mode, Surface Drawing, Lighting, Specular Lighting, \
        Culling Mode, Inclusive, Instancing Transform, \
        Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges
    Allowed Option List = Sphere, From Surface, Isovolume, \
                          Surrounding Node, Element Number
    CONTEXT: Sphere
      Optional Parameter List = Point, Radius
    END
    CONTEXT: From Surface
      Optional Parameter List = Location List, Volume Intersection Mode
    END
    CONTEXT: Isovolume
      Optional Parameter List = Isovolume Intersection Mode, Variable, \
                                Variable Boundary Values, Value 1, Value 2
    END
    CONTEXT: Surrounding Node
      Optional Parameter List = Node Number
    END
    CONTEXT: Element Number
      Optional Parameter List = Element Number
    END
    Allowed Parent List = ROOT
    PARAMETER: Surface Drawing
      Default = Flat Shading
    END

    Description = An object that contains a subset of the volume elements of \
                  the domains it is defined on.  Options are provided \
                  to specify how that subset is defined.
  END
      
  OBJECT: INTERNAL VOLUME
    CCLObject Class = GeometricCCLObject
    Category = point, deletable, constant-colour, volume,\
               geometry, domain-dependent, selectable, viewer-viewable, \
               has-variable, has-variable-colour, internal, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = geometry, volumecalc, VolumeCalcFunc, \
                         top, volumecalc, VolumeCalcFunc, \
                         colour, volumecalc, VolumeCalcFunc, \
                         render, volumecalc, VolumeCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Element Type List, \
        Colour Mode, Colour, Colour Map, Colour Scale, \
        Colour Variable, Colour Variable Boundary Values, Range, Min, Max, \
        Visibility, Transparency, Draw Faces, Draw Lines, Line Width, \
        Line Colour, Line Colour Mode, Surface Drawing, Lighting, Specular Lighting, \
        Culling Mode, Inclusive, Instancing Transform, \
        Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges
    Allowed Option List = Sphere, From Surface, Isovolume, \
                          Surrounding Node, Element Number
    CONTEXT: Sphere
      Optional Parameter List = Point, Radius
    END
    CONTEXT: From Surface
      Optional Parameter List = Location List, Volume Intersection Mode
    END
    CONTEXT: Isovolume
      Optional Parameter List = Isovolume Intersection Mode, Variable, \
                                Variable Boundary Values, Value 1, Value 2
    END
    CONTEXT: Surrounding Node
      Optional Parameter List = Node Number
    END
    CONTEXT: Element Number
      Optional Parameter List = Element Number
    END

    Allowed Parent List = ROOT, CASE COMPARISON
    PARAMETER: Surface Drawing
      Default = Flat Shading
    END

    Description = An object that contains a subset of the volume elements of \
                  the domains it is defined on.  Options are provided \
                  to specify how that subset is defined.
  END

  OBJECT: LINE
    CCLObject Class = GeometricCCLObject
    Category = line, line-only, point, deletable, constant-colour, geometry, domain-dependent, \
             selectable, viewer-viewable, has-variable, has-variable-colour, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = top, linecalc, LineCalcFunc, \
                         geometry, linecalc, LineCalcFunc, \
                         colour, linecalc, LineCalcFunc, \
                         render, linecalc, LineCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, Colour Variable, \
                        Colour Variable Boundary Values, Visibility, Line Width, Range, \
                        Min, Max, Line Type, Line Samples, Draw Lines, \
                        Instancing Transform, Apply Instancing Transform, \
                        Colour Scale
    Internal Parameter List = Local Variable Ranges

    Allowed Option List = Two Points
    CONTEXT: Two Points
      Optional Parameter List = Point 1, Point 2
    END
    Allowed Parent List = ROOT
    PARAMETER: Colour
     Default = 1, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    Description = Defines a line object.
  END

  OBJECT: INTERNAL LINE
    CCLObject Class = GeometricCCLObject
    Category = line, line-only, point, deletable, constant-colour, geometry, domain-dependent, \
             selectable, viewer-viewable, has-variable, has-variable-colour, internal, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = top, linecalc, LineCalcFunc, \
                         geometry, linecalc, LineCalcFunc, \
                         colour, linecalc, LineCalcFunc, \
                         render, linecalc, LineCalcFunc
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Colour Mode, Colour, Colour Map, \
                        Colour Variable, Colour Variable Boundary Values, \
                        Visibility, Line Width, Range, \
                        Min, Max, Line Type, Line Samples, Draw Lines, \
                        Instancing Transform, Apply Instancing Transform, \
                        Colour Scale
    Internal Parameter List = Local Variable Ranges

    Allowed Option List = Two Points
    CONTEXT: Two Points
      Optional Parameter List = Point 1, Point 2
    END
    Allowed Parent List = ROOT, CASE COMPARISON
    PARAMETER: Colour
     Default = 1, 1, 0
    END
    PARAMETER: Line Width
     Default = 2
    END
    Description = Defines a line object.
  END

 OBJECT: CONTOUR
   CCLObject Class = ContourCCLObject
   Category = deletable, constant-colour, selectable, \
              viewer-viewable, has-variable-colour, has-local-variable, \
              domain-dependent, tbr-plot, suspendable
   Scheduler = top, geometry, colour, render
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Calculate Function = top, contourcalc, ContourCalcFunc, \
                        geometry, contourcalc, ContourCalcFunc, \
                        colour, contourcalc, ContourCalcFunc, \
                        render, contourcalc, ContourCalcFunc
   Essential Parameter List = Location List, Colour Variable
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Domain List, Number of Contours,\
                             Clip Contour, Colour Scale, Colour Map, \
                             Colour Variable Boundary Values, \
                             Contour Range, Min, Max, Value List,\
                             Visibility, Transparency, \
                             Surface Drawing, Line Width, \
                             Constant Contour Colour, \
                             Line Colour, Line Colour Mode, Lighting, \
                             Show Numbers, \
                             Draw Contours, Fringe Fill, Instancing Transform, \
                             Specular Lighting, Culling Mode, \
                             Apply Instancing Transform, \
                             Text Height, Font, Text Colour, Text Colour Mode, \
                             Use Face Values

   Internal Parameter List = Local Variable Ranges

   Allowed Parent List = ROOT
   Description = Creates a contour plot on a given list of locators.
 END

 OBJECT: INTERNAL CONTOUR
   CCLObject Class = ContourCCLObject
   Category = deletable, constant-colour, \
              viewer-viewable, has-variable-colour, has-local-variable, \
              domain-dependent, has-local-legend, suspendable
   Scheduler = top, geometry, colour, render
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Calculate Function = top, contourcalc, ContourCalcFunc, \
                        geometry, contourcalc, ContourCalcFunc, \
                        colour, contourcalc, ContourCalcFunc, \
                        render, contourcalc, ContourCalcFunc
   Essential Parameter List = Location List, Colour Variable
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Domain List, Number of Contours, \
                             Clip Contour, Colour Scale, Colour Map, \
                             Colour Variable Boundary Values, \
                             Contour Range, Min, Max, Value List, \
                             Visibility, Transparency, \
                             Surface Drawing, Line Width, \
                             Constant Contour Colour, \
                             Line Colour, Line Colour Mode, Lighting, \
                             Show Numbers, \
                             Draw Contours, Fringe Fill, Instancing Transform, \
                             Specular Lighting, Culling Mode, \
                             Apply Instancing Transform, \
                             Text Height, Font, Text Colour, Text Colour Mode, \
                             Use Face Values

   Internal Parameter List = Local Variable Ranges

   Allowed Parent List = ROOT, CASE COMPARISON
   Description = Creates a contour plot on a given list of locators (internal version).
   PARAMETER: Location List
     Local Type = top
     Remote Type = colour
   END
 END

 OBJECT: SURFACE GROUP
   CCLObject Class = GeometricCCLObject
   Category = point, surface, deletable, constant-colour, \
              geometry,  domain-dependent, selectable, viewer-viewable, \
              has-variable, has-variable-colour, suspendable
   Scheduler = top, geometry, colour, render
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Calculate Function = top, surfacegroupcalc, SurfaceGroupCalcFunc, \
                        geometry, surfacegroupcalc, SurfaceGroupCalcFunc, \
                        colour, surfacegroupcalc, SurfaceGroupCalcFunc, \
                        render, surfacegroupcalc, SurfaceGroupCalcFunc
   Essential Parameter List = Location List
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Domain List, Colour Scale, Colour Mode, \
        Colour, Colour Variable, Colour Map, Colour Variable Boundary Values, \
        Range, Min, Max, Visibility, Transparency, Draw Faces, \
        Surface Drawing, Draw Lines, Line Width, Line Colour, Line Colour Mode, \
        Lighting, Specular Lighting, Culling Mode, Instancing Transform, \
        Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

   Internal Parameter List = Local Variable Ranges, Object State
   Allowed Parent List = ROOT
   Description = Creates a group of surface plot on a given list of locators.
 END

 OBJECT: INTERNAL SURFACE GROUP
   CCLObject Class = GeometricCCLObject
   Category = point, surface, deletable, constant-colour, \
              geometry,  domain-dependent, viewer-viewable, \
              has-variable, has-variable-colour, has-local-legend, suspendable
   Scheduler = top, geometry, colour, render
   Scheduler Links = top, geometry, geometry, colour, colour, render
   Calculate Function = top, surfacegroupcalc, SurfaceGroupCalcFunc, \
                        geometry, surfacegroupcalc, SurfaceGroupCalcFunc, \
                        colour, surfacegroupcalc, SurfaceGroupCalcFunc, \
                        render, surfacegroupcalc, SurfaceGroupCalcFunc
   Essential Parameter List = Location List
   Optional Child List = OBJECT VIEW TRANSFORM
   Optional Parameter List = Domain List, Colour Scale, Colour Mode, \
        Colour, Colour Variable, Colour Map, Colour Variable Boundary Values, \
        Range, Min, Max, Visibility, Transparency, Draw Faces, \
        Surface Drawing, Draw Lines, Line Width, Line Colour, Line Colour Mode, \
        Lighting, Specular Lighting, Culling Mode, Instancing Transform, \
        Apply Instancing Transform, Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

   Internal Parameter List = Local Variable Ranges, Object State
   Allowed Parent List = ROOT
   Description = Creates a group of surface plot on a given list of locators.
 END


  OBJECT: DIFFERENCE OBJECT
    CCLObject Class = GeometricCCLObject
    Category = point, surface, deletable, constant-colour, \
               geometry,  domain-dependent, viewer-viewable, \
               has-variable, has-variable-colour, internal, \
               has-local-variable, suspendable 
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = top, differenceobjectcalc, DifferenceObjectCalcFunc, \
                         geometry, differenceobjectcalc, DifferenceObjectCalcFunc, \ 
                         colour, differenceobjectcalc, DifferenceObjectCalcFunc, \
                         render, differenceobjectcalc, DifferenceObjectCalcFunc
    Essential Parameter List = Location List
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Visibility, Colour Variable, Domain List, \
         Colour, Colour Mode, Colour Map, Colour Variable Boundary Values, \
         Colour Scale, Instancing Transform
    Internal Parameter List = \
         Range, Min, Max, Object State, Transparency, Draw Faces, \
         Surface Drawing, Draw Lines, Line Width, Line Colour, Line Colour Mode, \
         Lighting, Specular Lighting, Culling Mode, \
         Apply Instancing Transform, Render Edge Angle, \
         Apply Texture, Texture Type, \
         Texture File, Texture Material, \
         Texture Direction, Texture Position, \
         Texture Scale, Texture Angle, Tile Texture, \
         Blend Texture, Transform Texture, Local Variable Ranges, Add Local Variable
         
    PARAMETER: Location List
      Local Type = top
      Remote Type = render
    END
    Allowed Parent List = ROOT, CASE COMPARISON
    Description = Creates a group of surface plot on a given list of locators.
  END

#
# VOLUME RENDERING
#


  PARAMETER: Volume Resolution
    Parameter Type = Integer
    Default = 20
    Local Type = top
    Description = The resolution of the density, or number of plane cuts per axis.
  END
  
  PARAMETER: Volume Rendering Range
    Parameter Type = String
    Allowed String List = Global, Local, User Specified
    Local Type = top
    Default = Global
    Description = Sets the method used to calculate the extents of the density. \
                "Global" uses the range of values in the problem domain. "Local" \
                uses the range of values on the current object.
  END
  
  PARAMETER: Volume Rendering Min
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Description = The minimum value of a variable which represents transparency when using a \
                "User Specified" range.

  END
 
  PARAMETER: Volume Rendering Max
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Description = The maximum value of a variable which represents transparency when using a \
                "User Specified" range.

  END
 
  PARAMETER: Volume Rendering Scale
    Parameter Type = String
    Allowed String List = Linear, Logarithmic
    Default = Linear
    Local Type = render
    Description = Sets whether to calculate the object density with a Linear \
                 or Logarithmic scale.  By default, the scale is Linear.
  END

  PARAMETER: Density Variable Ranges
    Parameter Type = String List
    Description = A list of Variable Local Range data in base units.  Each element in the \
                list contains: "<Variable Name> : <Hybrid/Conservative> : \
                <Min Value> : <Max Value>"
  END
  
  PARAMETER: Volume Rendering Faceset Data
    Parameter Type = String List
    Description = The data is in the following form: \
        [num domains], <[normal], <[num plane clips], <[domain name], [num faces]>>>,...
    
  END

  PARAMETER: Clip Planes
    Parameter Type = Logical
    Default = On
    Local Type = top
    Description = If On, then cut the planes down by extents of density variable min and max.
  END

  PARAMETER: Make Edges Transparent
    Parameter Type = Logical
    Default = Off
    Local Type = render
    Description = If On, then all free edges are made to be transparent, lessening fringing artifacts.
  END

  PARAMETER: Transparency Colour Map
    Parameter Type = String
    Default = Transparency
    Local Type = colour
    Remote Type = top
    Description = The name of the colour map to use when rendering transparency the object.
  END

  PARAMETER: Volume Rendering Normals
    Parameter Type = Real List
    Default = 1.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 1.0
    Local Type = top
    Description = The data is a list of normal components for which to generate volume rendering planes from.
  END

  PARAMETER: Normals From Views
    Parameter Type = String List
        Local Type = top
    Description = A list of VIEW objects from which we will grab the normal from and form \
                        union with Volume Rendering Normals.
  END
  
  OBJECT: VOLUME RENDERING
    CCLObject Class = GeometricCCLObject
    Category = deletable, constant-colour, domain-dependent, selectable, \
             viewer-viewable, has-variable-colour, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = top, volumecalc, VolumeRenderingCalcFunc, \
                         geometry, volumecalc, VolumeRenderingCalcFunc, \
                         colour, volumecalc, VolumeRenderingCalcFunc, \
                         render, volumecalc, VolumeRenderingCalcFunc
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Volume Rendering Normals, Normals From Views, \
                           Volume Resolution, Variable, \
                           Volume Rendering Range, Volume Rendering Min, Volume Rendering Max, \
                           Variable Boundary Values, Make Edges Transparent, \
                           Volume Rendering Scale, Clip Planes, Transparency Colour Map, \                           
                           Colour Mode, Colour, Colour Variable, Colour Map, \
                           Colour Variable Boundary Values, \
                           Range, Min, Max, Colour Scale, \
                           Visibility, Draw Faces, Surface Drawing, \
                           Draw Lines, Line Width, \
                           Line Colour, Line Colour Mode, \
                                                Lighting, Transparency, \
                           Specular Lighting, Culling Mode, \
                           Instancing Transform, Apply Instancing Transform, \
                           Render Edge Angle, \                       
                           Apply Texture, Texture Type, \
                           Texture File, Texture Material, \
                           Texture Direction, \
                           Texture Position, \
                           Texture Scale, Texture Angle, Tile Texture, \
                           Blend Texture, Transform Texture
    Internal Parameter List = Local Variable Ranges, Density Variable Ranges, \
                           Volume Rendering Faceset Data
    PARAMETER: Colour Mode
      Default = Use Plot Variable
    END
    PARAMETER: Specular Lighting
      Default = Off
    END
    PARAMETER: Lighting
      Default = Off
    END
    PARAMETER: Transparency
      Default = 0.2
    END
    Allowed Parent List = ROOT
    Description = A general object to describe a volume visualization, or smoke.
  END

# For comparison mode
OBJECT: INTERNAL VOLUME RENDERING
    CCLObject Class = GeometricCCLObject
    Category = deletable, constant-colour, domain-dependent, selectable, \
             viewer-viewable, has-variable-colour, suspendable
    Scheduler = top, geometry, colour, render
    Scheduler Links = top, geometry, geometry, colour, colour, render
    Calculate Function = top, volumecalc, VolumeRenderingCalcFunc, \
                         geometry, volumecalc, VolumeRenderingCalcFunc, \
                         colour, volumecalc, VolumeRenderingCalcFunc, \
                         render, volumecalc, VolumeRenderingCalcFunc
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, Volume Rendering Normals, Normals From Views, \
                           Volume Resolution, Variable, \
                           Volume Rendering Range, Volume Rendering Min, Volume Rendering Max, \
                           Variable Boundary Values, Make Edges Transparent, \
                           Volume Rendering Scale, Clip Planes, Transparency Colour Map, \                           
                           Colour Mode, Colour, Colour Variable, Colour Map, \
                           Colour Variable Boundary Values, \
                           Range, Min, Max, Colour Scale, \
                           Visibility, Draw Faces, Surface Drawing, \
                           Draw Lines, Line Width, \
                           Line Colour, Line Colour Mode, \
                                                Lighting, Transparency, \
                           Specular Lighting, Culling Mode, \
                           Instancing Transform, Apply Instancing Transform, \
                           Render Edge Angle, \                       
                           Apply Texture, Texture Type, \
                           Texture File, Texture Material, \
                           Texture Direction, \
                           Texture Position, \
                           Texture Scale, Texture Angle, Tile Texture, \
                           Blend Texture, Transform Texture
    Internal Parameter List = Local Variable Ranges, Density Variable Ranges, \
                           Volume Rendering Faceset Data
    PARAMETER: Colour Mode
      Default = Use Plot Variable
    END
    PARAMETER: Specular Lighting
      Default = Off
    END
    PARAMETER: Lighting
      Default = Off
    END
    PARAMETER: Transparency
      Default = 0.2
    END
    Allowed Parent List = ROOT
    Description = A general object to describe a volume visualization, or smoke.
  END

#
# END VOLUME RENDERING
#



  PARAMETER: Meridional Point 1
    Parameter Type = Real List
    Local Type = top
    Remote Type = expression
    Default = 0.0, 1.0
    Description = A-R coordinates defining a point in meridional plane.
  END
  PARAMETER: Meridional Point 2
    Parameter Type = Real List
    Local Type = top
    Remote Type = expression
    Default = 1.0, 2.0
    Description = A-R coordinates defining a point in meridional plane.
  END
  PARAMETER: Meridional Points
    Parameter Type = Integer
    Local Type = top
    Default = 10
    Description = Number of points in the meridional plane \
        (used in sample mode).
  END
 PARAMETER: Project to AR Plane
   Parameter Type = Logical
   Local Type = top
   Default = On
   Description = Enables/disables projecting of line points to AR plane before \
        the generation of surface of revolution.
 END
 PARAMETER: Use Angle Range
  Parameter Type = Logical
  Local Type = top
  Default = Off
  Description = If set to true Theta Min and Theta Max are used to limit the \
        surface. Otherwise, a 360 degree surface is generated.
 END
  PARAMETER: Starting Axial Shift
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0 [m]
    Description = Shift in the axial direction for the initial theta location.
  END
  PARAMETER: Ending Axial Shift
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0 [m]
    Description = Shift in the axial direction for the final theta location.
  END
  PARAMETER: Starting Radial Shift
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0 [m]
    Description = Shift in the radial direction for the initial theta location.
  END
  PARAMETER: Ending Radial Shift
    Parameter Type = Real
    Local Type = top
    Remote Type = expression
    Default = 0.0 [m]
    Description = Shift in the radial direction for the final theta location.
  END

  OBJECT: SURFACE OF REVOLUTION
    CCLObject Class = GeometricCCLObject
    Category = point, surface, deletable, constant-colour, \
                geometry, domain-dependent, selectable, viewer-viewable,  \
                has-variable, has-variable-colour, suspendable
    Scheduler = instance, top, geometry, colour, render
    Calculate Function = top, surfaceofrevolutioncalc, SurfaceOfRevolutionCalcFunc, \
                         geometry, surfaceofrevolutioncalc, SurfaceOfRevolutionCalcFunc, \
                         colour, surfaceofrevolutioncalc, SurfaceOfRevolutionCalcFunc, \
                         render, surfaceofrevolutioncalc, SurfaceOfRevolutionCalcFunc
    Scheduler Links = instance, top, top, geometry, geometry, colour, colour, render
    Essential Parameter List = Option
    Optional Child List = OBJECT VIEW TRANSFORM
    Optional Parameter List = Domain List, \
                              Rotation Axis Type, Principal Axis, \
                              Rotation Axis From, Rotation Axis To, \
                              Theta Points, \
                              Use Angle Range, Theta Min, Theta Max, \
                              Starting Axial Shift, Ending Axial Shift, \
                              Starting Radial Shift, Ending Radial Shift, \
                              Colour Mode, \
                              Colour, Colour Variable, Colour Map, \
                              Colour Variable Boundary Values, \
                              Range, Min, Max, Colour Scale, \
                              Visibility, Transparency, Draw Faces, \
                              Surface Drawing, Draw Lines, Line Width, \
                              Line Colour, Line Colour Mode, Lighting, \
                              Specular Lighting, Culling Mode, \
                              Instancing Transform, Apply Instancing Transform, \
                              Render Edge Angle, \
                              Apply Texture, Texture Type, \
                              Texture File, Texture Material, \
                              Texture Direction, \
                              Texture Position, \
                              Texture Scale, Texture Angle, Tile Texture, \
                              Blend Texture, Transform Texture

    Internal Parameter List = Local Variable Ranges
    Allowed Option List = Cylinder, Cone, Disc, Sphere, From Line
    CONTEXT: Cylinder
      Optional Parameter List = Meridional Point 1, Meridional Point 2, \
        Meridional Points
    END
    CONTEXT: Cone
      Optional Parameter List = Meridional Point 1, Meridional Point 2, \
        Meridional Points
    END
    CONTEXT: Disc
      Optional Parameter List = Meridional Point 1, Meridional Point 2, \
        Meridional Points
    END
    CONTEXT: Sphere
      Optional Parameter List = Meridional Point 1, Meridional Points
    END
    CONTEXT: From Line
      Essential Parameter List = Location List
      Optional Parameter List = Project to AR Plane
    END
    Allowed Parent List = ROOT
    Description = A general surface of revolution object.
  END

# Action Executor Objects

 SINGLETON: HARDCOPY
   CCLObject Class = DataCCLObject
   Essential Parameter List = Hardcopy Format
   Optional Parameter List = Hardcopy Filename, Hardcopy Tolerance
   Context Rule = Hardcopy Format
   Allowed Option List = ps, eps, jpg, ppm, bmp, png, vrml, cvf, avz, gltf
   CONTEXT: ps
     Optional Parameter List = Paper Size, Print Quality, \
                               Paper Orientation, White Background, \
                               Print Line Width
   END
   CONTEXT: eps
     Optional Parameter List = Paper Size, Print Quality, \
                               Paper Orientation, White Background, \
                               Print Line Width
   END
   CONTEXT: bmp
       Optional Parameter List = Print Quality, White Background, \
                                 Use Screen Size, Image Width, Image Height, \
                                 Image Scale, Print Line Width, \
                                 Screen Capture, Antialiasing
   END
   CONTEXT: jpg
       Optional Parameter List = Print Quality, White Background, \
                                 Use Screen Size, Image Width, Image Height, \
                                 Image Scale, Print Line Width, \
                                 Screen Capture, Antialiasing, JPEG Image Quality
   END
   CONTEXT: png
       Optional Parameter List = Print Quality, White Background, \
                                 Use Screen Size, Image Width, Image Height, \
                                 Image Scale, Print Line Width, \
                                 Screen Capture, Antialiasing
   END
   CONTEXT: ppm
       Optional Parameter List = Print Quality, White Background, \
                                 Use Screen Size, Image Width, Image Height, \
                                 Image Scale, Print Line Width, \
                                 Screen Capture, Antialiasing
   END
   Allowed Parent List = ROOT
   Description = This object contains the settings used to control the creation of \
               hardcopy output from the viewer.  It is used by the "print" action.

 END

 SINGLETON: DATA READER
   CCLObject Class = DataCCLObject
   Optional Parameter List = \
                             Current Case List, \
                             Current Results File, \
                             Current Case Name, \
                             Master Results File, \
                             Multi Configuration File Load Option, \
                             Current Timestep, \
                             Current Timevalue, \
                             Timestep Sync Mode, \
                             Timevalue Match Criterion, \
                             Timestep Match Criterion, \
                             Domains to Load, \
                             Force File Reload, \
                             Clear All Objects, \
                             Keep Camera Position, \
                             Load Particle Tracks, \
                             Construct Variables From Fourier Coefficients, \
                             Append Results, \
                             Apply X Offset, \
                             Apply Y Offset, \
                             Apply Z Offset, \
                             Open in New View, \
                             Open to Compare, \
                             Edit Case Names, \
                             File Length Units, \
                             File Mass Units, \
                             File Time Units, \
                             File Temperature Units, \
                             File Angle Units, \
                             File Light Units, \
                             File Money Units, \
                             File Current Units, \
                             File Solid Angle Units, \
                             File Chemical Amount Units, \
                             Files to Compare, \
                             Active Case Name, \
                             Reference Acoustic Pressure, \
                             Reference Length, \
                             Reference Velocity
                             

   Internal Parameter List = \
                             Current File Type, \ 
                             Current Results File Version, \
                             Particle Track Material List, \
                             Expression List, \
                             File Is Turbo, \
                             Load Domain Geometry On Demand, \
                             Timestep List, \


   Optional Child List = CASE
   Allowed Parent List = ROOT
   Description = This object contains the settings used to read results files into \
               the post-processor.  It is used by the "load" action.
 END           

PARAMETER: Timestep Sampling
  Parameter Type = String
  Allowed String List = Simulation Timestep, Uniform, Value List
  Default = Simulation Timestep
  Local Type = top
  Description = 
END

PARAMETER: Number of Timesteps
  Parameter Type = Integer
  Default = 10
  Local Type = top
  Description = 
END

PARAMETER: Specify Phase Range
  Parameter Type = Logical
  Default = Off
END

PARAMETER: Minimum Phase
  Parameter Type = Float
  Default = 0.0
END

PARAMETER: Maximum Phase
  Parameter Type = Float
  Default = 1.0
END

PARAMETER: Phase Positions
  Parameter Type = Real List
  Default = 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1
  Local Type = top
  Description = 
END

 SINGLETON: TBR OPTIONS
   CCLObject Class = GenericCCLObject
   Category = suspendable
   Scheduler = top
   Calculate Function = top, tbrcalc, TBRCalcFunc
   Optional Parameter List = Timestep Sampling
   Context Rule = Timestep Sampling
   Allowed Option List = Simulation Timestep, Uniform, Value List
   CONTEXT: Uniform
     Optional Parameter List = \
       Number of Timesteps, \
       Specify Phase Range, \
       Minimum Phase, \
       Maximum Phase
   END
   CONTEXT: Value List
     Optional Parameter List = Phase Positions
   END
 
   Allowed Parent List = CASE
 END
 
 OBJECT: CASE
   CCLObject Class = GenericCCLObject
   Category = internal
   Scheduler = instance, render, top
   Scheduler Links = instance, render
   Calculate Function =  render, casecalc, CaseCalcFunc
   Optional Parameter List = Current Results File, \
     Current Case Name, \
     Current Timestep, \
     Current Timevalue, \
     Domains to Load, \
     File Length Units, \
     File Mass Units, \
     File Time Units, \
     File Temperature Units, \
     File Angle Units, File Light Units, \
     File Money Units, \
     File Current Units, \
     File Solid Angle Units, \
     File Chemical Amount Units, \
     Additional Timestep Files, \
     Multi Configuration File Load Option, \
     Workbench ID, \
     Construct Variables From Fourier Coefficients
                           
   Internal Parameter List = Current File Type, \
                             Current Mesh File, \
                             Current Configuration Name, \
                             Current Results File Version, \
                             Particle Track Material List, \
                             Expression List, \
                             File Is Turbo, \
                             File Has Multiple Configurations, \
                             Timestep List, \
                             Previous Timestep, \
                             Available Domains, \
                             Machine Type, \
                             Flow Type, \
                             Case Is Transient

   Optional Child List = OBJECT VIEW TRANSFORM, DOMAIN, SUBDOMAIN, \
                         COMPOSITE, BOUNDARY, PRIMITIVE2D, PRIMITIVE3D, \
                         COMPOSITE PERIODIC, COMPOSITE INTER BLOCK, TBR OPTIONS
                        

   Allowed Parent List = DATA READER
   Description = This object contains information and settings about a \
               results file  that is read into the post-processor.  \
               It is used by DATA READER object.
 END           


##  COMPARE CASE parameters
  PARAMETER: Mode Is Active
    Parameter Type = Boolean
    Default = false
    Local Type = top
    Description = Indication of whether this comparison mode is turned on.
  END

  PARAMETER: Case Name 1
    Parameter Type = String
    Local Type = top
    Description = First case name in results comparison.
  END

  PARAMETER: Case Name 2
    Parameter Type = String
    Local Type = top
    Description = Second case name in results comparison.
  END

  PARAMETER: Synchronize Visibility on Activate
    Parameter Type = Boolean
    Default = true
    Local Type = top
    Description = Turn on Visibility Synchronization when mode activated.
  END

  PARAMETER: Synchronize Camera on Activate
    Parameter Type = Boolean
    Default = true
    Local Type = top
    Description =  Turn on Camera Synchronization when mode activated.
  END

  PARAMETER: Absolute Value of Difference
    Parameter Type = Boolean
    Default = false
    Local Type = top
    Description = Use absolute value in the difference variable calculation.
  END

  PARAMETER: Same Mesh Detection Mode
    Allowed String List = Same Mesh, Different Mesh, Auto Detect
    Parameter Type = String
    Local Type = top
    Default = Auto Detect
    Description = String to indicate how to detect same meshes for file comparison
  END


 SINGLETON: CASE COMPARISON
   CCLObject Class = ComparisonCCLObject
   Scheduler = top

   Optional Parameter List = Mode Is Active, \
                             Case Name 1, \
                             Case Name 2, \
                             Synchronize Visibility on Activate, \
                             Synchronize Camera on Activate, \
                             Absolute Value of Difference, \
                             Same Mesh Detection Mode

   Allowed Parent List = DATA READER
   Optional Child List = DIFFERENCE OBJECT, \
                         INTERNAL VECTOR, \
                         INTERNAL CONTOUR, \
                         INTERNAL STREAMLINE, \
                         INTERNAL POINT, \
                         INTERNAL POINT CLOUD, \
                         INTERNAL POLYLINE, \
                         INTERNAL VOLUME, \
                         INTERNAL VOLUME RENDERING, \
                         INTERNAL LINE, \
                         INTERNAL TURBO SURFACE, \
                         INTERNAL TURBO LINE, \
                         LEGEND
   Description = This object contains information and settings for \
               the comparison of two (for now) results files or timesteps.  \
               It is used by DATA READER object.
 END           



 SINGLETON: DEFORMATION INFO
   CCLObject Class = DeformationCCLObject
   Category = suspendable
   Scheduler = render
   Optional Parameter List = Deformation Scale
   Internal Parameter List = Deformation Variable, Deformation Auto Scale

   Allowed Parent List = ROOT
   Description = This object contains the settings used to render \
               deformation for all GeometricCCLObject.
 END           

# Although the Export object does not require a scheduler, it is added to make
# the system work since the Location parameter is a scheduled parameter (since
# it is used elsewhere).
SINGLETON: EXPORT
   Category = deletable, suspendable
   Scheduler = top
   Optional Parameter List = Export File, Export Type, Overwrite, \
     Export Chart Name, Include Header, Separator, Include File Information, \
     Export Units System, Split Cut Lines
   Context Rule = Export Type
   Allowed Option List = Generic, ANSYS, BC Profile, Case Summary, \
     External Data, Geometry Only, STL
  
   CONTEXT: Generic
     Optional Parameter List = Location List, Export Location Aliases, \
       Variable List, Export Geometry, Export Connectivity, \
       Export Node Numbers, Export Null Data, Null Token, Precision, \
       Vector Display, Vector Brackets, Export Coord Frame, \
       Export Variable Type
   END
   CONTEXT: ANSYS
     Optional Parameter List = ANSYS Export Data, ANSYS Export Locator, \
       ANSYS Specify Reference Temperature, ANSYS Reference Temperature, \
       ANSYS Supplemental HTC, ANSYS Fluid Selection, Export Variable Type, \
       CFX Timestep List, ANSYS Timestep List, ANSYS Export Units, \
       ANSYS File Format
   END
   CONTEXT: BC Profile
     Optional Parameter List = Location List, Export Location Aliases, \
       BC Profile Type, Spatial Variables, Variable List, Precision, \
       Export Coord Frame, Export Variable Type
   END
   CONTEXT: Case Summary
     Optional Parameter List = Case Summary Format, Case Summary Type
   END
   PARAMETER: Location
      Parameter Type = String
      Description = A locator name
   END
   CONTEXT: External Data
     Optional Parameter List = External Export Data, Location, \
       Additional Variable List, Heat Flow Sign Flipping, Export \
       Variable Type, Precision
   END
   CONTEXT: Geometry Only
     Optional Parameter List = Export Geometry Location, \
       Export Location Aliases, Precision
   END
   CONTEXT: STL
     Optional Parameter List = Export Geometry Location, \
       Export Location Aliases, Precision
   END
   Allowed Parent List = ROOT
   Description = Holds parameters which control the export of data to an \
     external text file.
END

# SESSION AND STATE OBJECTS:

SINGLETON: SESSION
  Category = deletable
  Essential Parameter List = Session Filename
  Optional Parameter List = Write Session Mode
  Allowed Parent List = ROOT
  Description = Stores parameters used by the readsession command.
END

SINGLETON: STATE
  Category = deletable
  Essential Parameter List = State Filename
  Optional Parameter List = Read State Mode, Save State Mode, \
        Load Data, Save State Objects, Keep Results Expressions
  Description = Stores parameters used by the readstate and savestate commands.
  Allowed Parent List = ROOT
END


##########################
###  VIEWPORT MANAGER  ###
##########################

PARAMETER: Viewport Layout
  Parameter Type = String
  Default = No Split
  Allowed String List = No Split, Vertical Split, Horizontal Split, Horizontal And Left Split, \
        Vertical And Top Split, Horizontal And Right Split, Vertical And Bottom Split, \
        Horizontal And Vertical Split
  Local Type = top
  Description = Specifies the layout of viewports.
END
PARAMETER: X Split
  Parameter Type = Real
  Local Type = top
  Remote Type = expression
  Default = 0.5
  Description = The normalized location of the vertical viewport \
                splitter.
END
PARAMETER: Y Split
  Parameter Type = Real
  Local Type = top
  Remote Type = expression
  Default = 0.5
  Description = The normalized location of the horizontal viewport \
                splitter.
END
PARAMETER: Maximized Viewport
  Parameter Type = Integer
  Default = -1
  Local Type = render
  Description = If set to a viewport number (1-4), the viewport will be \
                resized to fill up the screen, regardless of the viewport layout.
END
PARAMETER: Background Type
  Parameter Type = String
  Default = Colour
  Allowed String List = Colour, Image
  Local Type = render
  Description = Specifies the type of background to use in the viewer.
END
PARAMETER: Background Colour Type
  Parameter Type = String
  Default = Top-Bottom Gradient
  Allowed String List = Solid, Top-Bottom Gradient, Left-Right Gradient, \
        Diagonal Gradient
  Local Type = render
  Description = Specifies the type of background colour gradient to use \
                in the viewer.
END
PARAMETER: Background Colour
  Parameter Type = Real List
  Local Type = render
  Default = 0, 0.5, 1
  Parameter Category = RGBColour
  Description = Defines the R, G and B values for the viewer background colour.
END
PARAMETER: Background Colour 2
  Parameter Type = Real List
  Local Type = render
  Default = 1, 1, 1
  Parameter Category = RGBColour
  Description = Defines the R, G and B values for the second viewer background colour \
                (used for gradients)
END
PARAMETER: Background Image Type
  Parameter Type = String
  Allowed String List = Predefined, Custom
  Default = Predefined
  Local Type = render
  Description = The type of image to use.
END
PARAMETER: Background Image
  Parameter Type = String
  Allowed String List = Mountains, Earth West, Earth East
  Default = Mountains
  Local Type = render
  Description = The predefined image to use
END
PARAMETER: Background Image Mapping
  Parameter Type = String
  Allowed String List = Flat, Spherical
  Default = Flat
  Local Type = render
  Description = Flat - image is mapped as a flat background; Spherical - image is \
                mapped to a background sphere (must have 2x1 width to height pixel ratio)
END
PARAMETER: Background Image File
  Parameter Type = String
  Local Type = render
  Description = The image file to use for the viewer background.
END
PARAMETER: Global Text Colour
  Parameter Type = Real List
  Local Type = text colour
  Default = 0, 0, 0
  Parameter Category = RGBColour
  Description = Defines the global colour used for Text objects
END
PARAMETER: Global Edge Colour
  Parameter Type = Real List
  Local Type = edge colour
  Default = 0, 0, 0
  Parameter Category = RGBColour
  Description = Defines the global colour used for mesh edges
END
PARAMETER: Viewport 1 View
  Parameter Type = String
  Local Type = top
  Remote Type = delete
  Description = Specifies the VIEW that Viewport 1 should display.
END
PARAMETER: Viewport 2 View
  Parameter Type = String
  Local Type = top
  Remote Type = delete
  Description = Specifies the VIEW that Viewport 2 should display.
END
PARAMETER: Viewport 3 View
  Parameter Type = String
  Local Type = top
  Remote Type = delete
  Description = Specifies the VIEW that Viewport 3 should display.
END
PARAMETER: Viewport 4 View
  Parameter Type = String
  Local Type = top
  Remote Type = delete
  Description = Specifies the VIEW that Viewport 4 should display.
END

PARAMETER: View Length Units
  Parameter Type = String
  Default = m
  Description = Length units used in viewer
  Local Type = ruler
END

PARAMETER: Synchronize Camera
  Parameter Type = Boolean
  Default = false
  Local Type = render
  Description = Specifies if cameras in the active views will be synchronized.
END

PARAMETER: Synchronize Visibility
  Parameter Type = Boolean
  Default = true
  Description = Specifies if visibility of an object in the active views will be synchronized.
END

PARAMETER: Viewer Eye Point
  Paramter Type = String
  Allowed String List = Normal, Stereo, Split
  Local Type = render
  Default = Normal
  Description = Specifies whether to place the viewer in a Stereo mode.
END

PARAMETER: Viewer Camera Z
  Paramter Type = Real
  Local Type = render
  Default = -5
  Description = Specifies the distance from the scene origin to the screen plane
END

PARAMETER: Viewer Eye Separation
  Parameter Type = Real
  Local Type = render
  Default = 5
  Description = Specifies the distance between the eyes for Stereo Mode.  A larger \
                                number will increase the stereo effect, and a smaller number will \
                                decrease the stereo effect.
END

SINGLETON: VIEWPORT MANAGER
  CCLObject Class = ViewportManagerCCLObject
  Category = suspendable
  Scheduler = top, render, edge colour, text colour, ruler
  Optional Parameter List = Viewport Layout, \
        X Split, Y Split, Maximized Viewport, \
        Background Type, Background Colour Type, Background Image Type, \
        Background Image, Background Image File, Background Image Mapping, \
        Background Colour, Background Colour 2, \
        Global Edge Colour, Global Text Colour, \
        Viewport 1 View, Viewport 2 View, Viewport 3 View, Viewport 4 View, \
    Synchronize Camera, Synchronize Visibility, View Length Units, \
    Viewer Eye Point, Viewer Camera Z, Viewer Eye Separation
  Allowed Parent List = ROOT
  Description = This object stores the parameters that control the\
                global viewport controls.
END


################
###  CAMERA  ###
################

PARAMETER: Pivot Point
  Parameter Type = Real List
  Local Type = top
  Default = 0.0, 0.0, 0.0
  Parameter Category = Position
  Description = Defines the center of rotation (pivot point) for the camera.
END
PARAMETER: Scale
  Parameter Type = Real
  Local Type = top
  Default = 1.0
  Description = Defines the relative scale of the camera view. With the \
                default scale (1.0), the scene completely fills the viewer window. 
END
PARAMETER: Pan
  Parameter Type = Real List
  Local Type = top
  Default = 0.0, 0.0
  Description = Defines the camera pan in screen (X, Y) coordinates, with \
                positive X pointing right and positive Y pointing up.
END
PARAMETER: Rotation Quaternion
  Parameter Type = Real List
  Local Type = top
  Default = -0.707107, 0, 0, 0.707107
  Parameter Category = Quaternion
  Description = Defines the camera rotation quaternion.
END
PARAMETER: Rotation
  Parameter Type = Real List
  Local Type = top
  Default = -90, 0, 0
  Parameter Category = Direction
  Description = Defines the camera rotation in terms of angles about X, Y and \
                Z axis, respectively. X axis is pointing right, Y is pointing \
                up and Z towards the user.
END
PARAMETER: Send To Viewer
  Parameter Type = Logical
  Default = true
  Description = A parameter that indicates whether or not the parent VIEW \
                object should be updated with this CAMERA CCL.
END
# Camera is a singleton since only one CAMERA object can
# be specified for a VIEW object.
SINGLETON: CAMERA
  CCLObject Class = CameraCCLObject
  Category = suspendable
  Scheduler = top
  Essential Parameter List = Option
  Optional Parameter List = Send To Viewer
  Allowed Option List = Pivot Point and Quaternion, Pivot Point and Rotation
  CONTEXT: Pivot Point and Quaternion
    Optional Parameter List = Pivot Point, Rotation Quaternion, Scale, Pan
  END
  CONTEXT: Pivot Point and Rotation
    Optional Parameter List = Pivot Point, Rotation, Scale, Pan
  END
  Allowed Parent List = VIEW
  Description = Defines a camera that can be used to specify the current view in \
                a VIEW object.
END


##############
###  VIEW  ###
##############

PARAMETER: Camera Mode
  Parameter Type = String
  Local Type = camera
  Allowed String List = Standard, User Specified
  Default = Standard
  Description = Defines the current viewer camera mode. It can be either \
                Standard (specified by Standard View parameter) or User Specified, in \
                which case a CAMERA object has to be defined and specified in \
                User Camera parameter.
END
#PARAMETER: User Camera
#  Parameter Type = String
#  Local Type = camera
#  Remote Type = top
#  Description = Defines the CAMERA object that is used to set up the camera \
#               view in the viewer (Note that Camera Mode has to be set to User \
#               Specified for this parameter to have effect).
#END
PARAMETER: Standard View
  Parameter Type = String
  Local Type = camera
  Allowed String List = +X, +Y, +Z, -X, -Y, -Z, \
                Isometric, Isometric X, Isometric Y, Isometric Z
  Default = Isometric Y
  Description = Defines one of the standard views in the viewer (Note that \
                Camera Mode has to be set to Standard for this parameter to have \
                effect).
END
PARAMETER: Projection
  Parameter Type = String
  Local Type = render
  Allowed String List = Perspective, Orthographic
  Default = Orthographic
  Description = Defines the current projection mode in the viewer. It can be \
                either Perspective or Orthographic.
END
PARAMETER: Axis Visibility
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Toggles the axis visibility in the viewport.
END
PARAMETER: Ruler Visibility
  Parameter Type = Logical
  Default = true
  Local Type = render
  Description = Toggles the ruler visibility in the viewport.
END
PARAMETER: Border Visibility
  Parameter Type = Logical
  Default = false
  Local Type = render
  Description = Toggles the viewport border visibility in the viewport.
END
PARAMETER: Light Angle
  Parameter Type = Real List
  Local Type = render
  Default = 50, 110
  Description = Defines the viewer light angles in degrees. The first \
                angle goes from right (0) to left (180), and the second goes from \
                bottom (0) to top (180). 
END
PARAMETER: Clip Scene
  Parameter Type = Logical
  Default = false
  Local Type = render
  Description = Toggles the scene clipping plane in the viewer.
END
PARAMETER: Clip Plane
  Parameter Type = String
  Local Type = render
  Remote Type = top
  Description = Defines the CLIP PLANE object that is used for scene clipping.
END
PARAMETER: Object Visibility List
  Parameter Type = String
  Local Type = top
  Description = Specifies the list of objects shown in this view.
END
PARAMETER: Local Object List
  Parameter Type = String
  Description = Stores the list of objects that were created specifically \
                for this view.
END
PARAMETER: Coord Transform
  Parameter Type = String
  Default = Cartesian
   Allowed String List = Cartesian, 3D Meridional, 3D Turbo, \
                         2D Meridional, 2D Blade-to-blade
  Local Type = top
  Description = Specifies the coordinate transformation to apply\
                to all objects shown in this viewport.
END
PARAMETER: Angular Coord Shift
   Parameter Type = Real
   Local Type = top
   Remote Type = expression
   Default = 0.0
   Description = The angular shift value. The shift is used in adjusting \
               Turbo B2B view.
END
PARAMETER: Auto Center
  Parameter Type = Logical
  Default = false
  Local Type = render
  Description = Toggle automatic centering of the view.
END
PARAMETER: Highlight Type
  Parameter Type = String
  Allowed String List = Bounding Box, Wireframe, Face Highlight, Surface Mesh
  Default = Surface Mesh
  Local Type = top
  Description = Specifies the highlight type used when picking.
END
PARAMETER: Is A Figure
  Parameter Type = Logical
  Default = true
  Description = Set for a view that is not intended to be a figure to be shown \
                in Reports.
END

PARAMETER: Valid Case
  Parameter Type = String
  Local Type = top
  Default = All Cases
  Description = Case reference to limit the rendering to in view, for filtering by case.
END

PARAMETER: Hide Difference Case
  Parameter Type = Logical
  Local Type = top
  Default = false
  Description = Case reference to limit the rendering to in view, for filtering by case.
END


OBJECT: VIEW
  CCLObject Class = PostViewCCLObject
  Category = selectable, reportable, suspendable
  Scheduler = top, camera, render, delete
  Optional Parameter List = \
    Camera Mode, Standard View, \
    Projection, Axis Visibility, Ruler Visibility, \
    Border Visibility, Light Angle, Clip Scene, \
    Clip Plane, Object Visibility List, \
    Local Object List, \
    Coord Transform, Highlight Type, Angular Coord Shift, \
    Auto Center, Is A Figure, \
    Valid Case, Hide Difference Case
  Allowed Parent List = ROOT
  Optional Child List = CAMERA, OBJECT REPORT OPTIONS
  Description = This object stores the view settings.
END


# Internal (non-modifiable) Engine Objects


  OBJECT: VECTOR VARIABLE
    CCLObject Class = VariableCCLObject
    Category = internal, vector-variable, variable, fundamental-variable
    Scheduler = top, bndValues
    Optional Parameter List = Boundary Values, User Units, \
        X Expression, Y Expression, Z Expression
    Internal Parameter List = VarMin, \
                              VarMax, \
                              HybridMin, \
                              HybridMax, \
                              FaceVarMin, \
                              FaceVarMax, \
                              Boundary Only, \
                              Variable Dimensions, \
                              Base Units, \
                              Has Hybrid Values, \
                              Has Face Values, \
                              User Level, \
                              Quantity Type, \
                              Is Temperature Difference, \
                              Related Object, \
                              Turbo Variable Type, \
                              Variable Description, \
                              Variable Group, \
                              Replaced with Expression, \
                              Can Be Overwritten, \
                              Variable Location, \
                              Iso Level Index, \
                              Velocity Names, \
                              Velocity Names Case Map, \
                              Method Name, \
                              Recipe, \
                              Variable, \
                              Is Local Variable, \
                              Fourier Coefficient List, \
                              Instancing Recipe
    Allowed Parent List = ROOT
    Description = An object used to reference the data associated with a vector \
                quantity in the results file.
    PARAMETER: X Expression
      Local Type = 
      Remote Type = 
    END     
    PARAMETER: Y Expression
      Local Type =
      Remote Type = 
    END     
    PARAMETER: Z Expression
      Local Type =
      Remote Type = 
    END     
    PARAMETER: User Units
      Local Type = top
    END     
  END

  OBJECT: SCALAR VARIABLE
    CCLObject Class = VariableCCLObject
    Category = internal, scalar-variable, variable, fundamental-variable
    Scheduler = top, bndValues
    Optional Parameter List = Boundary Values, \
                              User Units, \
                              Expression
    Internal Parameter List = VarMin, \
                              VarMax, \
                              HybridMin, \
                              HybridMax, \
                              FaceVarMin, \
                              FaceVarMax, \
                              Boundary Only, \
                              Variable Dimensions, \
                              Base Units, \
                              Variable, \
                              Component Index, \
                              Recipe, \
                              Has Hybrid Values, \
                              Has Face Values, \
                              User Level, \
                              Quantity Type, \
                              Is Temperature Difference, \
                              Related Object, \
                              Turbo Variable Type, \
                              Variable Description, \
                              Variable Group, \
                              Replaced with Expression, \
                              Can Be Overwritten, \
                              Variable Location, \
                              Iso Level Index, \
                              Velocity Names, \
                              Velocity Names Case Map, \
                              Method Name, \
                              Is Local Variable, \ 
                              Fourier Coefficient List, \
                              Instancing Recipe
    Context Rule = Recipe
    Allowed Option List = Standard, Vector Component, Difference
    CONTEXT: Standard
      Optional Parameter List = Boundary Values
    END
    CONTEXT: Vector Component
      #Essential Parameter List = Variable, Component Index
    END
    Allowed Parent List = ROOT
    Description = An object used to reference the data associated with a scalar \
                quantity in the results file.

    PARAMETER: Expression
      Local Type = 
      Remote Type = 
    END     
    PARAMETER: User Units
      Local Type = top
    END     

  END

  OBJECT: USER SCALAR VARIABLE
    CCLObject Class = VariableCCLObject
    Category = internal, scalar-variable, variable, deletable, user-variable
    Scheduler = top, bndValues
    Optional Parameter List = Boundary Values, User Units, Recipe, Calculate Global Range, \
                              Variable to Gradient
    Internal Parameter List = VarMin, \
                              VarMax, \
                              HybridMin, \
                              HybridMax, \
                              FaceVarMin, \
                              FaceVarMax, \
                              Boundary Only, \
                              Variable Dimensions, \
                              Base Units, \
                              Has Hybrid Values, \
                              Has Face Values, \
                              Quantity Type, \
                              Is Temperature Difference, \
                              Related Object, \
                              Variable Group, \
                              Variable Location
    Context Rule = Recipe
    Allowed Option List = Expression, Frozen Copy, Vector Component
    CONTEXT: Expression
      Essential Parameter List = Expression
    END
    CONTEXT: Frozen Copy
      Essential Parameter List = Variable to Copy
    END
    CONTEXT: Vector Component
     Essential Parameter List =  Variable, Component Index
    END
    Allowed Parent List = ROOT
    Description = An object used to reference scalar user-defined data.
  END

  OBJECT: USER VECTOR VARIABLE
    CCLObject Class = VariableCCLObject
    Category = internal, vector-variable, variable, deletable, user-variable
    Scheduler = top, bndValues
    Optional Parameter List = Boundary Values, User Units, Recipe, Calculate Global Range
    Internal Parameter List = VarMin, \
                              VarMax, \
                              HybridMin, \
                              HybridMax, \
                              FaceVarMin, \
                              FaceVarMax, \
                              Boundary Only, \
                              Variable Dimensions, \
                              Base Units, \
                              Has Hybrid Values, \
                              Has Face Values, \
                              Quantity Type, \
                              Is Temperature Difference, \
                              Related Object, \
                              Variable Group, \
                              Variable Location
    Context Rule = Recipe
    Allowed Option List = Expression, Frozen Copy, Gradient
    CONTEXT: Expression
      Essential Parameter List = X Expression, Y Expression, Z Expression
    END
    CONTEXT: Frozen Copy
      Essential Parameter List = Variable to Copy
    END
    CONTEXT: Gradient
      Essential Parameter List = Variable to Gradient
    END
    Allowed Parent List = ROOT
    Description = An object used to reference vector user-defined data.
  END

  SINGLETON: CEL
   Allowed Parent List = LIBRARY
   Optional Child List = EXPRESSIONS
  END

  SINGLETON: EXPRESSIONS
   CCLObject Class = ExpressionsCCLObject
   Category = internal
   Rules Option = Allow Any Parameter
   Parameter Name Restriction = CEL
   Allowed Parent List = CEL
   Description = This object holds the definitions of all CEL expressions in the post-processor.
  END

###############
###  TABLE  ###
###############

PARAMETER: Table Exists
  Parameter Type = Logical
  Default = false
  Local Type = top
END
PARAMETER: Table Export Format
  Parameter Type = String
  Local Type = top
  Default = State
  Allowed String List = State, HTML, CSV, Text
  Description = What to export the table to.
END
PARAMETER: Export Table Only
  Parameter Type = Logical
  Local Type = top
  Default = True
  Description = Whether or not to export the table within the context \
                of a complete HTML document, or to just export the \
                table itself as a section of HTML.
END
PARAMETER: Table Export HTML Title
  Parameter Type = String
  Local Type = top
  Description = Specifies the HTML Table title to give to the HTML document \
                This only applies to HTML Export when the Export Table Only \
                parameter is 'False'.
END 
PARAMETER: Table Export HTML Caption Position
  Parameter Type = String
  Local Type = top
  Default = Bottom
  Allowed String List = Top, Bottom
  Description = Specifies whether or not to show the caption specified \
                in the Table Export Caption parameter.
END
PARAMETER: Table Export HTML Caption
  Parameter Type = String
  Local Type = top
  Description = Specifies a caption for the table to give a description \
                of the contents of the table.
END
PARAMETER: Table Export HTML Border Width
  Parameter Type = Integer
  Local Type = top
  Default = 1
  Description = Specifies the width of the border around the exported HTML table. \
                If '0' is specified, then no borders are shown around the table, \
                nor between the cells.
END
PARAMETER: Table Export HTML Cell Padding
  Parameter Type = Integer
  Local Type = top
  Default = 5
  Description = Specifies the padding between the cell data and the borders around \
                the cell.  Specified as a percentage. 
END
PARAMETER: Table Export HTML Cell Spacing
  Parameter Type = Integer
  Local Type = top
  Default = 1
  Description = Specifies the spacing between the cells in the exported HTML table. \
                This may not be supported by all HTML browsers.
END
PARAMETER: Table Export Lines
  Parameter Type = String
  Local Type = top
  Default = All
  Allowed String List = All, Rows, Cols, None
  Description = Specifies which lines to show between the cells of the table. \
                This applies to HTML and Text export
END
PARAMETER: Table Export Trailing Separators
  Parameter Type = Logical
  Local Type = top
  Default = True
  Description = Specifies whether to show trailing separators when exporting \
                to CSV or Text files.
END
PARAMETER: Table Export Separator
  Parameter Type = String
  Local Type = top
  Default = Tab
  Allowed String List = Tab, Comma, Comma Space, Space
  Description = Specifies the separator to use between each table cell \
                when exporting to Text.
END
PARAMETER: Table Default Case Name
  Parameter Type = String
  Local Type = top
  Description = Specifies the case on which to do the expression evaluation \
                when not explicitly set as part of a cell expression.
END

OBJECT: TABLE
  CCLObject Class = TableCCLObject
  Category = deletable, selectable, reportable, suspendable
  Scheduler = top
  Optional Child List = TABLE CELLS, OBJECT REPORT OPTIONS
  Optional Parameter List = \
        Table Export Format, Export Table Only, \
        Table Export HTML Title, Table Export HTML Caption Position, \
        Table Export HTML Caption, Table Export HTML Border Width, \
        Table Export HTML Cell Padding, \
        Table Export HTML Cell Spacing, Table Export Lines, \
        Table Export Trailing Separators, Table Export Separator, Table Exists, \
        Table Default Case Name
  Allowed Parent List = ROOT
  Description = Definition of the TABLE object.
END
OBJECT: INTERNAL TABLE
  CCLObject Class = TableCCLObject
  Category = autogenerated, suspendable
  Scheduler = top
  Optional Child List = TABLE CELLS, OBJECT REPORT OPTIONS
  Optional Parameter List = \
        Table Export Format, Export Table Only, \
        Table Export HTML Title, Table Export HTML Caption Position, \
        Table Export HTML Caption, Table Export HTML Border Width, \
        Table Export HTML Cell Padding, \
        Table Export HTML Cell Spacing, Table Export Lines, \
        Table Export Trailing Separators, Table Export Separator, Table Exists, \
        Table Default Case Name
  Allowed Parent List = ROOT
  Description = Definition of the TABLE object.
END

SINGLETON: TABLE CELLS
  CCLObject Class = TableCCLObject
  Rules Option = Allow Any Parameter
  Allowed Parent List = TABLE
  Description = Definition of the TABLE object.
END

#################
###  COMMENT  ###
#################

PARAMETER: Comment Text
  Parameter Type = String
  Local Type = top
  Description = The text used within a COMMENT object.
END
PARAMETER: Comment Heading
  Parameter Type = String
  Local Type = top
  Description = The heading text of the comment.  If blank, no heading text is assigned.
END
PARAMETER: Heading Level
  Parameter Type = Integer
  Default = 1
  Local Type = top
  Description = Specifies the Heading depth.  E.g. A value of 2 specifies a 'Heading 2' setting, \
                resulting in a second level heading number: e.g. 1.2.
END
PARAMETER: Comment Exists
  Parameter Type = Logical
  Default = false
  Local Type = top
END
OBJECT: COMMENT
  CCLObject Class = CommentCCLObject
  Category = deletable, selectable, reportable, suspendable
  Scheduler = top
  Optional Parameter List = Comment Text, Comment Heading, Heading Level, \
                            Comment Exists
  Allowed Parent List = ROOT 
  Description = Definition of the COMMENT object.
END
OBJECT: INTERNAL COMMENT
  CCLObject Class = CommentCCLObject
  Category = deletable, suspendable
  Scheduler = top
  Optional Parameter List = Comment Text, Comment Heading, Heading Level, Comment Exists
  Allowed Parent List = ROOT
  Description = Definition of the COMMENT object.
END


#### OBJECT OPTIONS PARAMETERS:
PARAMETER: This Exists
  Parameter Type = Logical
  Default = false
  Description = Indicates whether this object exists or not.
END
PARAMETER: Generate This
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether this object should be generated or not.
END

###########################
###  REPORT TITLE PAGE  ###
###########################

#### REPORT TITLE PAGE:

PARAMETER: Title Page Exists
  Parameter Type = Logical
  Default = false
END
PARAMETER: Report Title
  Parameter Type = String
  Default = 
  Description = Specifies the title for the report.
END
PARAMETER: Report Author
  Parameter Type = String
  Default = 
  Description = Specifies the author of the report.
END
PARAMETER: Include ANSYS Logo
  Parameter Type = Logical
  Default = true
  Description = Specifies whether to include the ANSYS report logo in the report.
END
PARAMETER: Include Custom Logo
  Parameter Type = Logical
  Default = false
  Description = Specifies whether to include a custom logo in the report.
END
PARAMETER: Custom Logo Path
  Parameter Type = String
  Default =
  Description = The path to the Custom logo.  Only used if 'Include Custom Logo' \
                is true.
END
PARAMETER: Include Date
  Parameter Type = Logical
  Default = true
  Description = Specifies whether to include the date in the report Title Page
END
PARAMETER: Include TOC
  Parameter Type = Logical
  Default = true
  Description = Specifies whether to include a Table of Contents in the Report.
END
PARAMETER: Show Captions in TOC
  Parameter Type = Logical
  Default = true
  Description = Specifies wether to show Figure, Chart and Table captions in \
                the Table of Contents.
END
SINGLETON: TITLE PAGE
  CCLObject Class = TitlePageCCLObject
  Category = selectable, reportable, suspendable
  Scheduler = top
  Optional Parameter List = Title Page Exists, Report Title, Report Author, \
                Include ANSYS Logo, Include Custom Logo, \
                Custom Logo Path, Include Date, Include TOC, Show Captions in TOC
  Description = Defines the Title Page for a report.
  Allowed Parent List = ROOT
END

#### COMMON AUTO GENERATED REPORT OBJECT PARAMETERS:
PARAMETER: Include In Report
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Specifies whether to show this object in the Report or not.
END


#### FILE INFORMATION
SINGLETON: FILE INFORMATION OPTIONS
  CCLObject Class = ReportCCLObject
  Category = selectable, reportable, suspendable
  Scheduler = top
  Optional Parameter List = This Exists, Include In Report
  Allowed Parent List = REPORT
END


#### MESH STATISTICS:
PARAMETER: Show Number of Nodes
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the number of Nodes in the Mesh Statistics Table.
END
PARAMETER: Show Number of Elements
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the number of Elements in the Mesh Statistics Table.
END
PARAMETER: Show Number of Tetrahedra
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the number of Tetrahedra in the Mesh Statistics Table.
END
PARAMETER: Show Number of Wedges
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the number of Wedges in the Mesh Statistics Table.
END
PARAMETER: Show Number of Pyramids
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the number of Pyramids in the Mesh Statistics Table.
END
PARAMETER: Show Number of Hexahedra
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the number of Hexahedra in the Mesh Statistics Table.
END
PARAMETER: Show Number of Polyhedra
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the number of Polyhedra in the Mesh Statistics Table.
END
PARAMETER:Show Max Face Angle
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the Maximum Face Angle in the Mesh Statistics Table.
END
PARAMETER: Show Min Face Angle
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the Minimum Face Angle in the Mesh Statistics Table.
END
PARAMETER: Show Edge Length Ratio
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the Edge Length Ratio in the Mesh Statistics Table.
END
PARAMETER: Show Connectivity Number
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the Connectivity Number in the Mesh Statistics Table.
END
PARAMETER: Show Element Volume Ratio
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the Element Volume Ratio in the Mesh Statistics Table.
END
SINGLETON: MESH STATISTICS OPTIONS
  CCLObject Class = ReportCCLObject
  Category = selectable, reportable, suspendable
  Scheduler = top
  Optional Parameter List = This Exists, Include In Report, \
        Show Number of Nodes, Show Number of Elements, Show Number of Tetrahedra, \
        Show Number of Wedges, Show Number of Pyramids, Show Number of Hexahedra, \
        Show Number of Polyhedra, \
        Show Max Face Angle, Show Min Face Angle, Show Edge Length Ratio, \
        Show Connectivity Number, Show Element Volume Ratio
  Allowed Parent List = REPORT
END

#PARAMETER: Show Is Rotating
#  Parameter Type = Logical
#  Default = true
#  Local Type = top
#  Description = Indicates whether to show whether the domain is Rotating in the Mesh Statistics Table.
#END

#### PHYSICS SUMMARY:
PARAMETER: Show Domain Physics
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the Domain Physics Summary Table.
END
PARAMETER: Show Boundary Physics
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the Boundary Physics Summary Table.
END
SINGLETON: PHYSICS SUMMARY OPTIONS
  CCLObject Class = ReportCCLObject
  Category = selectable, reportable, suspendable
  Scheduler = top
  Optional Parameter List = This Exists, Include In Report, Show Domain Physics, Show Boundary Physics
  Allowed Parent List = REPORT
END


#### SOLUTION SUMMARY:
PARAMETER: Show Boundary Flow Summary
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the Boundary Flow Summary Table.
END
PARAMETER: Show Force and Torque Summary
  Parameter Type = Logical
  Default = false
  Local Type = top
  Description = Indicates whether to show the Pressure & Viscous Force & Torque Summary Table.
END
PARAMETER: Show Forces
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the Pressure & Viscous Forces in the Summary Table.
END
PARAMETER: Show Torques
  Parameter Type = Logical
  Default = true
  Local Type = top
  Description = Indicates whether to show the Pressure & Torques in the Summary Table.
END

SINGLETON: SOLUTION SUMMARY OPTIONS
  CCLObject Class = ReportCCLObject
  Category = selectable, reportable, suspendable
  Scheduler = top
  Optional Parameter List = This Exists, Include In Report, Show Boundary Flow Summary, \
        Show Force and Torque Summary, Show Forces, Show Torques
  Allowed Parent List = REPORT
  PARAMETER: Include In Report
    Default = false
  END
END

#### REPORT PROPERTIES
PARAMETER: Report Template Name
  Parameter Type = String
  Description = Specifies the name of the report.
END
PARAMETER: Report Support Level
  Parameter Type = String
  Allowed String List = Full, Beta, None
  Default = None
  Description = Specifies whether the report is fully supported or Beta
END
PARAMETER: Keywords
  Parameter Type = String List
  Description = Specifies any keywords that may be associated with this report.
END
PARAMETER: Execution Type
  Parameter Type = String
  Allowed String List = State, Session, Automatic
  Default = Automatic
  Description = Specifies whether this report should be run as a session file or \
                as a state file.
END
PARAMETER: Report Template Description
  Parameter Type = String
  Description = Provides a description of the Report Template for the user to understand \
                what the report does.
END
SINGLETON: REPORT PROPERTIES
  Category = 
  CCLObject Class = ReportCCLObject
  Optional Parameter List = Report Template Name, Keywords, Execution Type, \
                        Report Template Description, Report Support Level
  Allowed Parent List = REPORT
END

################
###  REPORT  ###
################

#### REPORT OPTIONS:
PARAMETER: Fit Views
  Parameter Type = Logical
  Default = false
  Description = Specifies whether to center every view before generating figures
END
PARAMETER: Figure Size
  Parameter Type = String
  Allowed String List = 512 x 384, 1024 x 768, 2048 x 1536, Custom
  Default = 512 x 384
  Description = Specifies the size of Figures in the Report
END
PARAMETER: Custom Figure Size Width
  Parameter Type = Integer
  Default = 512
  Description = Specifies the Figure width if 'Custom' Figure Size is selected.
END
PARAMETER: Custom Figure Size Height
  Parameter Type = Integer
  Default = 384
  Description = Specifies the Figure height if 'Custom' Figure Size is selected.
END
PARAMETER: Figure Image Type
  Parameter Type = String
  Allowed String List = png, jpg, bmp
  Default = png
  Description = Specifies the image format to generate.
END
PARAMETER: Chart Size
  Parameter Type = String
  Allowed String List = Same As Figure, 512 x 384, 1024 x 768, 2048 x 1536, Custom
  Default = Same As Figure
  Description = Specifies the size of Charts in the Report
END
PARAMETER: Custom Chart Size Width
  Parameter Type = Integer
  Default = 512
  Description = Specifies the Chart width if 'Custom' Chart Size is selected.
END
PARAMETER: Custom Chart Size Height
  Parameter Type = Integer
  Default = 384
  Description = Specifies the Chart height if 'Custom' Chart Size is selected.
END
PARAMETER: Chart Image Type
  Parameter Type = String
  Allowed String List = png, bmp, xpm
  Default = png
  Description = Specifies the image format to generate.
END

SINGLETON: OUTPUT SETTINGS
  CCLObject Class = ReportCCLObject
  Category = suspendable
  Scheduler = top
  Optional Parameter List = This Exists, Fit Views, Figure Size, \
        Custom Figure Size Width, Custom Figure Size Height, Figure Image Type, \
        Chart Size, Custom Chart Size Width, Custom Chart Size Height, \
        Chart Image Type
  Allowed Parent List = PUBLISH, PREVIEW
  Description = Defines options for the Report.
END

# PUBLISH PARAMETERS:

PARAMETER: Report Format
  Parameter Type = String
  Default = HTML
  Allowed String List = HTML, XML, Text, ARZ
  Description = Specifies the format to export the Report in.
END
PARAMETER: Report Path
  Parameter Type = String
  Default = ./Report.htm
  Description = Specifies the file path to save the report to.
END
PARAMETER: Save Images In Separate Folder
  Parameter Type = Logical
  Default = true
  Description = Indicates whether to save the generated images in an automatically \
                generated subdirectory of the report directory or not.
END
PARAMETER: Generate 3D Viewer Files
  Parameter Type = Logical
  Default = false
  Description = Indicates whether to generate ANSYS or CFX Viewer Files \
                for figures that are included in a report. When generating \
                report in ARZ format, an AVZ file for each figure will be \
                generated. For reports in HTML format, a CVF file will be \
                generated for each figure. Both AVZ and ARZ files can be \
                displayed in stand alone ANSYS Viewer while CVF file can be \
                viewed using stand alone CFX viewer. 
END
PARAMETER: Default Report Name
  Parameter Type = String
  Default = Report
  Description = Specifies the default name to use for this report if a name is \
                not specified.  This is most important when generating reports \
                in batch mode where the user may only enter an output directory \
                without specifying a name.
END

# PUBLISH SINGLETON:

SINGLETON: PUBLISH
  CCLObject Class = ReportCCLObject
  Category = suspendable
  Scheduler = top
  Optional Parameter List = This Exists, Report Format, Report Path, Default Report Name, \
        Save Images In Separate Folder, Generate 3D Viewer Files
  Optional Child List = OUTPUT SETTINGS
  Allowed Parent List = ROOT
  Description = Defines the Report.
END

# PREVIEW SINGLETON:

SINGLETON: PREVIEW
  CCLObject Class = ReportCCLObject
  Category = suspendable
  Scheduler = top
  Optional Parameter List = This Exists
  Optional Child List = OUTPUT SETTINGS
  Allowed Parent List = ROOT
  Description = Defines the Report.
END


#### REPORT SINGLETON:

PARAMETER: Report Items
  Parameter Type = String
  Default = 
  Local Type = top
  Description = A list of object paths that make up the report.  This list contains \
                all objects that can possibly exist in a report, and in the order \
                in which they will appear.  If any of these objects are not to be \
                included in the final report, the object paths should be specified \
                in the 'Excluded Report Items' parameter.
END
PARAMETER: Excluded Report Items
  Parameter Type = String
  Default =
  Local Type = top
  Description = Specifies which items in the 'Report Items' parameter should NOT \
                be included in the generated report.
END
SINGLETON: REPORT
  CCLObject Class = ReportCCLObject
  Category = selectable, suspendable
  Scheduler = top
  Optional Parameter List = Report Items, Excluded Report Items
  Optional Child List = PUBLISH, PREVIEW, REPORT PROPERTIES, \
        FILE INFORMATION OPTIONS, MESH STATISTICS OPTIONS, \
        PHYSICS SUMMARY OPTIONS, SOLUTION SUMMARY OPTIONS
  Allowed Parent List = ROOT
  Description = Defines the Report.
END

#######################
###  END OF REPORT  ###
#######################


# User Engine Objects

SINGLETON: ANIMATION
  Category = deletable, suspendable
  Optional Parameter List = Animation Name, Animation Filename, Keyframe List, \
    Looping, Looping Cycles, Timestep Interpolation Method, \
    Frame Increment, Animate Camera, Save Hardcopy, \
    Animation Hardcopy Filename, Animation Quality, \
    Animation Frame Pattern, Animation Bit Rate, Variable Bit Rate, \
    Intermediate File Format, Keep Intermediate Files, \
    Output Directory, Local Output Directory, Output to User Directory, \
    Animation Frame Rate, Use Screen MPEG Size, MPEG Size, MPEG Width, \
    MPEG Height, MPEG Scale, White Background, Screen Capture, \
    Speed Adjustment Selection, Animation Speed Factor, \
    Speed Scaling Method, Antialiasing, \
    QAnim Object List, QAnim Frames, QAnim Looping, \
    QAnim Looping Cycles, QAnim Save MPEG, QAnim MPEG Filename, \
    QAnim Symbol Spacing, QAnim Override Symbol, QAnim Symbol Size, \
    QAnim Symbol Type, TimeAnim Looping Cycles, \
    TimeAnim Save MPEG, TimeAnim MPEG Filename, TimeAnim Control Case, \
    TimeAnim Control Variable, TimeAnim Specify Range, \
    TimeAnim Start Timestep, TimeAnim End Timestep, \
    TimeAnim Start Time, TimeAnim End Time, \
    TimeAnim Start Crank Angle, TimeAnim End Crank Angle, \
    TimeAnim Frame Spacing, TimeAnim Number Of Frames, \
    TimeAnim Frame Interval, TimeAnim Time Interval, \
    TimeAnim Crank Angle Interval, TimeAnim Timestep Interval, \
    Hardcopy Tolerance, Drop Last MPEG Frame, Video Format
  Internal Parameter List = Current Frame, Playback Status
  Allowed Parent List = ROOT
  Description = Defines a Keyframe animation sequence.  A list of KEYFRAME \
                objects indicate the states between which to interpolate.
  PARAMETER: Hardcopy Tolerance
    Default = 0.0001
  END
END
# Keyframe Frame List, Looping, Looping Cycles, Default Inter Frame Count, \

OBJECT: KEYFRAME
  Category = deletable, suspendable
  Optional Parameter List = Keyframe Name, Number Of Frames, Keyframe Filename
  Allowed Parent List = ROOT
  Description = Defines a specific keyframe for an animation sequence. The actual \
        system state is stored in a file referenced by the 'Keyframe Filename' \
        parameter.
END

 OBJECT: DOMAIN GROUP
   CCLObject Class = GenericCCLObject
   Category = internal, domain, suspendable
   Scheduler = top, geometry, turbo
   Essential Parameter List = Member List, Turbo Member List
  # Optional Parameter List = Visibility, Transparency, Draw Faces, \
  #                           Surface Drawing, Draw Lines, Line Width, \
  #                           Line Colour, Lighting, Instancing Transform, Apply Instancing Transform
   Allowed Parent List = ROOT
   Description = Allows a group of multiple objects to behave as a single object. \
                 Currently only used internally and does not work for graphics, etc.
 END

 OBJECT: DEFAULT INSTANCE TRANSFORM
   CCLObject Class = GeometricCCLObject
   Category = selectable, instance-transformation, has-instance-transform, suspendable
   Scheduler = instance
   Optional Parameter List = Instancing Info From Domain, \
                             Apply Reflection, Apply Translation, \
                             Apply Rotation, \
                             Rotation Axis Type, \
                             Principal Axis, \
                             Rotation Axis From, \
                             Rotation Axis To,\
                             Coord Frame,\
                             Axis,\
                             Full Circle, \
                             Angle Definition Method, \
                             Rotation Angle, \
                             Number of Passages in 360, \
                             Number of Passages in Component, \
                             Number of Components in 360, \
                             Translation Vector, \
                             Number of Copies, \
                             Reflection Plane Option

   Allowed Parent List = ROOT
   Description = Specifies the default instance transformation.

   Context Rule = Reflection Plane Option
   Allowed Option List = XY Plane, YZ Plane, ZX Plane, From Plane
   CONTEXT: YZ Plane
     Optional Parameter List = X
   END
   CONTEXT: ZX Plane
     Optional Parameter List = Y
   END
   CONTEXT: XY Plane
     Optional Parameter List = Z
   END
   CONTEXT: From Plane
     Optional Parameter List = Reflection Plane
   END

   PARAMETER: X
     Local Type = instance
   END
   PARAMETER: Y
     Local Type = instance
   END
   PARAMETER: Z
     Local Type = instance
   END
   PARAMETER: Axis
     Local Type = instance
   END
   PARAMETER: Coord Frame
     Local Type = instance
     Default =
   END
   PARAMETER: Rotation Axis Type
     Allowed String List = Principal Axis, Rotation Axis, Coordinate Frame
     Default = Principal Axis
   END
 END

 OBJECT: INSTANCE TRANSFORM
   CCLObject Class = GeometricCCLObject
   Category = selectable, deletable, instance-transformation, has-instance-transform, suspendable
   Scheduler = instance
   Optional Parameter List = Instancing Info From Domain, \
                             Apply Reflection, Apply Translation, \
                             Apply Rotation, \
                             Rotation Axis Type, \
                             Principal Axis, \
                             Rotation Axis From, \
                             Rotation Axis To,\
                             Coord Frame,\
                             Axis,\
                             Full Circle, \
                             Angle Definition Method, \
                             Rotation Angle, \
                             Number of Passages in 360, \
                             Number of Passages in Component, \
                             Number of Components in 360, \
                             Translation Vector, \
                             Number of Copies, \
                             Reflection Plane Option
   Allowed Parent List = ROOT
   Description = Specifies an instance  transformation that can consist of \
        a rotation, a translation, a reflection and a number of copies of \
        the original object to produce. Note that applying reflection \
        duplicates the number of copies.

   Context Rule = Reflection Plane Option
   Allowed Option List = XY Plane, YZ Plane, ZX Plane, From Plane
   CONTEXT: YZ Plane
     Optional Parameter List = X
   END
   CONTEXT: ZX Plane
     Optional Parameter List = Y
   END
   CONTEXT: XY Plane
     Optional Parameter List = Z
   END
   CONTEXT: From Plane
     Optional Parameter List = Reflection Plane
   END

   PARAMETER: X
     Local Type = instance
   END
   PARAMETER: Y
     Local Type = instance
   END
   PARAMETER: Z
     Local Type = instance
   END
   PARAMETER: Axis
     Local Type = instance
   END
   PARAMETER: Coord Frame
     Local Type = instance
     Default = 
   END
   PARAMETER: Rotation Axis Type
     Allowed String List = Principal Axis, Rotation Axis, Coordinate Frame
     Default = Principal Axis
   END
 END

SINGLETON: OBJECT VIEW TRANSFORM
   CCLObject Class = ObjectTransformCCLObject
   Category = deletable, suspendable
   Scheduler = top, instance, render
   Scheduler Links = top,instance,instance,render
   Optional Parameter List = Apply Reflection, \
                             Apply Rotation, \
                             Apply Translation, \
                             Apply Scale, \
                             Rotation Axis Type, \
                             Principal Axis, \
                             Rotation Axis From, \
                             Rotation Axis To,\
                             Rotation Angle, \
                             Translation Vector, \
                             Scale Vector, \
                             Reflection Plane Option
   Allowed Parent List = ROOT

   Description = This object contains object transformation info to be \
                 processed by the viewer. Like instance transform, this \
                 object should be associated with each geometry. It is \
                 usually specified as a sub-object.
                
   Context Rule = Reflection Plane Option
   Allowed Option List = XY Plane, YZ Plane, ZX Plane, From Plane
   CONTEXT: YZ Plane
     Optional Parameter List = X
   END
   CONTEXT: ZX Plane
     Optional Parameter List = Y
   END
   CONTEXT: XY Plane
     Optional Parameter List = Z
   END
   CONTEXT: From Plane
     Optional Parameter List = Reflection Plane
   END
 END


OBJECT: LEGEND
  CCLObject Class = OverlayCCLObject
  Category = deletable, selectable, viewer-viewable, suspendable
  Scheduler = colour, render
  Scheduler Links = colour, render
  Calculate Function =  colour, postlegendcalc, PostLegendCalcFunc, \
                        render, postlegendcalc, PostLegendCalcFunc
  Essential Parameter List = Legend Plot
  Optional Parameter List = Legend X Justification, Legend Y Justification, Legend Position, \
                        Legend Size, Legend Ticks, Legend Resolution, \
                        Legend Shading, Font, Legend Aspect, Visibility, \
                        Colour, Legend Format, Text Height, Text Rotation, \
                        Legend Title Mode, Legend Title, Show Legend Units, \
                        Legend Orientation, Text Colour Mode, Related Object
  Allowed Parent List = ROOT, CASE COMPARISON
  PARAMETER: Colour
    Default = 0, 0, 0
  END
  PARAMETER: Legend Plot
    Local Type = colour
    Remote Type = render
  END
  Description = Creates a labelled colour bar to show to legend associated \
                with the named plot. 
END

OBJECT: DEFAULT LEGEND
  CCLObject Class = OverlayCCLObject
  Category = selectable, viewer-viewable, suspendable
  Scheduler = colour, render
  Scheduler Links = colour, render
  Calculate Function =  colour, postlegendcalc, PostLegendCalcFunc, \
                        render, postlegendcalc, PostLegendCalcFunc
  Optional Parameter List = Legend X Justification, Legend Y Justification, Legend Position, \
                        Legend Size, Legend Ticks, Legend Resolution, \
                        Legend Shading, Font, Legend Aspect, Visibility, \
                        Colour, Legend Format, Text Height, Text Rotation, \
                        Legend Title Mode, Legend Title, Show Legend Units, \
                        Legend Orientation, Text Colour Mode, Related Object, \
                        Legend Plot
  Internal Parameter List = Legend Object List
  Allowed Parent List = ROOT
  PARAMETER: Colour
    Default = 0, 0, 0
  END
  PARAMETER: Legend X Justification
    Default = Left
  END
  PARAMETER: Legend Plot
    Local Type = colour
  END

  Description = Creates a labelled colour bar to show to legend associated \
                with the named plot. 
END

# OBJECT: ARRAY
#   Category = deletable
#   Essential Parameter List = Option, Dimensions, Array Entries
#   Allowed Option List = 1D, 2D, 3D
#   Allowed Parent List = ROOT
# END

OBJECT: COORDINATE FRAME
  CCLObject Class = CoordinateFrameCCLObject
  Category = deletable, selectable, viewer-viewable, suspendable
  Scheduler = top, colour, symbol, render
  Scheduler Links = top, colour, colour, symbol, symbol, render
  Calculate Function = top, coordframecalc, CoordFrameCalcFunc, \
                       colour, coordframecalc, CoordFrameCalcFunc, \
                       symbol, coordframecalc, CoordFrameCalcFunc, \
                       render, coordframecalc, CoordFrameCalcFunc
  Optional Parameter List = Option, Reference Coord Frame, Coord Frame Type, \
        Symbol Size, Visibility
  Allowed Option List = Axis Points
  CONTEXT: Axis Points
    Essential Parameter List = Origin Point, Axis 3 Point, Plane 13 Point
  END
  Allowed Parent List = ROOT
  Description = Defines a coordinate frame which can be used for setting \
                direction and axis specifications.
END

# SINGLETON: CEL
#   Rules Option = CEL
#   Allowed Parent List = ROOT
# END
#

SINGLETON: CALCULATOR
  CCLObject Class = DataCCLObject
  Category = internal
  Optional Parameter List = Function, Verbose, Case Name, Location
  Internal Parameter List = Result, Result Units
  Context Rule = Function
  Allowed Option List = area, areaAve, areaInt, ave, count, countTrue, force, forceNorm, \
                        length, lengthAve, lengthInt, massFlow, massFlowAve, massFlowAveAbs, massFlowInt,  \
                        maxVal, minVal, probe, sum, torque, \
                        volume, volumeAve, volumeInt
  CONTEXT: massFlow
    Optional Parameter List = Fluid
  END
  CONTEXT: massFlowAve
    Essential Parameter List = Expression
    Optional Parameter List = Fluid
  END
  CONTEXT: massFlowAveAbs
    Essential Parameter List = Expression
    Optional Parameter List = Fluid
  END
  CONTEXT: area
    Optional Parameter List = Axis
  END
  CONTEXT: areaAve
    Essential Parameter List = Expression
  END
  CONTEXT: areaInt
    Essential Parameter List = Expression
    Optional Parameter List = Axis
  END
  CONTEXT: ave
    Essential Parameter List = Expression
  END
  CONTEXT: sum
    Essential Parameter List = Expression
  END
  CONTEXT: minVal
    Essential Parameter List = Expression
  END
  CONTEXT: maxVal
    Essential Parameter List = Expression
  END
  CONTEXT: probe
    Essential Parameter List = Expression
  END
  CONTEXT: force
    Essential Parameter List = Axis
    Optional Parameter List = Fluid
  END
  CONTEXT: forceNorm
    Optional Parameter List = Fluid
  END
  CONTEXT: torque
    Essential Parameter List = Axis
    Optional Parameter List = Fluid
  END
  CONTEXT: lengthInt
    Essential Parameter List = Expression
  END
  CONTEXT: lengthAve
    Essential Parameter List = Expression
  END
  CONTEXT: countTrue
    Essential Parameter List = Expression
  END
  Allowed Parent List = ROOT
  Description = This singleton is used by the calculate action to define the \
                function and arguments to be evaluated, and store the Result.
END
PARAMETER: Axis
  Parameter Type = String
  Description = The axis specification for directional quantitative calculations.
END
PARAMETER: Fluid
  Parameter Type = String
  Description = The fluid specification for multiphase quantitative calculations.
END

PARAMETER: Function
  Parameter Type = String
  Description = The context controlling parameter for the CALCULATOR object,  \
                which defines the name of the function to be evaluated.
END
PARAMETER: Verbose
  Parameter Type = Logical
  Default = Off
  Description = Controls if the result of a calculation is written to the screen.
END
PARAMETER: Result
  Parameter Type = String
  Description = The internal parameter for the CALCULATOR and EXPRESSION EVALUATOR \
                object used to  \
                store the results of a function evaluation.
END
PARAMETER: Result Units
  Parameter Type = String
  Description = The internal parameter for the CALCULATOR \
                and EXPRESSION EVALUATOR object used to  \
                store the units of the results of a function evaluation.
END
PARAMETER: Evaluated Expression
  Parameter Type = String
  Local Type = top
  Description = A CFX Expression Language expression for usage in EXPRESSION EVALUATOR.
END

SINGLETON: MESH CALCULATOR
  CCLObject Class = DataCCLObject
  Category = internal
  Essential Parameter List = Mesh Function
  Internal Parameter List = Max Result, Min Result, Result Units, \
                            Number of Nodes, Number of Elements, \
                            Number of Tetrahedra, Number of Wedges, \
                            Number of Pyramids, Number of Hexahedra, \
                            Number of Polyhedra
  Allowed Parent List = ROOT
  Description = This singleton is used by the mesh calculate action to define the \
                function to be evaluated, and store the max and min Results.
END
PARAMETER: Max Result
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the max result of evaluation.
END
PARAMETER: Min Result
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to  store the min result of evaluation.
END
PARAMETER: Number of Nodes
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of nodes.
END
PARAMETER: Number of Elements
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of elements.
END
PARAMETER: Number of Tetrahedra
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of tetrahedra.
END
PARAMETER: Number of Wedges
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of wedges.
END
PARAMETER: Number of Pyramids
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of pyramids.
END
PARAMETER: Number of Hexahedra
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of hexahedra.
END
PARAMETER: Number of Polyhedra
  Parameter Type = String
  Description = The internal parameter for the MESH CALCULATOR object \
                used to store the number of polyhedra.
END
PARAMETER: Mesh Function
  Parameter Type = String
  Allowed String List = Maximum Face Angle, Minimum Face Angle, \
                        Edge Length Ratio, Connectivity Number, \
                        Element Volume Ratio, Mesh Statistics
  Default = Maximum Face Angle
  Description = The context controlling parameter for the MESH CALCULATOR object,  \
                which defines the name of the function to be evaluated.
END

SINGLETON:EXPRESSION EVALUATOR
  CCLObject Class = ExpressionEvaluatorCCLObject
  Category = internal
  Scheduler = top
  Internal Parameter List = Result, Result Units
  Essential Parameter List = Evaluated Expression
  Allowed Parent List = ROOT
  Description = This singleton evaluates the specified Expression and stores \
                the Result.
END

PARAMETER: Preview Expression
  Parameter Type = String
  Local Type = top
  Remote Type = expression
END

PARAMETER: Preview Variable Ranges
  Local Type = top
  Parameter Type = String List
END

PARAMETER: Preview Variable Values
  Local Type = top
  Parameter Type = String List
END

PARAMETER: Preview Range Steps
  Local Type = top
  Parameter Type = Integer
END

PARAMETER: Preview Mode
  Local Type = top
  Parameter Type = String
  Allowed Values List = Query, Evaluate, Evaluate Point
  Default = Query
END

PARAMETER: Preview Required Variables
  Parameter Type = String List
END

PARAMETER: Preview Varying Variable
  Parameter Type = String
END

PARAMETER: Preview Input Units
  Parameter Type = String
END

PARAMETER: Preview Evaluated Units
  Parameter Type = String
END

SINGLETON:EXPRESSION PREVIEW
  CCLObject Class = ExpressionPreviewCCLObject
  Category = internal
  Scheduler = top
  Internal Parameter List = Preview Required Variables, Preview Varying Variable, \
                            Preview Evaluated Units, Preview Input Units
  Essential Parameter List = Preview Expression
  Optional Parameter List = Preview Mode, Preview Variable Values, \
                            Preview Variable Ranges, Preview Range Steps, \
                            Case Name
  Allowed Parent List = ROOT
  Description = This singleton is used to generate data for expression \
                preview graphs.
  PARAMETER: Case Name
    Local Type = top
  END
END

### Rules to allow the inclusion of VARIABLES file
  PARAMETER: Tensor Type
    Parameter Type = String
    Allowed String List = SCALAR, VECTOR, SYMTEN2
    Default = SCALAR
  END
  PARAMETER: Quantity
    #
    # This parameter is very similar to Quantity Type.
    #
    # The problem is that Quantity Type is used in RULES
    # for PARAMETER definition but it has not yet been
    # formally defined itself, so is not available elsewhere.
    # 3.3.2000.
    #
    Parameter Type = String
  END
  PARAMETER: Node Number
    Parameter Type = Integer
    Default = 0
    Local Type = top
    Description = the node number which the point plot will be drawn     
  END
  PARAMETER: Element Number
    Parameter Type = Integer
    Default = 0
    Local Type = top
    Description = the element number which will be drawn
  END
  PARAMETER: User Level
    Parameter Type = Integer
    Default = 1
  END
  PARAMETER: Output to Jobfile
    Parameter Type = Logical
    Default = No
  END
  PARAMETER: Output to Postprocessor
    Parameter Type = Logical
    Default = No
  END
  PARAMETER: Variable Class
    Parameter Type = String
    Description = Solver variable class
  END
  PARAMETER: Variable Description
    Parameter Type = String
  END
  PARAMETER: Variable Type
    Parameter Type = String
    Allowed String List = \
      Unspecified, \
      Volumetric, \
      Specific
    Default = Unspecified
  END
  PARAMETER: Default Vulnerability
    Parameter Type        = Integer
    Description           = Default vulnerability for non-permanent \
                            solver data.
  END
  PARAMETER: MMS Name
    #
    #
    # to define the alias for an object type,
    # while MMS Name is used, outside RULES,
    # to associate aliases for object names.
    #
    Parameter Type = String
  END
  PARAMETER: Long Name
    Parameter Type = String
  END
  PARAMETER: Status
    Parameter Type = String
    Allowed String List = P,D,DR,M
  END
  PARAMETER: Under Relaxation Factor
    Parameter Type = Real
  END
  PARAMETER: Component Bounds Flag
#    Parameter Type = Logical List # Logical List was refused 3.3.2000
#    Parameter Type = Logical List
    Parameter Type = String
  END
  PARAMETER: Component Clip Factors
    Parameter Type = Real List
  END
  PARAMETER: Component Long Names
    Parameter Type = String List
  END
  PARAMETER: Component Lower Bounds
    Parameter Type = Real List
  END
  PARAMETER: Component MMS Names
    Parameter Type = String List
  END
  PARAMETER: Component Short Names
    Parameter Type = String List
  END
  PARAMETER: Component Upper Bounds
    Parameter Type = Real List
  END
  PARAMETER: General Availability
    Parameter Type = String List
    Default = No
  END
  PARAMETER: Physical Availability
    Parameter Type = String List
    Default = No
  END
### end of rules to allow the inclusion of the VARIABLES file

SINGLETON: FILE PROCESSING
  Category = 
  Essential Parameter List = Path Stack, Processing Mode
  Optional Parameter List = Supress File Replacement Warnings, User Files Directory
  Allowed Parent List = ROOT
  Description = Stores parameters indicating the state of processing state or seesion files.
END

PARAMETER: Path Stack
  Parameter Type = String List
  Description = Stack of paths to look in for files
END

PARAMETER: Supress File Replacement Warnings
  Parameter Type = Logical
  Default = false
END

PARAMETER: User Files Directory
  Parameter Type = String
  Default =
END

PARAMETER: Processing Mode
  Allowed String List = None, Session, State
  Parameter Type = String
  Default = None
  Description = Indicates the type of file currently being processed.
END

## Rules for parameterization

SINGLETON: PARAMETERIZATION
  Category = deletable, suspendable
  Allowed Parent List = ROOT
  Optional Child List = INPUT FIELD, RESPONSE FIELD
END

OBJECT: INPUT FIELD
  CCLObject Class = ParameterizationCCLObject
  Scheduler = top
  Essential Parameter List = Method
  Optional Parameter List = WB Parameter Value
  Context Rule = Method
  Allowed Option List = Expression, Parameter
  CONTEXT: Expression
    Essential Parameter List = Expression Name
  END
  CONTEXT: Parameter
    Essential Parameter List = Parameter Path
  END
  Allowed Parent List = PARAMETERIZATION
END

OBJECT: RESPONSE FIELD
  CCLObject Class = ParameterizationCCLObject
  Scheduler = top
  Essential Parameter List = Method
  Context Rule = Method
  Allowed Option List = Expression
  CONTEXT: Expression
    Essential Parameter List = Expression Name
  END
  Allowed Parent List = PARAMETERIZATION
END

PARAMETER: WB Parameter Value
  Parameter Type = String
END

PARAMETER: Method
  Solver Name = NULL
  Parameter Type = String
  Local Type = top
END

PARAMETER: Expression Name
  Solver Name = NULL
  Parameter Type = String
  Local Type = top
  Remote Type = expression
END

PARAMETER: Parameter Path
  Solver Name = NULL
  Parameter Type = String
  Local Type = top
END


PARAMETER: CFX Post Version
  Parameter Type = String
  Description = Indicates the type of file currently being processed.
END
SINGLETON: COMMAND FILE
  Essential Parameter List = CFX Post Version
  Description = Stores the Version of the current command file.
  Allowed Parent List = ROOT
END  

OBJECT: TURBO PLOTS
  Optional Parameter List = Turbo HS Chart Plot Type, \
                            Turbo HS Chart Display Option, \
                            Turbo HS Chart Compare Axis Option
  Description = Stores turbo hub-to-shroud chart options.
  Allowed Parent List = ROOT
END

PARAMETER: Turbo HS Chart Plot Type
  Parameter Type = String
  Allowed String List = Single Line, Two Lines
  Default = Single Line
  Description = Turbo hub-to-shroud chart plot option.
END

PARAMETER: Turbo HS Chart Display Option
  Parameter Type = String
  Allowed String List = Separate Lines, Difference, Ratio
  Default = Separate Lines
  Description = Turbo hub-to-shroud chart display option.
END

PARAMETER: Turbo HS Chart Compare Axis Option
  Parameter Type = String
  Allowed String List = X, Y
  Default = X
  Description = Turbo hub-to-shroud axis compare option.
END

# Rules for CFX Style variable name mapping

OBJECT: EXTERNAL NAMES MAP
  CCLObject Class = DataCCLObject
  Essential Parameter List = File Type
  Optional Child List = UNITS QUANTITY MAP, VARIABLE NAME MAP
  Allowed Parent List = ROOT
END

PARAMETER: File Type
  Allowed String List = CFX5, CFX4, TASCflow, CGNS, ANSYS, FLUENT, FieldView, FidapNeut, Forte, FENSAP
  Parameter Type = String
  Description = The type of the results file read for which this map \
                is created. 
END

OBJECT: UNITS QUANTITY MAP
  CCLObject Class = DataCCLObject
  Essential Parameter List = External Name, CFX Style Name
  Optional Parameter List = Variable Dimensions, Units Name
  Allowed Parent List = EXTERNAL NAMES MAP
END

OBJECT: VARIABLE NAME MAP
  CCLObject Class = DataCCLObject
  Essential Parameter List = External Name, CFX Style Name
  Allowed PARENT LIST = EXTERNAL NAMES MAP
END

PARAMETER: External Name
   Type = String
   Description = External name being used by the external application \
                 that wrote this file
END

PARAMETER: CFX Style Name
   Type = String
   Description = Equivalent CFX solver name 
END

PARAMETER: Units Name
  Type = String
  Description = Units name for variable quantity. This is just for \
                better readability and is not going to be used.
END

END
#
# end of rules
